/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.35.0-dev.20221002(61f8dee571efac71035000f4c57f1c42ada04e46)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/base/common/event","vs/base/common/errors","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/uri","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Z=function(k){for(var r=[],N=0,e=k.length;N<e;N++)r[N]=X[k[N]];return r},Ee=this,Me=typeof global=="object"?global:{},ie;(function(k){k.global=Ee;var r=function(){function N(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(N.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),N.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=N._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof k.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},N._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},N}();k.Environment=r})(ie||(ie={}));var ie;(function(k){var r=function(){function E(f,p,C){this.type=f,this.detail=p,this.timestamp=C}return E}();k.LoaderEvent=r;var N=function(){function E(f){this._events=[new r(1,"",f)]}return E.prototype.record=function(f,p){this._events.push(new r(f,p,k.Utilities.getHighPerformanceTimestamp()))},E.prototype.getEvents=function(){return this._events},E}();k.LoaderEventRecorder=N;var e=function(){function E(){}return E.prototype.record=function(f,p){},E.prototype.getEvents=function(){return[]},E.INSTANCE=new E,E}();k.NullLoaderEventRecorder=e})(ie||(ie={}));var ie;(function(k){var r=function(){function N(){}return N.fileUriToFilePath=function(e,E){if(E=decodeURI(E).replace(/%23/g,"#"),e){if(/^file:\/\/\//.test(E))return E.substr(8);if(/^file:\/\//.test(E))return E.substr(5)}else if(/^file:\/\//.test(E))return E.substr(7);return E},N.startsWith=function(e,E){return e.length>=E.length&&e.substr(0,E.length)===E},N.endsWith=function(e,E){return e.length>=E.length&&e.substr(e.length-E.length)===E},N.containsQueryString=function(e){return/^[^\#]*\?/gi.test(e)},N.isAbsolutePath=function(e){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(e)},N.forEachProperty=function(e,E){if(e){var f=void 0;for(f in e)e.hasOwnProperty(f)&&E(f,e[f])}},N.isEmpty=function(e){var E=!0;return N.forEachProperty(e,function(){E=!1}),E},N.recursiveClone=function(e){if(!e||typeof e!="object"||e instanceof RegExp||!Array.isArray(e)&&Object.getPrototypeOf(e)!==Object.prototype)return e;var E=Array.isArray(e)?[]:{};return N.forEachProperty(e,function(f,p){p&&typeof p=="object"?E[f]=N.recursiveClone(p):E[f]=p}),E},N.generateAnonymousModule=function(){return"===anonymous"+N.NEXT_ANONYMOUS_ID+++"==="},N.isAnonymousModule=function(e){return N.startsWith(e,"===anonymous")},N.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=k.global.performance&&typeof k.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?k.global.performance.now():Date.now()},N.NEXT_ANONYMOUS_ID=1,N.PERFORMANCE_NOW_PROBED=!1,N.HAS_PERFORMANCE_NOW=!1,N}();k.Utilities=r})(ie||(ie={}));var ie;(function(k){function r(E){if(E instanceof Error)return E;var f=new Error(E.message||String(E)||"Unknown Error");return E.stack&&(f.stack=E.stack),f}k.ensureError=r;var N=function(){function E(){}return E.validateConfigurationOptions=function(f){function p(l){if(l.phase==="loading"){console.error('Loading "'+l.moduleId+'" failed'),console.error(l),console.error("Here are the modules that depend on it:"),console.error(l.neededBy);return}if(l.phase==="factory"){console.error('The factory function of "'+l.moduleId+'" has thrown an exception'),console.error(l),console.error("Here are the modules that depend on it:"),console.error(l.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=p),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(k.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){var C=r(new Error("INVALID cached data configuration, 'path' MUST be set"));C.phase="configuration",f.onError(C),f.nodeCachedData=void 0}return f},E.mergeConfigurationOptions=function(f,p){f===void 0&&(f=null),p===void 0&&(p=null);var C=k.Utilities.recursiveClone(p||{});return k.Utilities.forEachProperty(f,function(l,d){l==="ignoreDuplicateModules"&&typeof C.ignoreDuplicateModules<"u"?C.ignoreDuplicateModules=C.ignoreDuplicateModules.concat(d):l==="paths"&&typeof C.paths<"u"?k.Utilities.forEachProperty(d,function(y,t){return C.paths[y]=t}):l==="config"&&typeof C.config<"u"?k.Utilities.forEachProperty(d,function(y,t){return C.config[y]=t}):C[l]=k.Utilities.recursiveClone(d)}),E.validateConfigurationOptions(C)},E}();k.ConfigurationOptionsUtil=N;var e=function(){function E(f,p){if(this._env=f,this.options=N.mergeConfigurationOptions(p),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var C=this.options.nodeRequire.main.filename,l=Math.max(C.lastIndexOf("/"),C.lastIndexOf("\\"));this.options.baseUrl=C.substring(0,l+1)}}return E.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0},E.prototype._createSortedPathsRules=function(){var f=this;this.sortedPathsRules=[],k.Utilities.forEachProperty(this.options.paths,function(p,C){Array.isArray(C)?f.sortedPathsRules.push({from:p,to:C}):f.sortedPathsRules.push({from:p,to:[C]})}),this.sortedPathsRules.sort(function(p,C){return C.from.length-p.from.length})},E.prototype.cloneAndMerge=function(f){return new E(this._env,N.mergeConfigurationOptions(f,this.options))},E.prototype.getOptionsLiteral=function(){return this.options},E.prototype._applyPaths=function(f){for(var p,C=0,l=this.sortedPathsRules.length;C<l;C++)if(p=this.sortedPathsRules[C],k.Utilities.startsWith(f,p.from)){for(var d=[],y=0,t=p.to.length;y<t;y++)d.push(p.to[y]+f.substr(p.from.length));return d}return[f]},E.prototype._addUrlArgsToUrl=function(f){return k.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs},E.prototype._addUrlArgsIfNecessaryToUrl=function(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f},E.prototype._addUrlArgsIfNecessaryToUrls=function(f){if(this.options.urlArgs)for(var p=0,C=f.length;p<C;p++)f[p]=this._addUrlArgsToUrl(f[p]);return f},E.prototype.moduleIdToPaths=function(f){if(this._env.isNode){var p=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f);if(p)return this.isBuild()?["empty:"]:["node|"+f]}var C=f,l;if(!k.Utilities.endsWith(C,".js")&&!k.Utilities.isAbsolutePath(C)){l=this._applyPaths(C);for(var d=0,y=l.length;d<y;d++)this.isBuild()&&l[d]==="empty:"||(k.Utilities.isAbsolutePath(l[d])||(l[d]=this.options.baseUrl+l[d]),!k.Utilities.endsWith(l[d],".js")&&!k.Utilities.containsQueryString(l[d])&&(l[d]=l[d]+".js"))}else!k.Utilities.endsWith(C,".js")&&!k.Utilities.containsQueryString(C)&&(C=C+".js"),l=[C];return this._addUrlArgsIfNecessaryToUrls(l)},E.prototype.requireToUrl=function(f){var p=f;return k.Utilities.isAbsolutePath(p)||(p=this._applyPaths(p)[0],k.Utilities.isAbsolutePath(p)||(p=this.options.baseUrl+p)),this._addUrlArgsIfNecessaryToUrl(p)},E.prototype.isBuild=function(){return this.options.isBuild},E.prototype.shouldInvokeFactory=function(f){return!!(!this.options.isBuild||k.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])},E.prototype.isDuplicateMessageIgnoredFor=function(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)},E.prototype.getConfigForModule=function(f){if(this.options.config)return this.options.config[f]},E.prototype.shouldCatchError=function(){return this.options.catchError},E.prototype.shouldRecordStats=function(){return this.options.recordStats},E.prototype.onError=function(f){this.options.onError(f)},E}();k.Configuration=e})(ie||(ie={}));var ie;(function(k){var r=function(){function l(d){this._env=d,this._scriptLoader=null,this._callbackMap={}}return l.prototype.load=function(d,y,t,v){var u=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new E;else if(this._env.isElectronRenderer){var m=d.getConfig().getOptionsLiteral().preferScriptTags;m?this._scriptLoader=new N:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new N;var w={callback:t,errorback:v};if(this._callbackMap.hasOwnProperty(y)){this._callbackMap[y].push(w);return}this._callbackMap[y]=[w],this._scriptLoader.load(d,y,function(){return u.triggerCallback(y)},function(L){return u.triggerErrorback(y,L)})},l.prototype.triggerCallback=function(d){var y=this._callbackMap[d];delete this._callbackMap[d];for(var t=0;t<y.length;t++)y[t].callback()},l.prototype.triggerErrorback=function(d,y){var t=this._callbackMap[d];delete this._callbackMap[d];for(var v=0;v<t.length;v++)t[v].errorback(y)},l}(),N=function(){function l(){}return l.prototype.attachListeners=function(d,y,t){var v=function(){d.removeEventListener("load",u),d.removeEventListener("error",m)},u=function(w){v(),y()},m=function(w){v(),t(w)};d.addEventListener("load",u),d.addEventListener("error",m)},l.prototype.load=function(d,y,t,v){if(/^node\|/.test(y)){var u=d.getConfig().getOptionsLiteral(),m=p(d.getRecorder(),u.nodeRequire||k.global.nodeRequire),w=y.split("|"),L=null;try{L=m(w[1])}catch(i){v(i);return}d.enqueueDefineAnonymousModule([],function(){return L}),t()}else{var S=document.createElement("script");S.setAttribute("async","async"),S.setAttribute("type","text/javascript"),this.attachListeners(S,t,v);var b=d.getConfig().getOptionsLiteral().trustedTypesPolicy;b&&(y=b.createScriptURL(y)),S.setAttribute("src",y);var s=d.getConfig().getOptionsLiteral().cspNonce;s&&S.setAttribute("nonce",s),document.getElementsByTagName("head")[0].appendChild(S)}},l}();function e(l){var d=l.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var y=d?self.eval(d.createScript("","true")):new Function("true");return y.call(self),!0}catch{return!1}}var E=function(){function l(){this._cachedCanUseEval=null}return l.prototype._canUseEval=function(d){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=e(d)),this._cachedCanUseEval},l.prototype.load=function(d,y,t,v){if(/^node\|/.test(y)){var u=d.getConfig().getOptionsLiteral(),m=p(d.getRecorder(),u.nodeRequire||k.global.nodeRequire),w=y.split("|"),L=null;try{L=m(w[1])}catch(s){v(s);return}d.enqueueDefineAnonymousModule([],function(){return L}),t()}else{var S=d.getConfig().getOptionsLiteral().trustedTypesPolicy,b=/^((http:)|(https:)|(file:))/.test(y)&&y.substring(0,self.origin.length)!==self.origin;if(!b&&this._canUseEval(d)){fetch(y).then(function(s){if(s.status!==200)throw new Error(s.statusText);return s.text()}).then(function(s){s=s+`
//# sourceURL=`+y;var i=S?self.eval(S.createScript("",s)):new Function(s);i.call(self),t()}).then(void 0,v);return}try{S&&(y=S.createScriptURL(y)),importScripts(y),t()}catch(s){v(s)}}},l}(),f=function(){function l(d){this._env=d,this._didInitialize=!1,this._didPatchNodeRequire=!1}return l.prototype._init=function(d){this._didInitialize||(this._didInitialize=!0,this._fs=d("fs"),this._vm=d("vm"),this._path=d("path"),this._crypto=d("crypto"))},l.prototype._initNodeRequire=function(d,y){var t=y.getConfig().getOptionsLiteral().nodeCachedData;if(!t||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var v=this,u=d("module");function m(w){var L=w.constructor,S=function(s){try{return w.require(s)}finally{}};return S.resolve=function(s,i){return L._resolveFilename(s,w,!1,i)},S.resolve.paths=function(s){return L._resolveLookupPaths(s,w)},S.main=process.mainModule,S.extensions=L._extensions,S.cache=L._cache,S}u.prototype._compile=function(w,L){var S=u.wrap(w.replace(/^#!.*/,"")),b=y.getRecorder(),s=v._getCachedDataPath(t,L),i={filename:L},o;try{var _=v._fs.readFileSync(s);o=_.slice(0,16),i.cachedData=_.slice(16),b.record(60,s)}catch{b.record(61,s)}var c=new v._vm.Script(S,i),a=c.runInThisContext(i),h=v._path.dirname(L),g=m(this),A=[this.exports,g,this,L,h,process,Me,Buffer],M=a.apply(this.exports,A);return v._handleCachedData(c,S,s,!i.cachedData,y),v._verifyCachedData(c,S,s,o,y),M}},l.prototype.load=function(d,y,t,v){var u=this,m=d.getConfig().getOptionsLiteral(),w=p(d.getRecorder(),m.nodeRequire||k.global.nodeRequire),L=m.nodeInstrumenter||function(a){return a};this._init(w),this._initNodeRequire(w,d);var S=d.getRecorder();if(/^node\|/.test(y)){var b=y.split("|"),s=null;try{s=w(b[1])}catch(a){v(a);return}d.enqueueDefineAnonymousModule([],function(){return s}),t()}else{y=k.Utilities.fileUriToFilePath(this._env.isWindows,y);var i=this._path.normalize(y),o=this._getElectronRendererScriptPathOrUri(i),_=Boolean(m.nodeCachedData),c=_?this._getCachedDataPath(m.nodeCachedData,y):void 0;this._readSourceAndCachedData(i,c,S,function(a,h,g,A){if(a){v(a);return}var M;h.charCodeAt(0)===l._BOM?M=l._PREFIX+h.substring(1)+l._SUFFIX:M=l._PREFIX+h+l._SUFFIX,M=L(M,i);var D={filename:o,cachedData:g},P=u._createAndEvalScript(d,M,D,t,v);u._handleCachedData(P,M,c,_&&!g,d),u._verifyCachedData(P,M,c,A,d)})}},l.prototype._createAndEvalScript=function(d,y,t,v,u){var m=d.getRecorder();m.record(31,t.filename);var w=new this._vm.Script(y,t),L=w.runInThisContext(t),S=d.getGlobalAMDDefineFunc(),b=!1,s=function(){return b=!0,S.apply(null,arguments)};return s.amd=S.amd,L.call(k.global,d.getGlobalAMDRequireFunc(),s,t.filename,this._path.dirname(t.filename)),m.record(32,t.filename),b?v():u(new Error("Didn't receive define call in "+t.filename+"!")),w},l.prototype._getElectronRendererScriptPathOrUri=function(d){if(!this._env.isElectronRenderer)return d;var y=d.match(/^([a-z])\:(.*)/i);return y?"file:///"+(y[1].toUpperCase()+":"+y[2]).replace(/\\/g,"/"):"file://"+d},l.prototype._getCachedDataPath=function(d,y){var t=this._crypto.createHash("md5").update(y,"utf8").update(d.seed,"utf8").update(process.arch,"").digest("hex"),v=this._path.basename(y).replace(/\.js$/,"");return this._path.join(d.path,v+"-"+t+".code")},l.prototype._handleCachedData=function(d,y,t,v,u){var m=this;d.cachedDataRejected?this._fs.unlink(t,function(w){u.getRecorder().record(62,t),m._createAndWriteCachedData(d,y,t,u),w&&u.getConfig().onError(w)}):v&&this._createAndWriteCachedData(d,y,t,u)},l.prototype._createAndWriteCachedData=function(d,y,t,v){var u=this,m=Math.ceil(v.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),w=-1,L=0,S=void 0,b=function(){setTimeout(function(){S||(S=u._crypto.createHash("md5").update(y,"utf8").digest());var s=d.createCachedData();if(!(s.length===0||s.length===w||L>=5)){if(s.length<w){b();return}w=s.length,u._fs.writeFile(t,Buffer.concat([S,s]),function(i){i&&v.getConfig().onError(i),v.getRecorder().record(63,t),b()})}},m*Math.pow(4,L++))};b()},l.prototype._readSourceAndCachedData=function(d,y,t,v){if(!y)this._fs.readFile(d,{encoding:"utf8"},v);else{var u=void 0,m=void 0,w=void 0,L=2,S=function(b){b?v(b):--L===0&&v(void 0,u,m,w)};this._fs.readFile(d,{encoding:"utf8"},function(b,s){u=s,S(b)}),this._fs.readFile(y,function(b,s){!b&&s&&s.length>0?(w=s.slice(0,16),m=s.slice(16),t.record(60,y)):t.record(61,y),S()})}},l.prototype._verifyCachedData=function(d,y,t,v,u){var m=this;!v||d.cachedDataRejected||setTimeout(function(){var w=m._crypto.createHash("md5").update(y,"utf8").digest();v.equals(w)||(u.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+t+"' now, but a RESTART IS REQUIRED")),m._fs.unlink(t,function(L){L&&u.getConfig().onError(L)}))},Math.ceil(5e3*(1+Math.random())))},l._BOM=65279,l._PREFIX="(function (require, define, __filename, __dirname) { ",l._SUFFIX=`
});`,l}();function p(l,d){if(d.__$__isRecorded)return d;var y=function(v){l.record(33,v);try{return d(v)}finally{l.record(34,v)}};return y.__$__isRecorded=!0,y}k.ensureRecordedNodeRequire=p;function C(l){return new r(l)}k.createScriptLoader=C})(ie||(ie={}));var ie;(function(k){var r=function(){function C(l){var d=l.lastIndexOf("/");d!==-1?this.fromModulePath=l.substr(0,d+1):this.fromModulePath=""}return C._normalizeModuleId=function(l){var d=l,y;for(y=/\/\.\//;y.test(d);)d=d.replace(y,"/");for(d=d.replace(/^\.\//g,""),y=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;y.test(d);)d=d.replace(y,"/");return d=d.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),d},C.prototype.resolveModule=function(l){var d=l;return k.Utilities.isAbsolutePath(d)||(k.Utilities.startsWith(d,"./")||k.Utilities.startsWith(d,"../"))&&(d=C._normalizeModuleId(this.fromModulePath+d)),d},C.ROOT=new C(""),C}();k.ModuleIdResolver=r;var N=function(){function C(l,d,y,t,v,u){this.id=l,this.strId=d,this.dependencies=y,this._callback=t,this._errorback=v,this.moduleIdResolver=u,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return C._safeInvokeFunction=function(l,d){try{return{returnedValue:l.apply(k.global,d),producedError:null}}catch(y){return{returnedValue:null,producedError:y}}},C._invokeFactory=function(l,d,y,t){return l.shouldInvokeFactory(d)?l.shouldCatchError()?this._safeInvokeFunction(y,t):{returnedValue:y.apply(k.global,t),producedError:null}:{returnedValue:null,producedError:null}},C.prototype.complete=function(l,d,y,t){this._isComplete=!0;var v=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);var u=C._invokeFactory(d,this.strId,this._callback,y);v=u.producedError,l.record(22,this.strId),!v&&typeof u.returnedValue<"u"&&(!this.exportsPassedIn||k.Utilities.isEmpty(this.exports))&&(this.exports=u.returnedValue)}else this.exports=this._callback;if(v){var m=k.ensureError(v);m.phase="factory",m.moduleId=this.strId,m.neededBy=t(this.id),this.error=m,d.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},C.prototype.onDependencyError=function(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1},C.prototype.isComplete=function(){return this._isComplete},C}();k.Module=N;var e=function(){function C(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return C.prototype.getMaxModuleId=function(){return this._nextId},C.prototype.getModuleId=function(l){var d=this._strModuleIdToIntModuleId.get(l);return typeof d>"u"&&(d=this._nextId++,this._strModuleIdToIntModuleId.set(l,d),this._intModuleIdToStrModuleId[d]=l),d},C.prototype.getStrModuleId=function(l){return this._intModuleIdToStrModuleId[l]},C}(),E=function(){function C(l){this.id=l}return C.EXPORTS=new C(0),C.MODULE=new C(1),C.REQUIRE=new C(2),C}();k.RegularDependency=E;var f=function(){function C(l,d,y){this.id=l,this.pluginId=d,this.pluginParam=y}return C}();k.PluginDependency=f;var p=function(){function C(l,d,y,t,v){v===void 0&&(v=0),this._env=l,this._scriptLoader=d,this._loaderAvailableTimestamp=v,this._defineFunc=y,this._requireFunc=t,this._moduleIdProvider=new e,this._config=new k.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return C.prototype.reset=function(){return new C(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},C.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},C.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},C._findRelevantLocationInStack=function(l,d){for(var y=function(i){return i.replace(/\\/g,"/")},t=y(l),v=d.split(/\n/),u=0;u<v.length;u++){var m=v[u].match(/(.*):(\d+):(\d+)\)?$/);if(m){var w=m[1],L=m[2],S=m[3],b=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(b),w=y(w),w===t){var s={line:parseInt(L,10),col:parseInt(S,10)};return s.line===1&&(s.col-=53),s}}}throw new Error("Could not correlate define call site for needle "+l)},C.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var l=[],d=0,y=0,t=this._modules2.length;y<t;y++){var v=this._modules2[y];if(!!v){var u=this._buildInfoPath[v.id]||null,m=this._buildInfoDefineStack[v.id]||null,w=this._buildInfoDependencies[v.id];l[d++]={id:v.strId,path:u,defineLocation:u&&m?C._findRelevantLocationInStack(u,m):null,dependencies:w,shim:null,exports:v.exports}}}return l},C.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new k.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=k.NullLoaderEventRecorder.INSTANCE),this._recorder},C.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},C.prototype.enqueueDefineAnonymousModule=function(l,d){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var y=null;this._config.isBuild()&&(y=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:y,dependencies:l,callback:d}},C.prototype.defineModule=function(l,d,y,t,v,u){var m=this;u===void 0&&(u=new r(l));var w=this._moduleIdProvider.getModuleId(l);if(this._modules2[w]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}var L=new N(w,l,this._normalizeDependencies(d,u),y,t,u);this._modules2[w]=L,this._config.isBuild()&&(this._buildInfoDefineStack[w]=v,this._buildInfoDependencies[w]=(L.dependencies||[]).map(function(S){return m._moduleIdProvider.getStrModuleId(S.id)})),this._resolve(L)},C.prototype._normalizeDependency=function(l,d){if(l==="exports")return E.EXPORTS;if(l==="module")return E.MODULE;if(l==="require")return E.REQUIRE;var y=l.indexOf("!");if(y>=0){var t=d.resolveModule(l.substr(0,y)),v=d.resolveModule(l.substr(y+1)),u=this._moduleIdProvider.getModuleId(t+"!"+v),m=this._moduleIdProvider.getModuleId(t);return new f(u,m,v)}return new E(this._moduleIdProvider.getModuleId(d.resolveModule(l)))},C.prototype._normalizeDependencies=function(l,d){for(var y=[],t=0,v=0,u=l.length;v<u;v++)y[t++]=this._normalizeDependency(l[v],d);return y},C.prototype._relativeRequire=function(l,d,y,t){if(typeof d=="string")return this.synchronousRequire(d,l);this.defineModule(k.Utilities.generateAnonymousModule(),d,y,t,null,l)},C.prototype.synchronousRequire=function(l,d){d===void 0&&(d=new r(l));var y=this._normalizeDependency(l,d),t=this._modules2[y.id];if(!t)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!t.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(t.error)throw t.error;return t.exports},C.prototype.configure=function(l,d){var y=this._config.shouldRecordStats();d?this._config=new k.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!y&&(this._recorder=null)},C.prototype.getConfig=function(){return this._config},C.prototype._onLoad=function(l){if(this._currentAnonymousDefineCall!==null){var d=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),d.dependencies,d.callback,null,d.stack)}},C.prototype._createLoadError=function(l,d){var y=this,t=this._moduleIdProvider.getStrModuleId(l),v=(this._inverseDependencies2[l]||[]).map(function(m){return y._moduleIdProvider.getStrModuleId(m)}),u=k.ensureError(d);return u.phase="loading",u.moduleId=t,u.neededBy=v,u},C.prototype._onLoadError=function(l,d){var y=this._createLoadError(l,d);this._modules2[l]||(this._modules2[l]=new N(l,this._moduleIdProvider.getStrModuleId(l),[],function(){},null,null));for(var t=[],v=0,u=this._moduleIdProvider.getMaxModuleId();v<u;v++)t[v]=!1;var m=!1,w=[];for(w.push(l),t[l]=!0;w.length>0;){var L=w.shift(),S=this._modules2[L];S&&(m=S.onDependencyError(y)||m);var b=this._inverseDependencies2[L];if(b)for(var v=0,u=b.length;v<u;v++){var s=b[v];t[s]||(w.push(s),t[s]=!0)}}m||this._config.onError(y)},C.prototype._hasDependencyPath=function(l,d){var y=this._modules2[l];if(!y)return!1;for(var t=[],v=0,u=this._moduleIdProvider.getMaxModuleId();v<u;v++)t[v]=!1;var m=[];for(m.push(y),t[l]=!0;m.length>0;){var w=m.shift(),L=w.dependencies;if(L)for(var v=0,u=L.length;v<u;v++){var S=L[v];if(S.id===d)return!0;var b=this._modules2[S.id];b&&!t[S.id]&&(t[S.id]=!0,m.push(b))}}return!1},C.prototype._findCyclePath=function(l,d,y){if(l===d||y===50)return[l];var t=this._modules2[l];if(!t)return null;var v=t.dependencies;if(v)for(var u=0,m=v.length;u<m;u++){var w=this._findCyclePath(v[u].id,d,y+1);if(w!==null)return w.push(l),w}return null},C.prototype._createRequire=function(l){var d=this,y=function(t,v,u){return d._relativeRequire(l,t,v,u)};return y.toUrl=function(t){return d._config.requireToUrl(l.resolveModule(t))},y.getStats=function(){return d.getLoaderEvents()},y.hasDependencyCycle=function(){return d._hasDependencyCycle},y.config=function(t,v){v===void 0&&(v=!1),d.configure(t,v)},y.__$__nodeRequire=k.global.nodeRequire,y},C.prototype._loadModule=function(l){var d=this;if(!(this._modules2[l]||this._knownModules2[l])){this._knownModules2[l]=!0;var y=this._moduleIdProvider.getStrModuleId(l),t=this._config.moduleIdToPaths(y),v=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(y.indexOf("/")===-1||v.test(y))&&t.push("node|"+y);var u=-1,m=function(w){if(u++,u>=t.length)d._onLoadError(l,w);else{var L=t[u],S=d.getRecorder();if(d._config.isBuild()&&L==="empty:"){d._buildInfoPath[l]=L,d.defineModule(d._moduleIdProvider.getStrModuleId(l),[],null,null,null),d._onLoad(l);return}S.record(10,L),d._scriptLoader.load(d,L,function(){d._config.isBuild()&&(d._buildInfoPath[l]=L),S.record(11,L),d._onLoad(l)},function(b){S.record(12,L),m(b)})}};m(null)}},C.prototype._loadPluginDependency=function(l,d){var y=this;if(!(this._modules2[d.id]||this._knownModules2[d.id])){this._knownModules2[d.id]=!0;var t=function(v){y.defineModule(y._moduleIdProvider.getStrModuleId(d.id),[],v,null,null)};t.error=function(v){y._config.onError(y._createLoadError(d.id,v))},l.load(d.pluginParam,this._createRequire(r.ROOT),t,this._config.getOptionsLiteral())}},C.prototype._resolve=function(l){var d=this,y=l.dependencies;if(y)for(var t=0,v=y.length;t<v;t++){var u=y[t];if(u===E.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(u===E.MODULE){l.unresolvedDependenciesCount--;continue}if(u===E.REQUIRE){l.unresolvedDependenciesCount--;continue}var m=this._modules2[u.id];if(m&&m.isComplete()){if(m.error){l.onDependencyError(m.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(u.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(u.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");var w=this._findCyclePath(u.id,l.id,0)||[];w.reverse(),w.push(u.id),console.warn(w.map(function(b){return d._moduleIdProvider.getStrModuleId(b)}).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[u.id]=this._inverseDependencies2[u.id]||[],this._inverseDependencies2[u.id].push(l.id),u instanceof f){var L=this._modules2[u.pluginId];if(L&&L.isComplete()){this._loadPluginDependency(L.exports,u);continue}var S=this._inversePluginDependencies2.get(u.pluginId);S||(S=[],this._inversePluginDependencies2.set(u.pluginId,S)),S.push(u),this._loadModule(u.pluginId);continue}this._loadModule(u.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)},C.prototype._onModuleComplete=function(l){var d=this,y=this.getRecorder();if(!l.isComplete()){var t=l.dependencies,v=[];if(t)for(var u=0,m=t.length;u<m;u++){var w=t[u];if(w===E.EXPORTS){v[u]=l.exports;continue}if(w===E.MODULE){v[u]={id:l.strId,config:function(){return d._config.getConfigForModule(l.strId)}};continue}if(w===E.REQUIRE){v[u]=this._createRequire(l.moduleIdResolver);continue}var L=this._modules2[w.id];if(L){v[u]=L.exports;continue}v[u]=null}var S=function(_){return(d._inverseDependencies2[_]||[]).map(function(c){return d._moduleIdProvider.getStrModuleId(c)})};l.complete(y,this._config,v,S);var b=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,b)for(var u=0,m=b.length;u<m;u++){var s=b[u],i=this._modules2[s];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var o=this._inversePluginDependencies2.get(l.id);if(o){this._inversePluginDependencies2.delete(l.id);for(var u=0,m=o.length;u<m;u++)this._loadPluginDependency(l.exports,o[u])}}},C}();k.ModuleManager=p})(ie||(ie={}));var Y,ie;(function(k){var r=new k.Environment,N=null,e=function(C,l,d){typeof C!="string"&&(d=l,l=C,C=null),(typeof l!="object"||!Array.isArray(l))&&(d=l,l=null),l||(l=["require","exports","module"]),C?N.defineModule(C,l,d,null,null):N.enqueueDefineAnonymousModule(l,d)};e.amd={jQuery:!0};var E=function(C,l){l===void 0&&(l=!1),N.configure(C,l)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){E(arguments[0]);return}if(typeof arguments[0]=="string")return N.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){N.defineModule(k.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=E,f.getConfig=function(){return N.getConfig().getOptionsLiteral()},f.reset=function(){N=N.reset()},f.getBuildInfo=function(){return N.getBuildInfo()},f.getStats=function(){return N.getLoaderEvents()},f.define=e;function p(){if(typeof k.global.require<"u"||typeof require<"u"){var C=k.global.require||require;if(typeof C=="function"&&typeof C.resolve=="function"){var l=k.ensureRecordedNodeRequire(N.getRecorder(),C);k.global.nodeRequire=l,f.nodeRequire=l,f.__$__nodeRequire=l}}r.isNode&&!r.isElectronRenderer&&!r.isElectronNodeIntegrationWebWorker?module.exports=f:(r.isElectronRenderer||(k.global.define=e),k.global.require=f)}k.init=p,(typeof k.global.define!="function"||!k.global.define.amd)&&(N=new k.ModuleManager(r,k.createScriptLoader(r),e,f,k.Utilities.getHighPerformanceTimestamp()),typeof k.global.require<"u"&&typeof k.global.require!="function"&&f.config(k.global.require),Y=function(){return e.apply(null,arguments)},Y.amd=e.amd,typeof doNotInitLoader>"u"&&p())})(ie||(ie={}));var le=this&&this.__awaiter||function(k,r,N,e){function E(f){return f instanceof N?f:new N(function(p){p(f)})}return new(N||(N=Promise))(function(f,p){function C(y){try{d(e.next(y))}catch(t){p(t)}}function l(y){try{d(e.throw(y))}catch(t){p(t)}}function d(y){y.done?f(y.value):E(y.value).then(C,l)}d((e=e.apply(k,r||[])).next())})};Y(X[21],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.load=r.create=r.setPseudoTranslation=r.getConfiguredDefaultLocale=r.localize=void 0;let N=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const e="i-default";function E(m,w){let L;return w.length===0?L=m:L=m.replace(/\{(\d+)\}/g,(S,b)=>{const s=b[0],i=w[s];let o=S;return typeof i=="string"?o=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(o=String(i)),o}),N&&(L="\uFF3B"+L.replace(/[aouei]/g,"$&$&")+"\uFF3D"),L}function f(m,w){let L=m[w];return L||(L=m["*"],L)?L:null}function p(m){return m.charAt(m.length-1)==="/"?m:m+"/"}function C(m,w,L){return le(this,void 0,void 0,function*(){const S=p(m)+p(w)+"vscode/"+p(L),b=yield fetch(S);if(b.ok)return yield b.json();throw new Error(`${b.status} - ${b.statusText}`)})}function l(m){return function(w,L){const S=Array.prototype.slice.call(arguments,2);return E(m[w],S)}}function d(m,w,...L){return E(w,L)}r.localize=d;function y(m){}r.getConfiguredDefaultLocale=y;function t(m){N=m}r.setPseudoTranslation=t;function v(m,w){var L;return{localize:l(w[m]),getConfiguredDefaultLocale:(L=w.getConfiguredDefaultLocale)!==null&&L!==void 0?L:S=>{}}}r.create=v;function u(m,w,L,S){var b;const s=(b=S["vs/nls"])!==null&&b!==void 0?b:{};if(!m||m.length===0)return L({localize:d,getConfiguredDefaultLocale:()=>{var a;return(a=s.availableLanguages)===null||a===void 0?void 0:a["*"]}});const i=s.availableLanguages?f(s.availableLanguages,m):null,o=i===null||i===e;let _=".nls";o||(_=_+"."+i);const c=a=>{Array.isArray(a)?a.localize=l(a):a.localize=l(a[m]),a.getConfiguredDefaultLocale=()=>{var h;return(h=s.availableLanguages)===null||h===void 0?void 0:h["*"]},L(a)};typeof s.loadBundle=="function"?s.loadBundle(m,i,(a,h)=>{a?w([m+".nls"],c):c(h)}):s.translationServiceUrl&&!o?le(this,void 0,void 0,function*(){var a;try{const h=yield C(s.translationServiceUrl,i,m);return c(h)}catch(h){if(!i.includes("-"))return console.error(h),w([m+".nls"],c);try{const g=i.split("-")[0],A=yield C(s.translationServiceUrl,g,m);return(a=s.availableLanguages)!==null&&a!==void 0||(s.availableLanguages={}),s.availableLanguages["*"]=g,c(A)}catch(g){return console.error(g),w([m+".nls"],c)}}}):w([m+_],c,a=>{if(_===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${i}. Falling back to the default language:`,a),w([m+".nls"],c)})}r.load=u}),function(){var k,r;const N=self.MonacoEnvironment,e=N&&N.baseUrl?N.baseUrl:"../../../",E=typeof((k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy)=="function"?(r=self.trustedTypes)===null||r===void 0?void 0:r.createPolicy("amdLoader",{createScriptURL:t=>t,createScript:(t,...v)=>{const u=v.slice(0,-1).join(","),m=v.pop().toString();return`(function anonymous(${u}) { ${m}
})`}}):void 0;function f(){try{return(E?self.eval(E.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function p(){return new Promise((t,v)=>{if(typeof self.define=="function"&&self.define.amd)return t();const u=e+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(u)&&u.substring(0,self.origin.length)!==self.origin)&&f()){fetch(u).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${u}`,(E?self.eval(E.createScript("",w)):new Function(w)).call(self),t()}).then(void 0,v);return}E?importScripts(E.createScriptURL(u)):importScripts(u),t()})}function C(){require.config({baseUrl:e,catchError:!0,trustedTypesPolicy:E,amdModulesPattern:/^vs\//})}function l(t){p().then(()=>{C(),require([t],function(v){setTimeout(function(){const u=v.create((m,w)=>{self.postMessage(m,w)},null);for(self.onmessage=m=>u.onmessage(m.data,m.ports);y.length>0;)self.onmessage(y.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&C();let d=!0;const y=[];self.onmessage=t=>{if(!d){y.push(t);return}d=!1,l(t.data)}}(),Y(X[22],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CallbackIterable=r.ArrayQueue=r.findMinBy=r.findLastMaxBy=r.findMaxBy=r.numberComparator=r.compareBy=r.CompareResult=r.splice=r.insertInto=r.asArray=r.pushMany=r.pushToEnd=r.pushToStart=r.arrayInsert=r.range=r.firstOrDefault=r.lastIndex=r.findLast=r.distinct=r.isNonEmptyArray=r.isFalsyOrEmpty=r.coalesce=r.groupBy=r.quickSelect=r.findFirstInSorted=r.binarySearch2=r.binarySearch=r.removeFastWithoutKeepingOrder=r.equals=r.tail2=r.tail=void 0;function N(F,U=0){return F[F.length-(1+U)]}r.tail=N;function e(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}r.tail2=e;function E(F,U,T=(O,j)=>O===j){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let O=0,j=F.length;O<j;O++)if(!T(F[O],U[O]))return!1;return!0}r.equals=E;function f(F,U){const T=F.length-1;U<T&&(F[U]=F[T]),F.pop()}r.removeFastWithoutKeepingOrder=f;function p(F,U,T){return C(F.length,O=>T(F[O],U))}r.binarySearch=p;function C(F,U){let T=0,O=F-1;for(;T<=O;){const j=(T+O)/2|0,n=U(j);if(n<0)T=j+1;else if(n>0)O=j-1;else return j}return-(T+1)}r.binarySearch2=C;function l(F,U){let T=0,O=F.length;if(O===0)return 0;for(;T<O;){const j=Math.floor((T+O)/2);U(F[j])?O=j:T=j+1}return T}r.findFirstInSorted=l;function d(F,U,T){if(F=F|0,F>=U.length)throw new TypeError("invalid index");const O=U[Math.floor(U.length*Math.random())],j=[],n=[],se=[];for(const ge of U){const me=T(ge,O);me<0?j.push(ge):me>0?n.push(ge):se.push(ge)}return F<j.length?d(F,j,T):F<j.length+se.length?se[0]:d(F-(j.length+se.length),n,T)}r.quickSelect=d;function y(F,U){const T=[];let O;for(const j of F.slice(0).sort(U))!O||U(O[0],j)!==0?(O=[j],T.push(O)):O.push(j);return T}r.groupBy=y;function t(F){return F.filter(U=>!!U)}r.coalesce=t;function v(F){return!Array.isArray(F)||F.length===0}r.isFalsyOrEmpty=v;function u(F){return Array.isArray(F)&&F.length>0}r.isNonEmptyArray=u;function m(F,U=T=>T){const T=new Set;return F.filter(O=>{const j=U(O);return T.has(j)?!1:(T.add(j),!0)})}r.distinct=m;function w(F,U){const T=L(F,U);if(T!==-1)return F[T]}r.findLast=w;function L(F,U){for(let T=F.length-1;T>=0;T--){const O=F[T];if(U(O))return T}return-1}r.lastIndex=L;function S(F,U){return F.length>0?F[0]:U}r.firstOrDefault=S;function b(F,U){let T=typeof U=="number"?F:0;typeof U=="number"?T=F:(T=0,U=F);const O=[];if(T<=U)for(let j=T;j<U;j++)O.push(j);else for(let j=T;j>U;j--)O.push(j);return O}r.range=b;function s(F,U,T){const O=F.slice(0,U),j=F.slice(U);return O.concat(T,j)}r.arrayInsert=s;function i(F,U){const T=F.indexOf(U);T>-1&&(F.splice(T,1),F.unshift(U))}r.pushToStart=i;function o(F,U){const T=F.indexOf(U);T>-1&&(F.splice(T,1),F.push(U))}r.pushToEnd=o;function _(F,U){for(const T of U)F.push(T)}r.pushMany=_;function c(F){return Array.isArray(F)?F:[F]}r.asArray=c;function a(F,U,T){const O=g(F,U),j=F.length,n=T.length;F.length=j+n;for(let se=j-1;se>=O;se--)F[se+n]=F[se];for(let se=0;se<n;se++)F[se+O]=T[se]}r.insertInto=a;function h(F,U,T,O){const j=g(F,U),n=F.splice(j,T);return a(F,j,O),n}r.splice=h;function g(F,U){return U<0?Math.max(U+F.length,0):Math.min(U,F.length)}var A;(function(F){function U(j){return j<0}F.isLessThan=U;function T(j){return j>0}F.isGreaterThan=T;function O(j){return j===0}F.isNeitherLessOrGreaterThan=O,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(A=r.CompareResult||(r.CompareResult={}));function M(F,U){return(T,O)=>U(F(T),F(O))}r.compareBy=M;const D=(F,U)=>F-U;r.numberComparator=D;function P(F,U){if(F.length===0)return;let T=F[0];for(let O=1;O<F.length;O++){const j=F[O];U(j,T)>0&&(T=j)}return T}r.findMaxBy=P;function B(F,U){if(F.length===0)return;let T=F[0];for(let O=1;O<F.length;O++){const j=F[O];U(j,T)>=0&&(T=j)}return T}r.findLastMaxBy=B;function q(F,U){return P(F,(T,O)=>-U(T,O))}r.findMinBy=q;class H{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let T=this.firstIdx;for(;T<this.items.length&&U(this.items[T]);)T++;const O=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,O}takeFromEndWhile(U){let T=this.lastIdx;for(;T>=0&&U(this.items[T]);)T--;const O=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,O}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const U=this.items[this.firstIdx];return this.firstIdx++,U}takeCount(U){const T=this.items.slice(this.firstIdx,this.firstIdx+U);return this.firstIdx+=U,T}}r.ArrayQueue=H;class W{constructor(U){this.iterate=U}toArray(){const U=[];return this.iterate(T=>(U.push(T),!0)),U}filter(U){return new W(T=>this.iterate(O=>U(O)?T(O):!0))}map(U){return new W(T=>this.iterate(O=>T(U(O))))}findLast(U){let T;return this.iterate(O=>(U(O)&&(T=O),!0)),T}findLastMaxBy(U){let T,O=!0;return this.iterate(j=>((O||A.isGreaterThan(U(j,T)))&&(O=!1,T=j),!0)),T}}r.CallbackIterable=W,W.empty=new W(F=>{})}),Y(X[23],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CachedFunction=r.LRUCachedFunction=void 0;class N{constructor(f){this.fn=f,this.lastCache=void 0,this.lastArgKey=void 0}get(f){const p=JSON.stringify(f);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(f)),this.lastCache}}r.LRUCachedFunction=N;class e{get cachedValues(){return this._map}constructor(f){this.fn=f,this._map=new Map}get(f){if(this._map.has(f))return this._map.get(f);const p=this.fn(f);return this._map.set(f,p),p}}r.CachedFunction=e}),Y(X[24],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CSSIcon=r.Codicon=r.getCodiconAriaLabel=void 0;function N(f){return f?f.replace(/\$\((.*?)\)/g,(p,C)=>` ${C} `).trim():""}r.getCodiconAriaLabel=N;class e{constructor(p,C,l){this.id=p,this.definition=C,this.description=l,e._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return e._allCodicons}}r.Codicon=e,e._allCodicons=[],e.add=new e("add",{fontCharacter:"\\ea60"}),e.plus=new e("plus",e.add.definition),e.gistNew=new e("gist-new",e.add.definition),e.repoCreate=new e("repo-create",e.add.definition),e.lightbulb=new e("lightbulb",{fontCharacter:"\\ea61"}),e.lightBulb=new e("light-bulb",{fontCharacter:"\\ea61"}),e.repo=new e("repo",{fontCharacter:"\\ea62"}),e.repoDelete=new e("repo-delete",{fontCharacter:"\\ea62"}),e.gistFork=new e("gist-fork",{fontCharacter:"\\ea63"}),e.repoForked=new e("repo-forked",{fontCharacter:"\\ea63"}),e.gitPullRequest=new e("git-pull-request",{fontCharacter:"\\ea64"}),e.gitPullRequestAbandoned=new e("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),e.recordKeys=new e("record-keys",{fontCharacter:"\\ea65"}),e.keyboard=new e("keyboard",{fontCharacter:"\\ea65"}),e.tag=new e("tag",{fontCharacter:"\\ea66"}),e.tagAdd=new e("tag-add",{fontCharacter:"\\ea66"}),e.tagRemove=new e("tag-remove",{fontCharacter:"\\ea66"}),e.person=new e("person",{fontCharacter:"\\ea67"}),e.personFollow=new e("person-follow",{fontCharacter:"\\ea67"}),e.personOutline=new e("person-outline",{fontCharacter:"\\ea67"}),e.personFilled=new e("person-filled",{fontCharacter:"\\ea67"}),e.gitBranch=new e("git-branch",{fontCharacter:"\\ea68"}),e.gitBranchCreate=new e("git-branch-create",{fontCharacter:"\\ea68"}),e.gitBranchDelete=new e("git-branch-delete",{fontCharacter:"\\ea68"}),e.sourceControl=new e("source-control",{fontCharacter:"\\ea68"}),e.mirror=new e("mirror",{fontCharacter:"\\ea69"}),e.mirrorPublic=new e("mirror-public",{fontCharacter:"\\ea69"}),e.star=new e("star",{fontCharacter:"\\ea6a"}),e.starAdd=new e("star-add",{fontCharacter:"\\ea6a"}),e.starDelete=new e("star-delete",{fontCharacter:"\\ea6a"}),e.starEmpty=new e("star-empty",{fontCharacter:"\\ea6a"}),e.comment=new e("comment",{fontCharacter:"\\ea6b"}),e.commentAdd=new e("comment-add",{fontCharacter:"\\ea6b"}),e.alert=new e("alert",{fontCharacter:"\\ea6c"}),e.warning=new e("warning",{fontCharacter:"\\ea6c"}),e.search=new e("search",{fontCharacter:"\\ea6d"}),e.searchSave=new e("search-save",{fontCharacter:"\\ea6d"}),e.logOut=new e("log-out",{fontCharacter:"\\ea6e"}),e.signOut=new e("sign-out",{fontCharacter:"\\ea6e"}),e.logIn=new e("log-in",{fontCharacter:"\\ea6f"}),e.signIn=new e("sign-in",{fontCharacter:"\\ea6f"}),e.eye=new e("eye",{fontCharacter:"\\ea70"}),e.eyeUnwatch=new e("eye-unwatch",{fontCharacter:"\\ea70"}),e.eyeWatch=new e("eye-watch",{fontCharacter:"\\ea70"}),e.circleFilled=new e("circle-filled",{fontCharacter:"\\ea71"}),e.primitiveDot=new e("primitive-dot",e.circleFilled.definition),e.closeDirty=new e("close-dirty",e.circleFilled.definition),e.debugBreakpoint=new e("debug-breakpoint",e.circleFilled.definition),e.debugBreakpointDisabled=new e("debug-breakpoint-disabled",e.circleFilled.definition),e.debugHint=new e("debug-hint",e.circleFilled.definition),e.primitiveSquare=new e("primitive-square",{fontCharacter:"\\ea72"}),e.edit=new e("edit",{fontCharacter:"\\ea73"}),e.pencil=new e("pencil",{fontCharacter:"\\ea73"}),e.info=new e("info",{fontCharacter:"\\ea74"}),e.issueOpened=new e("issue-opened",{fontCharacter:"\\ea74"}),e.gistPrivate=new e("gist-private",{fontCharacter:"\\ea75"}),e.gitForkPrivate=new e("git-fork-private",{fontCharacter:"\\ea75"}),e.lock=new e("lock",{fontCharacter:"\\ea75"}),e.mirrorPrivate=new e("mirror-private",{fontCharacter:"\\ea75"}),e.close=new e("close",{fontCharacter:"\\ea76"}),e.removeClose=new e("remove-close",{fontCharacter:"\\ea76"}),e.x=new e("x",{fontCharacter:"\\ea76"}),e.repoSync=new e("repo-sync",{fontCharacter:"\\ea77"}),e.sync=new e("sync",{fontCharacter:"\\ea77"}),e.clone=new e("clone",{fontCharacter:"\\ea78"}),e.desktopDownload=new e("desktop-download",{fontCharacter:"\\ea78"}),e.beaker=new e("beaker",{fontCharacter:"\\ea79"}),e.microscope=new e("microscope",{fontCharacter:"\\ea79"}),e.vm=new e("vm",{fontCharacter:"\\ea7a"}),e.deviceDesktop=new e("device-desktop",{fontCharacter:"\\ea7a"}),e.file=new e("file",{fontCharacter:"\\ea7b"}),e.fileText=new e("file-text",{fontCharacter:"\\ea7b"}),e.more=new e("more",{fontCharacter:"\\ea7c"}),e.ellipsis=new e("ellipsis",{fontCharacter:"\\ea7c"}),e.kebabHorizontal=new e("kebab-horizontal",{fontCharacter:"\\ea7c"}),e.mailReply=new e("mail-reply",{fontCharacter:"\\ea7d"}),e.reply=new e("reply",{fontCharacter:"\\ea7d"}),e.organization=new e("organization",{fontCharacter:"\\ea7e"}),e.organizationFilled=new e("organization-filled",{fontCharacter:"\\ea7e"}),e.organizationOutline=new e("organization-outline",{fontCharacter:"\\ea7e"}),e.newFile=new e("new-file",{fontCharacter:"\\ea7f"}),e.fileAdd=new e("file-add",{fontCharacter:"\\ea7f"}),e.newFolder=new e("new-folder",{fontCharacter:"\\ea80"}),e.fileDirectoryCreate=new e("file-directory-create",{fontCharacter:"\\ea80"}),e.trash=new e("trash",{fontCharacter:"\\ea81"}),e.trashcan=new e("trashcan",{fontCharacter:"\\ea81"}),e.history=new e("history",{fontCharacter:"\\ea82"}),e.clock=new e("clock",{fontCharacter:"\\ea82"}),e.folder=new e("folder",{fontCharacter:"\\ea83"}),e.fileDirectory=new e("file-directory",{fontCharacter:"\\ea83"}),e.symbolFolder=new e("symbol-folder",{fontCharacter:"\\ea83"}),e.logoGithub=new e("logo-github",{fontCharacter:"\\ea84"}),e.markGithub=new e("mark-github",{fontCharacter:"\\ea84"}),e.github=new e("github",{fontCharacter:"\\ea84"}),e.terminal=new e("terminal",{fontCharacter:"\\ea85"}),e.console=new e("console",{fontCharacter:"\\ea85"}),e.repl=new e("repl",{fontCharacter:"\\ea85"}),e.zap=new e("zap",{fontCharacter:"\\ea86"}),e.symbolEvent=new e("symbol-event",{fontCharacter:"\\ea86"}),e.error=new e("error",{fontCharacter:"\\ea87"}),e.stop=new e("stop",{fontCharacter:"\\ea87"}),e.variable=new e("variable",{fontCharacter:"\\ea88"}),e.symbolVariable=new e("symbol-variable",{fontCharacter:"\\ea88"}),e.array=new e("array",{fontCharacter:"\\ea8a"}),e.symbolArray=new e("symbol-array",{fontCharacter:"\\ea8a"}),e.symbolModule=new e("symbol-module",{fontCharacter:"\\ea8b"}),e.symbolPackage=new e("symbol-package",{fontCharacter:"\\ea8b"}),e.symbolNamespace=new e("symbol-namespace",{fontCharacter:"\\ea8b"}),e.symbolObject=new e("symbol-object",{fontCharacter:"\\ea8b"}),e.symbolMethod=new e("symbol-method",{fontCharacter:"\\ea8c"}),e.symbolFunction=new e("symbol-function",{fontCharacter:"\\ea8c"}),e.symbolConstructor=new e("symbol-constructor",{fontCharacter:"\\ea8c"}),e.symbolBoolean=new e("symbol-boolean",{fontCharacter:"\\ea8f"}),e.symbolNull=new e("symbol-null",{fontCharacter:"\\ea8f"}),e.symbolNumeric=new e("symbol-numeric",{fontCharacter:"\\ea90"}),e.symbolNumber=new e("symbol-number",{fontCharacter:"\\ea90"}),e.symbolStructure=new e("symbol-structure",{fontCharacter:"\\ea91"}),e.symbolStruct=new e("symbol-struct",{fontCharacter:"\\ea91"}),e.symbolParameter=new e("symbol-parameter",{fontCharacter:"\\ea92"}),e.symbolTypeParameter=new e("symbol-type-parameter",{fontCharacter:"\\ea92"}),e.symbolKey=new e("symbol-key",{fontCharacter:"\\ea93"}),e.symbolText=new e("symbol-text",{fontCharacter:"\\ea93"}),e.symbolReference=new e("symbol-reference",{fontCharacter:"\\ea94"}),e.goToFile=new e("go-to-file",{fontCharacter:"\\ea94"}),e.symbolEnum=new e("symbol-enum",{fontCharacter:"\\ea95"}),e.symbolValue=new e("symbol-value",{fontCharacter:"\\ea95"}),e.symbolRuler=new e("symbol-ruler",{fontCharacter:"\\ea96"}),e.symbolUnit=new e("symbol-unit",{fontCharacter:"\\ea96"}),e.activateBreakpoints=new e("activate-breakpoints",{fontCharacter:"\\ea97"}),e.archive=new e("archive",{fontCharacter:"\\ea98"}),e.arrowBoth=new e("arrow-both",{fontCharacter:"\\ea99"}),e.arrowDown=new e("arrow-down",{fontCharacter:"\\ea9a"}),e.arrowLeft=new e("arrow-left",{fontCharacter:"\\ea9b"}),e.arrowRight=new e("arrow-right",{fontCharacter:"\\ea9c"}),e.arrowSmallDown=new e("arrow-small-down",{fontCharacter:"\\ea9d"}),e.arrowSmallLeft=new e("arrow-small-left",{fontCharacter:"\\ea9e"}),e.arrowSmallRight=new e("arrow-small-right",{fontCharacter:"\\ea9f"}),e.arrowSmallUp=new e("arrow-small-up",{fontCharacter:"\\eaa0"}),e.arrowUp=new e("arrow-up",{fontCharacter:"\\eaa1"}),e.bell=new e("bell",{fontCharacter:"\\eaa2"}),e.bold=new e("bold",{fontCharacter:"\\eaa3"}),e.book=new e("book",{fontCharacter:"\\eaa4"}),e.bookmark=new e("bookmark",{fontCharacter:"\\eaa5"}),e.debugBreakpointConditionalUnverified=new e("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),e.debugBreakpointConditional=new e("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),e.debugBreakpointConditionalDisabled=new e("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),e.debugBreakpointDataUnverified=new e("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),e.debugBreakpointData=new e("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),e.debugBreakpointDataDisabled=new e("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),e.debugBreakpointLogUnverified=new e("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),e.debugBreakpointLog=new e("debug-breakpoint-log",{fontCharacter:"\\eaab"}),e.debugBreakpointLogDisabled=new e("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),e.briefcase=new e("briefcase",{fontCharacter:"\\eaac"}),e.broadcast=new e("broadcast",{fontCharacter:"\\eaad"}),e.browser=new e("browser",{fontCharacter:"\\eaae"}),e.bug=new e("bug",{fontCharacter:"\\eaaf"}),e.calendar=new e("calendar",{fontCharacter:"\\eab0"}),e.caseSensitive=new e("case-sensitive",{fontCharacter:"\\eab1"}),e.check=new e("check",{fontCharacter:"\\eab2"}),e.checklist=new e("checklist",{fontCharacter:"\\eab3"}),e.chevronDown=new e("chevron-down",{fontCharacter:"\\eab4"}),e.dropDownButton=new e("drop-down-button",e.chevronDown.definition),e.chevronLeft=new e("chevron-left",{fontCharacter:"\\eab5"}),e.chevronRight=new e("chevron-right",{fontCharacter:"\\eab6"}),e.chevronUp=new e("chevron-up",{fontCharacter:"\\eab7"}),e.chromeClose=new e("chrome-close",{fontCharacter:"\\eab8"}),e.chromeMaximize=new e("chrome-maximize",{fontCharacter:"\\eab9"}),e.chromeMinimize=new e("chrome-minimize",{fontCharacter:"\\eaba"}),e.chromeRestore=new e("chrome-restore",{fontCharacter:"\\eabb"}),e.circle=new e("circle",{fontCharacter:"\\eabc"}),e.circleOutline=new e("circle-outline",e.circle.definition),e.debugBreakpointUnverified=new e("debug-breakpoint-unverified",e.circle.definition),e.circleSlash=new e("circle-slash",{fontCharacter:"\\eabd"}),e.circuitBoard=new e("circuit-board",{fontCharacter:"\\eabe"}),e.clearAll=new e("clear-all",{fontCharacter:"\\eabf"}),e.clippy=new e("clippy",{fontCharacter:"\\eac0"}),e.closeAll=new e("close-all",{fontCharacter:"\\eac1"}),e.cloudDownload=new e("cloud-download",{fontCharacter:"\\eac2"}),e.cloudUpload=new e("cloud-upload",{fontCharacter:"\\eac3"}),e.code=new e("code",{fontCharacter:"\\eac4"}),e.collapseAll=new e("collapse-all",{fontCharacter:"\\eac5"}),e.colorMode=new e("color-mode",{fontCharacter:"\\eac6"}),e.commentDiscussion=new e("comment-discussion",{fontCharacter:"\\eac7"}),e.compareChanges=new e("compare-changes",{fontCharacter:"\\eafd"}),e.creditCard=new e("credit-card",{fontCharacter:"\\eac9"}),e.dash=new e("dash",{fontCharacter:"\\eacc"}),e.dashboard=new e("dashboard",{fontCharacter:"\\eacd"}),e.database=new e("database",{fontCharacter:"\\eace"}),e.debugContinue=new e("debug-continue",{fontCharacter:"\\eacf"}),e.debugDisconnect=new e("debug-disconnect",{fontCharacter:"\\ead0"}),e.debugPause=new e("debug-pause",{fontCharacter:"\\ead1"}),e.debugRestart=new e("debug-restart",{fontCharacter:"\\ead2"}),e.debugStart=new e("debug-start",{fontCharacter:"\\ead3"}),e.debugStepInto=new e("debug-step-into",{fontCharacter:"\\ead4"}),e.debugStepOut=new e("debug-step-out",{fontCharacter:"\\ead5"}),e.debugStepOver=new e("debug-step-over",{fontCharacter:"\\ead6"}),e.debugStop=new e("debug-stop",{fontCharacter:"\\ead7"}),e.debug=new e("debug",{fontCharacter:"\\ead8"}),e.deviceCameraVideo=new e("device-camera-video",{fontCharacter:"\\ead9"}),e.deviceCamera=new e("device-camera",{fontCharacter:"\\eada"}),e.deviceMobile=new e("device-mobile",{fontCharacter:"\\eadb"}),e.diffAdded=new e("diff-added",{fontCharacter:"\\eadc"}),e.diffIgnored=new e("diff-ignored",{fontCharacter:"\\eadd"}),e.diffModified=new e("diff-modified",{fontCharacter:"\\eade"}),e.diffRemoved=new e("diff-removed",{fontCharacter:"\\eadf"}),e.diffRenamed=new e("diff-renamed",{fontCharacter:"\\eae0"}),e.diff=new e("diff",{fontCharacter:"\\eae1"}),e.discard=new e("discard",{fontCharacter:"\\eae2"}),e.editorLayout=new e("editor-layout",{fontCharacter:"\\eae3"}),e.emptyWindow=new e("empty-window",{fontCharacter:"\\eae4"}),e.exclude=new e("exclude",{fontCharacter:"\\eae5"}),e.extensions=new e("extensions",{fontCharacter:"\\eae6"}),e.eyeClosed=new e("eye-closed",{fontCharacter:"\\eae7"}),e.fileBinary=new e("file-binary",{fontCharacter:"\\eae8"}),e.fileCode=new e("file-code",{fontCharacter:"\\eae9"}),e.fileMedia=new e("file-media",{fontCharacter:"\\eaea"}),e.filePdf=new e("file-pdf",{fontCharacter:"\\eaeb"}),e.fileSubmodule=new e("file-submodule",{fontCharacter:"\\eaec"}),e.fileSymlinkDirectory=new e("file-symlink-directory",{fontCharacter:"\\eaed"}),e.fileSymlinkFile=new e("file-symlink-file",{fontCharacter:"\\eaee"}),e.fileZip=new e("file-zip",{fontCharacter:"\\eaef"}),e.files=new e("files",{fontCharacter:"\\eaf0"}),e.filter=new e("filter",{fontCharacter:"\\eaf1"}),e.flame=new e("flame",{fontCharacter:"\\eaf2"}),e.foldDown=new e("fold-down",{fontCharacter:"\\eaf3"}),e.foldUp=new e("fold-up",{fontCharacter:"\\eaf4"}),e.fold=new e("fold",{fontCharacter:"\\eaf5"}),e.folderActive=new e("folder-active",{fontCharacter:"\\eaf6"}),e.folderOpened=new e("folder-opened",{fontCharacter:"\\eaf7"}),e.gear=new e("gear",{fontCharacter:"\\eaf8"}),e.gift=new e("gift",{fontCharacter:"\\eaf9"}),e.gistSecret=new e("gist-secret",{fontCharacter:"\\eafa"}),e.gist=new e("gist",{fontCharacter:"\\eafb"}),e.gitCommit=new e("git-commit",{fontCharacter:"\\eafc"}),e.gitCompare=new e("git-compare",{fontCharacter:"\\eafd"}),e.gitMerge=new e("git-merge",{fontCharacter:"\\eafe"}),e.githubAction=new e("github-action",{fontCharacter:"\\eaff"}),e.githubAlt=new e("github-alt",{fontCharacter:"\\eb00"}),e.globe=new e("globe",{fontCharacter:"\\eb01"}),e.grabber=new e("grabber",{fontCharacter:"\\eb02"}),e.graph=new e("graph",{fontCharacter:"\\eb03"}),e.gripper=new e("gripper",{fontCharacter:"\\eb04"}),e.heart=new e("heart",{fontCharacter:"\\eb05"}),e.home=new e("home",{fontCharacter:"\\eb06"}),e.horizontalRule=new e("horizontal-rule",{fontCharacter:"\\eb07"}),e.hubot=new e("hubot",{fontCharacter:"\\eb08"}),e.inbox=new e("inbox",{fontCharacter:"\\eb09"}),e.issueClosed=new e("issue-closed",{fontCharacter:"\\eba4"}),e.issueReopened=new e("issue-reopened",{fontCharacter:"\\eb0b"}),e.issues=new e("issues",{fontCharacter:"\\eb0c"}),e.italic=new e("italic",{fontCharacter:"\\eb0d"}),e.jersey=new e("jersey",{fontCharacter:"\\eb0e"}),e.json=new e("json",{fontCharacter:"\\eb0f"}),e.kebabVertical=new e("kebab-vertical",{fontCharacter:"\\eb10"}),e.key=new e("key",{fontCharacter:"\\eb11"}),e.law=new e("law",{fontCharacter:"\\eb12"}),e.lightbulbAutofix=new e("lightbulb-autofix",{fontCharacter:"\\eb13"}),e.linkExternal=new e("link-external",{fontCharacter:"\\eb14"}),e.link=new e("link",{fontCharacter:"\\eb15"}),e.listOrdered=new e("list-ordered",{fontCharacter:"\\eb16"}),e.listUnordered=new e("list-unordered",{fontCharacter:"\\eb17"}),e.liveShare=new e("live-share",{fontCharacter:"\\eb18"}),e.loading=new e("loading",{fontCharacter:"\\eb19"}),e.location=new e("location",{fontCharacter:"\\eb1a"}),e.mailRead=new e("mail-read",{fontCharacter:"\\eb1b"}),e.mail=new e("mail",{fontCharacter:"\\eb1c"}),e.markdown=new e("markdown",{fontCharacter:"\\eb1d"}),e.megaphone=new e("megaphone",{fontCharacter:"\\eb1e"}),e.mention=new e("mention",{fontCharacter:"\\eb1f"}),e.milestone=new e("milestone",{fontCharacter:"\\eb20"}),e.mortarBoard=new e("mortar-board",{fontCharacter:"\\eb21"}),e.move=new e("move",{fontCharacter:"\\eb22"}),e.multipleWindows=new e("multiple-windows",{fontCharacter:"\\eb23"}),e.mute=new e("mute",{fontCharacter:"\\eb24"}),e.noNewline=new e("no-newline",{fontCharacter:"\\eb25"}),e.note=new e("note",{fontCharacter:"\\eb26"}),e.octoface=new e("octoface",{fontCharacter:"\\eb27"}),e.openPreview=new e("open-preview",{fontCharacter:"\\eb28"}),e.package_=new e("package",{fontCharacter:"\\eb29"}),e.paintcan=new e("paintcan",{fontCharacter:"\\eb2a"}),e.pin=new e("pin",{fontCharacter:"\\eb2b"}),e.play=new e("play",{fontCharacter:"\\eb2c"}),e.run=new e("run",{fontCharacter:"\\eb2c"}),e.plug=new e("plug",{fontCharacter:"\\eb2d"}),e.preserveCase=new e("preserve-case",{fontCharacter:"\\eb2e"}),e.preview=new e("preview",{fontCharacter:"\\eb2f"}),e.project=new e("project",{fontCharacter:"\\eb30"}),e.pulse=new e("pulse",{fontCharacter:"\\eb31"}),e.question=new e("question",{fontCharacter:"\\eb32"}),e.quote=new e("quote",{fontCharacter:"\\eb33"}),e.radioTower=new e("radio-tower",{fontCharacter:"\\eb34"}),e.reactions=new e("reactions",{fontCharacter:"\\eb35"}),e.references=new e("references",{fontCharacter:"\\eb36"}),e.refresh=new e("refresh",{fontCharacter:"\\eb37"}),e.regex=new e("regex",{fontCharacter:"\\eb38"}),e.remoteExplorer=new e("remote-explorer",{fontCharacter:"\\eb39"}),e.remote=new e("remote",{fontCharacter:"\\eb3a"}),e.remove=new e("remove",{fontCharacter:"\\eb3b"}),e.replaceAll=new e("replace-all",{fontCharacter:"\\eb3c"}),e.replace=new e("replace",{fontCharacter:"\\eb3d"}),e.repoClone=new e("repo-clone",{fontCharacter:"\\eb3e"}),e.repoForcePush=new e("repo-force-push",{fontCharacter:"\\eb3f"}),e.repoPull=new e("repo-pull",{fontCharacter:"\\eb40"}),e.repoPush=new e("repo-push",{fontCharacter:"\\eb41"}),e.report=new e("report",{fontCharacter:"\\eb42"}),e.requestChanges=new e("request-changes",{fontCharacter:"\\eb43"}),e.rocket=new e("rocket",{fontCharacter:"\\eb44"}),e.rootFolderOpened=new e("root-folder-opened",{fontCharacter:"\\eb45"}),e.rootFolder=new e("root-folder",{fontCharacter:"\\eb46"}),e.rss=new e("rss",{fontCharacter:"\\eb47"}),e.ruby=new e("ruby",{fontCharacter:"\\eb48"}),e.saveAll=new e("save-all",{fontCharacter:"\\eb49"}),e.saveAs=new e("save-as",{fontCharacter:"\\eb4a"}),e.save=new e("save",{fontCharacter:"\\eb4b"}),e.screenFull=new e("screen-full",{fontCharacter:"\\eb4c"}),e.screenNormal=new e("screen-normal",{fontCharacter:"\\eb4d"}),e.searchStop=new e("search-stop",{fontCharacter:"\\eb4e"}),e.server=new e("server",{fontCharacter:"\\eb50"}),e.settingsGear=new e("settings-gear",{fontCharacter:"\\eb51"}),e.settings=new e("settings",{fontCharacter:"\\eb52"}),e.shield=new e("shield",{fontCharacter:"\\eb53"}),e.smiley=new e("smiley",{fontCharacter:"\\eb54"}),e.sortPrecedence=new e("sort-precedence",{fontCharacter:"\\eb55"}),e.splitHorizontal=new e("split-horizontal",{fontCharacter:"\\eb56"}),e.splitVertical=new e("split-vertical",{fontCharacter:"\\eb57"}),e.squirrel=new e("squirrel",{fontCharacter:"\\eb58"}),e.starFull=new e("star-full",{fontCharacter:"\\eb59"}),e.starHalf=new e("star-half",{fontCharacter:"\\eb5a"}),e.symbolClass=new e("symbol-class",{fontCharacter:"\\eb5b"}),e.symbolColor=new e("symbol-color",{fontCharacter:"\\eb5c"}),e.symbolCustomColor=new e("symbol-customcolor",{fontCharacter:"\\eb5c"}),e.symbolConstant=new e("symbol-constant",{fontCharacter:"\\eb5d"}),e.symbolEnumMember=new e("symbol-enum-member",{fontCharacter:"\\eb5e"}),e.symbolField=new e("symbol-field",{fontCharacter:"\\eb5f"}),e.symbolFile=new e("symbol-file",{fontCharacter:"\\eb60"}),e.symbolInterface=new e("symbol-interface",{fontCharacter:"\\eb61"}),e.symbolKeyword=new e("symbol-keyword",{fontCharacter:"\\eb62"}),e.symbolMisc=new e("symbol-misc",{fontCharacter:"\\eb63"}),e.symbolOperator=new e("symbol-operator",{fontCharacter:"\\eb64"}),e.symbolProperty=new e("symbol-property",{fontCharacter:"\\eb65"}),e.wrench=new e("wrench",{fontCharacter:"\\eb65"}),e.wrenchSubaction=new e("wrench-subaction",{fontCharacter:"\\eb65"}),e.symbolSnippet=new e("symbol-snippet",{fontCharacter:"\\eb66"}),e.tasklist=new e("tasklist",{fontCharacter:"\\eb67"}),e.telescope=new e("telescope",{fontCharacter:"\\eb68"}),e.textSize=new e("text-size",{fontCharacter:"\\eb69"}),e.threeBars=new e("three-bars",{fontCharacter:"\\eb6a"}),e.thumbsdown=new e("thumbsdown",{fontCharacter:"\\eb6b"}),e.thumbsup=new e("thumbsup",{fontCharacter:"\\eb6c"}),e.tools=new e("tools",{fontCharacter:"\\eb6d"}),e.triangleDown=new e("triangle-down",{fontCharacter:"\\eb6e"}),e.triangleLeft=new e("triangle-left",{fontCharacter:"\\eb6f"}),e.triangleRight=new e("triangle-right",{fontCharacter:"\\eb70"}),e.triangleUp=new e("triangle-up",{fontCharacter:"\\eb71"}),e.twitter=new e("twitter",{fontCharacter:"\\eb72"}),e.unfold=new e("unfold",{fontCharacter:"\\eb73"}),e.unlock=new e("unlock",{fontCharacter:"\\eb74"}),e.unmute=new e("unmute",{fontCharacter:"\\eb75"}),e.unverified=new e("unverified",{fontCharacter:"\\eb76"}),e.verified=new e("verified",{fontCharacter:"\\eb77"}),e.versions=new e("versions",{fontCharacter:"\\eb78"}),e.vmActive=new e("vm-active",{fontCharacter:"\\eb79"}),e.vmOutline=new e("vm-outline",{fontCharacter:"\\eb7a"}),e.vmRunning=new e("vm-running",{fontCharacter:"\\eb7b"}),e.watch=new e("watch",{fontCharacter:"\\eb7c"}),e.whitespace=new e("whitespace",{fontCharacter:"\\eb7d"}),e.wholeWord=new e("whole-word",{fontCharacter:"\\eb7e"}),e.window=new e("window",{fontCharacter:"\\eb7f"}),e.wordWrap=new e("word-wrap",{fontCharacter:"\\eb80"}),e.zoomIn=new e("zoom-in",{fontCharacter:"\\eb81"}),e.zoomOut=new e("zoom-out",{fontCharacter:"\\eb82"}),e.listFilter=new e("list-filter",{fontCharacter:"\\eb83"}),e.listFlat=new e("list-flat",{fontCharacter:"\\eb84"}),e.listSelection=new e("list-selection",{fontCharacter:"\\eb85"}),e.selection=new e("selection",{fontCharacter:"\\eb85"}),e.listTree=new e("list-tree",{fontCharacter:"\\eb86"}),e.debugBreakpointFunctionUnverified=new e("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),e.debugBreakpointFunction=new e("debug-breakpoint-function",{fontCharacter:"\\eb88"}),e.debugBreakpointFunctionDisabled=new e("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),e.debugStackframeActive=new e("debug-stackframe-active",{fontCharacter:"\\eb89"}),e.circleSmallFilled=new e("circle-small-filled",{fontCharacter:"\\eb8a"}),e.debugStackframeDot=new e("debug-stackframe-dot",e.circleSmallFilled.definition),e.debugStackframe=new e("debug-stackframe",{fontCharacter:"\\eb8b"}),e.debugStackframeFocused=new e("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),e.debugBreakpointUnsupported=new e("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),e.symbolString=new e("symbol-string",{fontCharacter:"\\eb8d"}),e.debugReverseContinue=new e("debug-reverse-continue",{fontCharacter:"\\eb8e"}),e.debugStepBack=new e("debug-step-back",{fontCharacter:"\\eb8f"}),e.debugRestartFrame=new e("debug-restart-frame",{fontCharacter:"\\eb90"}),e.callIncoming=new e("call-incoming",{fontCharacter:"\\eb92"}),e.callOutgoing=new e("call-outgoing",{fontCharacter:"\\eb93"}),e.menu=new e("menu",{fontCharacter:"\\eb94"}),e.expandAll=new e("expand-all",{fontCharacter:"\\eb95"}),e.feedback=new e("feedback",{fontCharacter:"\\eb96"}),e.groupByRefType=new e("group-by-ref-type",{fontCharacter:"\\eb97"}),e.ungroupByRefType=new e("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),e.account=new e("account",{fontCharacter:"\\eb99"}),e.bellDot=new e("bell-dot",{fontCharacter:"\\eb9a"}),e.debugConsole=new e("debug-console",{fontCharacter:"\\eb9b"}),e.library=new e("library",{fontCharacter:"\\eb9c"}),e.output=new e("output",{fontCharacter:"\\eb9d"}),e.runAll=new e("run-all",{fontCharacter:"\\eb9e"}),e.syncIgnored=new e("sync-ignored",{fontCharacter:"\\eb9f"}),e.pinned=new e("pinned",{fontCharacter:"\\eba0"}),e.githubInverted=new e("github-inverted",{fontCharacter:"\\eba1"}),e.debugAlt=new e("debug-alt",{fontCharacter:"\\eb91"}),e.serverProcess=new e("server-process",{fontCharacter:"\\eba2"}),e.serverEnvironment=new e("server-environment",{fontCharacter:"\\eba3"}),e.pass=new e("pass",{fontCharacter:"\\eba4"}),e.stopCircle=new e("stop-circle",{fontCharacter:"\\eba5"}),e.playCircle=new e("play-circle",{fontCharacter:"\\eba6"}),e.record=new e("record",{fontCharacter:"\\eba7"}),e.debugAltSmall=new e("debug-alt-small",{fontCharacter:"\\eba8"}),e.vmConnect=new e("vm-connect",{fontCharacter:"\\eba9"}),e.cloud=new e("cloud",{fontCharacter:"\\ebaa"}),e.merge=new e("merge",{fontCharacter:"\\ebab"}),e.exportIcon=new e("export",{fontCharacter:"\\ebac"}),e.graphLeft=new e("graph-left",{fontCharacter:"\\ebad"}),e.magnet=new e("magnet",{fontCharacter:"\\ebae"}),e.notebook=new e("notebook",{fontCharacter:"\\ebaf"}),e.redo=new e("redo",{fontCharacter:"\\ebb0"}),e.checkAll=new e("check-all",{fontCharacter:"\\ebb1"}),e.pinnedDirty=new e("pinned-dirty",{fontCharacter:"\\ebb2"}),e.passFilled=new e("pass-filled",{fontCharacter:"\\ebb3"}),e.circleLargeFilled=new e("circle-large-filled",{fontCharacter:"\\ebb4"}),e.circleLarge=new e("circle-large",{fontCharacter:"\\ebb5"}),e.circleLargeOutline=new e("circle-large-outline",e.circleLarge.definition),e.combine=new e("combine",{fontCharacter:"\\ebb6"}),e.gather=new e("gather",{fontCharacter:"\\ebb6"}),e.table=new e("table",{fontCharacter:"\\ebb7"}),e.variableGroup=new e("variable-group",{fontCharacter:"\\ebb8"}),e.typeHierarchy=new e("type-hierarchy",{fontCharacter:"\\ebb9"}),e.typeHierarchySub=new e("type-hierarchy-sub",{fontCharacter:"\\ebba"}),e.typeHierarchySuper=new e("type-hierarchy-super",{fontCharacter:"\\ebbb"}),e.gitPullRequestCreate=new e("git-pull-request-create",{fontCharacter:"\\ebbc"}),e.runAbove=new e("run-above",{fontCharacter:"\\ebbd"}),e.runBelow=new e("run-below",{fontCharacter:"\\ebbe"}),e.notebookTemplate=new e("notebook-template",{fontCharacter:"\\ebbf"}),e.debugRerun=new e("debug-rerun",{fontCharacter:"\\ebc0"}),e.workspaceTrusted=new e("workspace-trusted",{fontCharacter:"\\ebc1"}),e.workspaceUntrusted=new e("workspace-untrusted",{fontCharacter:"\\ebc2"}),e.workspaceUnspecified=new e("workspace-unspecified",{fontCharacter:"\\ebc3"}),e.terminalCmd=new e("terminal-cmd",{fontCharacter:"\\ebc4"}),e.terminalDebian=new e("terminal-debian",{fontCharacter:"\\ebc5"}),e.terminalLinux=new e("terminal-linux",{fontCharacter:"\\ebc6"}),e.terminalPowershell=new e("terminal-powershell",{fontCharacter:"\\ebc7"}),e.terminalTmux=new e("terminal-tmux",{fontCharacter:"\\ebc8"}),e.terminalUbuntu=new e("terminal-ubuntu",{fontCharacter:"\\ebc9"}),e.terminalBash=new e("terminal-bash",{fontCharacter:"\\ebca"}),e.arrowSwap=new e("arrow-swap",{fontCharacter:"\\ebcb"}),e.copy=new e("copy",{fontCharacter:"\\ebcc"}),e.personAdd=new e("person-add",{fontCharacter:"\\ebcd"}),e.filterFilled=new e("filter-filled",{fontCharacter:"\\ebce"}),e.wand=new e("wand",{fontCharacter:"\\ebcf"}),e.debugLineByLine=new e("debug-line-by-line",{fontCharacter:"\\ebd0"}),e.inspect=new e("inspect",{fontCharacter:"\\ebd1"}),e.layers=new e("layers",{fontCharacter:"\\ebd2"}),e.layersDot=new e("layers-dot",{fontCharacter:"\\ebd3"}),e.layersActive=new e("layers-active",{fontCharacter:"\\ebd4"}),e.compass=new e("compass",{fontCharacter:"\\ebd5"}),e.compassDot=new e("compass-dot",{fontCharacter:"\\ebd6"}),e.compassActive=new e("compass-active",{fontCharacter:"\\ebd7"}),e.azure=new e("azure",{fontCharacter:"\\ebd8"}),e.issueDraft=new e("issue-draft",{fontCharacter:"\\ebd9"}),e.gitPullRequestClosed=new e("git-pull-request-closed",{fontCharacter:"\\ebda"}),e.gitPullRequestDraft=new e("git-pull-request-draft",{fontCharacter:"\\ebdb"}),e.debugAll=new e("debug-all",{fontCharacter:"\\ebdc"}),e.debugCoverage=new e("debug-coverage",{fontCharacter:"\\ebdd"}),e.runErrors=new e("run-errors",{fontCharacter:"\\ebde"}),e.folderLibrary=new e("folder-library",{fontCharacter:"\\ebdf"}),e.debugContinueSmall=new e("debug-continue-small",{fontCharacter:"\\ebe0"}),e.beakerStop=new e("beaker-stop",{fontCharacter:"\\ebe1"}),e.graphLine=new e("graph-line",{fontCharacter:"\\ebe2"}),e.graphScatter=new e("graph-scatter",{fontCharacter:"\\ebe3"}),e.pieChart=new e("pie-chart",{fontCharacter:"\\ebe4"}),e.bracket=new e("bracket",e.json.definition),e.bracketDot=new e("bracket-dot",{fontCharacter:"\\ebe5"}),e.bracketError=new e("bracket-error",{fontCharacter:"\\ebe6"}),e.lockSmall=new e("lock-small",{fontCharacter:"\\ebe7"}),e.azureDevops=new e("azure-devops",{fontCharacter:"\\ebe8"}),e.verifiedFilled=new e("verified-filled",{fontCharacter:"\\ebe9"}),e.newLine=new e("newline",{fontCharacter:"\\ebea"}),e.layout=new e("layout",{fontCharacter:"\\ebeb"}),e.layoutActivitybarLeft=new e("layout-activitybar-left",{fontCharacter:"\\ebec"}),e.layoutActivitybarRight=new e("layout-activitybar-right",{fontCharacter:"\\ebed"}),e.layoutPanelLeft=new e("layout-panel-left",{fontCharacter:"\\ebee"}),e.layoutPanelCenter=new e("layout-panel-center",{fontCharacter:"\\ebef"}),e.layoutPanelJustify=new e("layout-panel-justify",{fontCharacter:"\\ebf0"}),e.layoutPanelRight=new e("layout-panel-right",{fontCharacter:"\\ebf1"}),e.layoutPanel=new e("layout-panel",{fontCharacter:"\\ebf2"}),e.layoutSidebarLeft=new e("layout-sidebar-left",{fontCharacter:"\\ebf3"}),e.layoutSidebarRight=new e("layout-sidebar-right",{fontCharacter:"\\ebf4"}),e.layoutStatusbar=new e("layout-statusbar",{fontCharacter:"\\ebf5"}),e.layoutMenubar=new e("layout-menubar",{fontCharacter:"\\ebf6"}),e.layoutCentered=new e("layout-centered",{fontCharacter:"\\ebf7"}),e.layoutSidebarRightOff=new e("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),e.layoutPanelOff=new e("layout-panel-off",{fontCharacter:"\\ec01"}),e.layoutSidebarLeftOff=new e("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),e.target=new e("target",{fontCharacter:"\\ebf8"}),e.indent=new e("indent",{fontCharacter:"\\ebf9"}),e.recordSmall=new e("record-small",{fontCharacter:"\\ebfa"}),e.errorSmall=new e("error-small",{fontCharacter:"\\ebfb"}),e.arrowCircleDown=new e("arrow-circle-down",{fontCharacter:"\\ebfc"}),e.arrowCircleLeft=new e("arrow-circle-left",{fontCharacter:"\\ebfd"}),e.arrowCircleRight=new e("arrow-circle-right",{fontCharacter:"\\ebfe"}),e.arrowCircleUp=new e("arrow-circle-up",{fontCharacter:"\\ebff"}),e.heartFilled=new e("heart-filled",{fontCharacter:"\\ec04"}),e.map=new e("map",{fontCharacter:"\\ec05"}),e.mapFilled=new e("map-filled",{fontCharacter:"\\ec06"}),e.circleSmall=new e("circle-small",{fontCharacter:"\\ec07"}),e.bellSlash=new e("bell-slash",{fontCharacter:"\\ec08"}),e.bellSlashDot=new e("bell-slash-dot",{fontCharacter:"\\ec09"}),e.commentUnresolved=new e("comment-unresolved",{fontCharacter:"\\ec0a"}),e.gitPullRequestGoToChanges=new e("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),e.gitPullRequestNewChanges=new e("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),e.searchFuzzy=new e("search-fuzzy",{fontCharacter:"\\ec0d"}),e.dialogError=new e("dialog-error",e.error.definition),e.dialogWarning=new e("dialog-warning",e.warning.definition),e.dialogInfo=new e("dialog-info",e.info.definition),e.dialogClose=new e("dialog-close",e.close.definition),e.treeItemExpanded=new e("tree-item-expanded",e.chevronDown.definition),e.treeFilterOnTypeOn=new e("tree-filter-on-type-on",e.listFilter.definition),e.treeFilterOnTypeOff=new e("tree-filter-on-type-off",e.listSelection.definition),e.treeFilterClear=new e("tree-filter-clear",e.close.definition),e.treeItemLoading=new e("tree-item-loading",e.loading.definition),e.menuSelection=new e("menu-selection",e.check.definition),e.menuSubmenu=new e("menu-submenu",e.chevronRight.definition),e.menuBarMore=new e("menubar-more",e.more.definition),e.scrollbarButtonLeft=new e("scrollbar-button-left",e.triangleLeft.definition),e.scrollbarButtonRight=new e("scrollbar-button-right",e.triangleRight.definition),e.scrollbarButtonUp=new e("scrollbar-button-up",e.triangleUp.definition),e.scrollbarButtonDown=new e("scrollbar-button-down",e.triangleDown.definition),e.toolBarMore=new e("toolbar-more",e.more.definition),e.quickInputBack=new e("quick-input-back",e.arrowLeft.definition);var E;(function(f){f.iconNameSegment="[A-Za-z0-9]+",f.iconNameExpression="[A-Za-z0-9-]+",f.iconModifierExpression="~[A-Za-z]+",f.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${f.iconNameExpression})(${f.iconModifierExpression})?$`);function C(y){if(y instanceof e)return["codicon","codicon-"+y.id];const t=p.exec(y.id);if(!t)return C(e.error);const[,v,u]=t,m=["codicon","codicon-"+v];return u&&m.push("codicon-modifier-"+u.substr(1)),m}f.asClassNameArray=C;function l(y){return C(y).join(" ")}f.asClassName=l;function d(y){return"."+C(y).join(".")}f.asCSSSelector=d})(E=r.CSSIcon||(r.CSSIcon={}))}),Y(X[25],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DiffChange=void 0;class N{constructor(E,f,p,C){this.originalStart=E,this.originalLength=f,this.modifiedStart=p,this.modifiedLength=C}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}r.DiffChange=N}),Y(X[7],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.BugIndicatingError=r.ErrorNoTelemetry=r.NotSupportedError=r.illegalState=r.illegalArgument=r.canceled=r.CancellationError=r.isCancellationError=r.transformErrorForSerialization=r.onUnexpectedExternalError=r.onUnexpectedError=r.errorHandler=r.ErrorHandler=void 0;class N{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(L){setTimeout(()=>{throw L.stack?u.isErrorNoTelemetry(L)?new u(L.message+`

`+L.stack):new Error(L.message+`

`+L.stack):L},0)}}emit(L){this.listeners.forEach(S=>{S(L)})}onUnexpectedError(L){this.unexpectedErrorHandler(L),this.emit(L)}onUnexpectedExternalError(L){this.unexpectedErrorHandler(L)}}r.ErrorHandler=N,r.errorHandler=new N;function e(w){C(w)||r.errorHandler.onUnexpectedError(w)}r.onUnexpectedError=e;function E(w){C(w)||r.errorHandler.onUnexpectedExternalError(w)}r.onUnexpectedExternalError=E;function f(w){if(w instanceof Error){const{name:L,message:S}=w,b=w.stacktrace||w.stack;return{$isError:!0,name:L,message:S,stack:b,noTelemetry:u.isErrorNoTelemetry(w)}}return w}r.transformErrorForSerialization=f;const p="Canceled";function C(w){return w instanceof l?!0:w instanceof Error&&w.name===p&&w.message===p}r.isCancellationError=C;class l extends Error{constructor(){super(p),this.name=this.message}}r.CancellationError=l;function d(){const w=new Error(p);return w.name=w.message,w}r.canceled=d;function y(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}r.illegalArgument=y;function t(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}r.illegalState=t;class v extends Error{constructor(L){super("NotSupported"),L&&(this.message=L)}}r.NotSupportedError=v;class u extends Error{constructor(L){super(L),this.name="CodeExpectedError"}static fromError(L){if(L instanceof u)return L;const S=new u;return S.message=L.message,S.stack=L.stack,S}static isErrorNoTelemetry(L){return L.name==="CodeExpectedError"}}r.ErrorNoTelemetry=u;class m extends Error{constructor(L){super(L||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype);debugger}}r.BugIndicatingError=m}),Y(X[8],Z([0,1,7]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.checkAdjacentItems=r.assertFn=r.assertNever=r.ok=void 0;function e(C,l){if(!C)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}r.ok=e;function E(C,l="Unreachable"){throw new Error(l)}r.assertNever=E;function f(C){if(!C()){debugger;C(),(0,N.onUnexpectedError)(new N.BugIndicatingError("Assertion Failed"))}}r.assertFn=f;function p(C,l){let d=0;for(;d<C.length-1;){const y=C[d],t=C[d+1];if(!l(y,t))return!1;d++}return!0}r.checkAdjacentItems=p}),Y(X[26],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.once=void 0;function N(e){const E=this;let f=!1,p;return function(){return f||(f=!0,p=e.apply(E,arguments)),p}}r.once=N}),Y(X[13],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Iterable=void 0;var N;(function(e){function E(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}e.is=E;const f=Object.freeze([]);function p(){return f}e.empty=p;function*C(c){yield c}e.single=C;function l(c){return c||f}e.from=l;function d(c){return!c||c[Symbol.iterator]().next().done===!0}e.isEmpty=d;function y(c){return c[Symbol.iterator]().next().value}e.first=y;function t(c,a){for(const h of c)if(a(h))return!0;return!1}e.some=t;function v(c,a){for(const h of c)if(a(h))return h}e.find=v;function*u(c,a){for(const h of c)a(h)&&(yield h)}e.filter=u;function*m(c,a){let h=0;for(const g of c)yield a(g,h++)}e.map=m;function*w(...c){for(const a of c)for(const h of a)yield h}e.concat=w;function*L(c){for(const a of c)for(const h of a)yield h}e.concatNested=L;function S(c,a,h){let g=h;for(const A of c)g=a(g,A);return g}e.reduce=S;function b(c,a){let h=0;for(const g of c)a(g,h++)}e.forEach=b;function*s(c,a,h=c.length){for(a<0&&(a+=c.length),h<0?h+=c.length:h>c.length&&(h=c.length);a<h;a++)yield c[a]}e.slice=s;function i(c,a=Number.POSITIVE_INFINITY){const h=[];if(a===0)return[h,c];const g=c[Symbol.iterator]();for(let A=0;A<a;A++){const M=g.next();if(M.done)return[h,e.empty()];h.push(M.value)}return[h,{[Symbol.iterator](){return g}}]}e.consume=i;function o(c){return i(c)[0]}e.collect=o;function _(c,a,h=(g,A)=>g===A){const g=c[Symbol.iterator](),A=a[Symbol.iterator]();for(;;){const M=g.next(),D=A.next();if(M.done!==D.done)return!1;if(M.done)return!0;if(!h(M.value,D.value))return!1}}e.equals=_})(N=r.Iterable||(r.Iterable={}))}),Y(X[27],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.KeyChord=r.KeyCodeUtils=r.IMMUTABLE_KEY_CODE_TO_CODE=r.IMMUTABLE_CODE_TO_KEY_CODE=r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=r.EVENT_KEY_CODE_MAP=void 0;class N{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(v,u){this._keyCodeToStr[v]=u,this._strToKeyCode[u.toLowerCase()]=v}keyCodeToStr(v){return this._keyCodeToStr[v]}strToKeyCode(v){return this._strToKeyCode[v.toLowerCase()]||0}}const e=new N,E=new N,f=new N;r.EVENT_KEY_CODE_MAP=new Array(230),r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const p=[],C=Object.create(null),l=Object.create(null);r.IMMUTABLE_CODE_TO_KEY_CODE=[],r.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)r.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)r.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",v=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],u=[],m=[];for(const w of v){const[L,S,b,s,i,o,_,c,a,h]=w;if(m[b]||(m[b]=!0,p[b]=s,C[s]=b,l[s.toLowerCase()]=b,S&&(r.IMMUTABLE_CODE_TO_KEY_CODE[b]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(r.IMMUTABLE_KEY_CODE_TO_CODE[i]=b))),!u[i]){if(u[i]=!0,!o)throw new Error(`String representation missing for key code ${i} around scan code ${s}`);e.define(i,o),E.define(i,a||o),f.define(i,h||a||o)}_&&(r.EVENT_KEY_CODE_MAP[_]=i),c&&(r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[c]=i)}r.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var d;(function(t){function v(b){return e.keyCodeToStr(b)}t.toString=v;function u(b){return e.strToKeyCode(b)}t.fromString=u;function m(b){return E.keyCodeToStr(b)}t.toUserSettingsUS=m;function w(b){return f.keyCodeToStr(b)}t.toUserSettingsGeneral=w;function L(b){return E.strToKeyCode(b)||f.strToKeyCode(b)}t.fromUserSettings=L;function S(b){if(b>=93&&b<=108)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return e.keyCodeToStr(b)}t.toElectronAccelerator=S})(d=r.KeyCodeUtils||(r.KeyCodeUtils={}));function y(t,v){const u=(v&65535)<<16>>>0;return(t|u)>>>0}r.KeyChord=y}),Y(X[28],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Lazy=void 0;class N{constructor(E){this.executor=E,this._didRun=!1}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}r.Lazy=N}),Y(X[9],Z([0,1,26,13]),function(k,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.ImmortalReference=r.SafeDisposable=r.RefCountedDisposable=r.MutableDisposable=r.Disposable=r.DisposableStore=r.toDisposable=r.combinedDisposable=r.dispose=r.isDisposable=r.markAsSingleton=r.setDisposableTracker=void 0;const E=!1;let f=null;function p(_){f=_}if(r.setDisposableTracker=p,E){const _="__is_disposable_tracked__";p(new class{trackDisposable(c){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[_]||console.log(a)},3e3)}setParent(c,a){if(c&&c!==S.None)try{c[_]=!0}catch{}}markAsDisposed(c){if(c&&c!==S.None)try{c[_]=!0}catch{}}markAsSingleton(c){}})}function C(_){return f?.trackDisposable(_),_}function l(_){f?.markAsDisposed(_)}function d(_,c){f?.setParent(_,c)}function y(_,c){if(!!f)for(const a of _)f.setParent(a,c)}function t(_){return f?.markAsSingleton(_),_}r.markAsSingleton=t;function v(_){return typeof _.dispose=="function"&&_.dispose.length===0}r.isDisposable=v;function u(_){if(e.Iterable.is(_)){const c=[];for(const a of _)if(a)try{a.dispose()}catch(h){c.push(h)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(_)?[]:_}else if(_)return _.dispose(),_}r.dispose=u;function m(..._){const c=w(()=>u(_));return y(_,c),c}r.combinedDisposable=m;function w(_){const c=C({dispose:(0,N.once)(()=>{l(c),_()})});return c}r.toDisposable=w;class L{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return d(c,this),this._isDisposed?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}r.DisposableStore=L,L.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new L,C(this),d(this._store,this)}dispose(){l(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}r.Disposable=S,S.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var a;this._isDisposed||c===this._value||((a=this._value)===null||a===void 0||a.dispose(),c&&d(c,this),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,l(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&d(c,null),c}}r.MutableDisposable=b;class s{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}r.RefCountedDisposable=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(c){let a=c;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,l(this))},this}}r.SafeDisposable=i;class o{constructor(c){this.object=c}dispose(){}}r.ImmortalReference=o}),Y(X[14],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LinkedList=void 0;class N{constructor(f){this.element=f,this.next=N.Undefined,this.prev=N.Undefined}}N.Undefined=new N(void 0);class e{constructor(){this._first=N.Undefined,this._last=N.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===N.Undefined}clear(){let f=this._first;for(;f!==N.Undefined;){const p=f.next;f.prev=N.Undefined,f.next=N.Undefined,f=p}this._first=N.Undefined,this._last=N.Undefined,this._size=0}unshift(f){return this._insert(f,!1)}push(f){return this._insert(f,!0)}_insert(f,p){const C=new N(f);if(this._first===N.Undefined)this._first=C,this._last=C;else if(p){const d=this._last;this._last=C,C.prev=d,d.next=C}else{const d=this._first;this._first=C,C.next=d,d.prev=C}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(C))}}shift(){if(this._first!==N.Undefined){const f=this._first.element;return this._remove(this._first),f}}pop(){if(this._last!==N.Undefined){const f=this._last.element;return this._remove(this._last),f}}_remove(f){if(f.prev!==N.Undefined&&f.next!==N.Undefined){const p=f.prev;p.next=f.next,f.next.prev=p}else f.prev===N.Undefined&&f.next===N.Undefined?(this._first=N.Undefined,this._last=N.Undefined):f.next===N.Undefined?(this._last=this._last.prev,this._last.next=N.Undefined):f.prev===N.Undefined&&(this._first=this._first.next,this._first.prev=N.Undefined);this._size-=1}*[Symbol.iterator](){let f=this._first;for(;f!==N.Undefined;)yield f.element,f=f.next}}r.LinkedList=e}),Y(X[4],Z([0,1,23,28]),function(k,r,N,e){"use strict";var E;Object.defineProperty(r,"__esModule",{value:!0}),r.InvisibleCharacters=r.AmbiguousCharacters=r.noBreakWhitespace=r.getLeftDeleteOffset=r.singleLetterHash=r.containsUppercaseCharacter=r.startsWithUTF8BOM=r.UTF8_BOM_CHARACTER=r.isEmojiImprecise=r.isFullWidthCharacter=r.containsUnusualLineTerminators=r.UNUSUAL_LINE_TERMINATORS=r.isBasicASCII=r.containsRTL=r.getCharContainingOffset=r.prevCharLength=r.nextCharLength=r.GraphemeIterator=r.CodePointIterator=r.getNextCodePoint=r.computeCodePoint=r.isLowSurrogate=r.isHighSurrogate=r.commonSuffixLength=r.commonPrefixLength=r.startsWithIgnoreCase=r.equalsIgnoreCase=r.isUpperAsciiLetter=r.isLowerAsciiLetter=r.isAsciiDigit=r.compareSubstringIgnoreCase=r.compareIgnoreCase=r.compareSubstring=r.compare=r.lastNonWhitespaceIndex=r.getLeadingWhitespace=r.firstNonWhitespaceIndex=r.splitLines=r.regExpFlags=r.regExpLeadsToEndlessLoop=r.createRegExp=r.stripWildcards=r.convertSimple2RegExpPattern=r.rtrim=r.ltrim=r.trim=r.escapeRegExpCharacters=r.escape=r.format=r.isFalsyOrWhitespace=void 0;function f(R){return!R||typeof R!="string"?!0:R.trim().length===0}r.isFalsyOrWhitespace=f;const p=/{(\d+)}/g;function C(R,...I){return I.length===0?R:R.replace(p,function(V,z){const J=parseInt(z,10);return isNaN(J)||J<0||J>=I.length?V:I[J]})}r.format=C;function l(R){return R.replace(/[<>&]/g,function(I){switch(I){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return I}})}r.escape=l;function d(R){return R.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}r.escapeRegExpCharacters=d;function y(R,I=" "){const V=t(R,I);return v(V,I)}r.trim=y;function t(R,I){if(!R||!I)return R;const V=I.length;if(V===0||R.length===0)return R;let z=0;for(;R.indexOf(I,z)===z;)z=z+V;return R.substring(z)}r.ltrim=t;function v(R,I){if(!R||!I)return R;const V=I.length,z=R.length;if(V===0||z===0)return R;let J=z,ne=-1;for(;ne=R.lastIndexOf(I,J-1),!(ne===-1||ne+V!==J);){if(ne===0)return"";J=ne}return R.substring(0,J)}r.rtrim=v;function u(R){return R.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}r.convertSimple2RegExpPattern=u;function m(R){return R.replace(/\*/g,"")}r.stripWildcards=m;function w(R,I,V={}){if(!R)throw new Error("Cannot create regex from empty string");I||(R=d(R)),V.wholeWord&&(/\B/.test(R.charAt(0))||(R="\\b"+R),/\B/.test(R.charAt(R.length-1))||(R=R+"\\b"));let z="";return V.global&&(z+="g"),V.matchCase||(z+="i"),V.multiline&&(z+="m"),V.unicode&&(z+="u"),new RegExp(R,z)}r.createRegExp=w;function L(R){return R.source==="^"||R.source==="^$"||R.source==="$"||R.source==="^\\s*$"?!1:!!(R.exec("")&&R.lastIndex===0)}r.regExpLeadsToEndlessLoop=L;function S(R){return(R.global?"g":"")+(R.ignoreCase?"i":"")+(R.multiline?"m":"")+(R.unicode?"u":"")}r.regExpFlags=S;function b(R){return R.split(/\r\n|\r|\n/)}r.splitLines=b;function s(R){for(let I=0,V=R.length;I<V;I++){const z=R.charCodeAt(I);if(z!==32&&z!==9)return I}return-1}r.firstNonWhitespaceIndex=s;function i(R,I=0,V=R.length){for(let z=I;z<V;z++){const J=R.charCodeAt(z);if(J!==32&&J!==9)return R.substring(I,z)}return R.substring(I,V)}r.getLeadingWhitespace=i;function o(R,I=R.length-1){for(let V=I;V>=0;V--){const z=R.charCodeAt(V);if(z!==32&&z!==9)return V}return-1}r.lastNonWhitespaceIndex=o;function _(R,I){return R<I?-1:R>I?1:0}r.compare=_;function c(R,I,V=0,z=R.length,J=0,ne=I.length){for(;V<z&&J<ne;V++,J++){const he=R.charCodeAt(V),re=I.charCodeAt(J);if(he<re)return-1;if(he>re)return 1}const oe=z-V,_e=ne-J;return oe<_e?-1:oe>_e?1:0}r.compareSubstring=c;function a(R,I){return h(R,I,0,R.length,0,I.length)}r.compareIgnoreCase=a;function h(R,I,V=0,z=R.length,J=0,ne=I.length){for(;V<z&&J<ne;V++,J++){let he=R.charCodeAt(V),re=I.charCodeAt(J);if(he===re)continue;if(he>=128||re>=128)return c(R.toLowerCase(),I.toLowerCase(),V,z,J,ne);A(he)&&(he-=32),A(re)&&(re-=32);const ce=he-re;if(ce!==0)return ce}const oe=z-V,_e=ne-J;return oe<_e?-1:oe>_e?1:0}r.compareSubstringIgnoreCase=h;function g(R){return R>=48&&R<=57}r.isAsciiDigit=g;function A(R){return R>=97&&R<=122}r.isLowerAsciiLetter=A;function M(R){return R>=65&&R<=90}r.isUpperAsciiLetter=M;function D(R,I){return R.length===I.length&&h(R,I)===0}r.equalsIgnoreCase=D;function P(R,I){const V=I.length;return I.length>R.length?!1:h(R,I,0,V)===0}r.startsWithIgnoreCase=P;function B(R,I){const V=Math.min(R.length,I.length);let z;for(z=0;z<V;z++)if(R.charCodeAt(z)!==I.charCodeAt(z))return z;return V}r.commonPrefixLength=B;function q(R,I){const V=Math.min(R.length,I.length);let z;const J=R.length-1,ne=I.length-1;for(z=0;z<V;z++)if(R.charCodeAt(J-z)!==I.charCodeAt(ne-z))return z;return V}r.commonSuffixLength=q;function H(R){return 55296<=R&&R<=56319}r.isHighSurrogate=H;function W(R){return 56320<=R&&R<=57343}r.isLowSurrogate=W;function F(R,I){return(R-55296<<10)+(I-56320)+65536}r.computeCodePoint=F;function U(R,I,V){const z=R.charCodeAt(V);if(H(z)&&V+1<I){const J=R.charCodeAt(V+1);if(W(J))return F(z,J)}return z}r.getNextCodePoint=U;function T(R,I){const V=R.charCodeAt(I-1);if(W(V)&&I>1){const z=R.charCodeAt(I-2);if(H(z))return F(z,V)}return V}class O{get offset(){return this._offset}constructor(I,V=0){this._str=I,this._len=I.length,this._offset=V}setOffset(I){this._offset=I}prevCodePoint(){const I=T(this._str,this._offset);return this._offset-=I>=65536?2:1,I}nextCodePoint(){const I=U(this._str,this._len,this._offset);return this._offset+=I>=65536?2:1,I}eol(){return this._offset>=this._len}}r.CodePointIterator=O;class j{get offset(){return this._iterator.offset}constructor(I,V=0){this._iterator=new O(I,V)}nextGraphemeLength(){const I=ue.getInstance(),V=this._iterator,z=V.offset;let J=I.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const ne=V.offset,oe=I.getGraphemeBreakType(V.nextCodePoint());if(be(J,oe)){V.setOffset(ne);break}J=oe}return V.offset-z}prevGraphemeLength(){const I=ue.getInstance(),V=this._iterator,z=V.offset;let J=I.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const ne=V.offset,oe=I.getGraphemeBreakType(V.prevCodePoint());if(be(oe,J)){V.setOffset(ne);break}J=oe}return z-V.offset}eol(){return this._iterator.eol()}}r.GraphemeIterator=j;function n(R,I){return new j(R,I).nextGraphemeLength()}r.nextCharLength=n;function se(R,I){return new j(R,I).prevGraphemeLength()}r.prevCharLength=se;function ge(R,I){I>0&&W(R.charCodeAt(I))&&I--;const V=I+n(R,I);return[V-se(R,V),V]}r.getCharContainingOffset=ge;let me;function Le(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ye(R){return me||(me=Le()),me.test(R)}r.containsRTL=ye;const K=/^[\t\n\r\x20-\x7E]*$/;function $(R){return K.test(R)}r.isBasicASCII=$,r.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(R){return r.UNUSUAL_LINE_TERMINATORS.test(R)}r.containsUnusualLineTerminators=G;function Q(R){return R>=11904&&R<=55215||R>=63744&&R<=64255||R>=65281&&R<=65374}r.isFullWidthCharacter=Q;function x(R){return R>=127462&&R<=127487||R===8986||R===8987||R===9200||R===9203||R>=9728&&R<=10175||R===11088||R===11093||R>=127744&&R<=128591||R>=128640&&R<=128764||R>=128992&&R<=129008||R>=129280&&R<=129535||R>=129648&&R<=129782}r.isEmojiImprecise=x,r.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ee(R){return!!(R&&R.length>0&&R.charCodeAt(0)===65279)}r.startsWithUTF8BOM=ee;function te(R,I=!1){return R?(I&&(R=R.replace(/\\./g,"")),R.toLowerCase()!==R):!1}r.containsUppercaseCharacter=te;function ae(R){return R=R%(2*26),R<26?String.fromCharCode(97+R):String.fromCharCode(65+R-26)}r.singleLetterHash=ae;function be(R,I){return R===0?I!==5&&I!==7:R===2&&I===3?!1:R===4||R===2||R===3||I===4||I===2||I===3?!0:!(R===8&&(I===8||I===9||I===11||I===12)||(R===11||R===9)&&(I===9||I===10)||(R===12||R===10)&&I===10||I===5||I===13||I===7||R===1||R===13&&I===14||R===6&&I===6)}class ue{static getInstance(){return ue._INSTANCE||(ue._INSTANCE=new ue),ue._INSTANCE}constructor(){this._data=ve()}getGraphemeBreakType(I){if(I<32)return I===10?3:I===13?2:4;if(I<127)return 0;const V=this._data,z=V.length/3;let J=1;for(;J<=z;)if(I<V[3*J])J=2*J;else if(I>V[3*J+1])J=2*J+1;else return V[3*J+2];return 0}}ue._INSTANCE=null;function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(R,I){if(R===0)return 0;const V=Se(R,I);if(V!==void 0)return V;const z=new O(I,R);return z.prevCodePoint(),z.offset}r.getLeftDeleteOffset=Ce;function Se(R,I){const V=new O(I,R);let z=V.prevCodePoint();for(;Ae(z)||z===65039||z===8419;){if(V.offset===0)return;z=V.prevCodePoint()}if(!x(z))return;let J=V.offset;return J>0&&V.prevCodePoint()===8205&&(J=V.offset),J}function Ae(R){return 127995<=R&&R<=127999}r.noBreakWhitespace="\xA0";class fe{static getInstance(I){return fe.cache.get(Array.from(I))}static getLocales(){return fe._locales.getValue()}constructor(I){this.confusableDictionary=I}isAmbiguous(I){return this.confusableDictionary.has(I)}getPrimaryConfusable(I){return this.confusableDictionary.get(I)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}r.AmbiguousCharacters=fe,E=fe,fe.ambiguousCharacterData=new e.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),fe.cache=new N.LRUCachedFunction(R=>{function I(re){const ce=new Map;for(let de=0;de<re.length;de+=2)ce.set(re[de],re[de+1]);return ce}function V(re,ce){const de=new Map(re);for(const[pe,Ne]of ce)de.set(pe,Ne);return de}function z(re,ce){if(!re)return ce;const de=new Map;for(const[pe,Ne]of re)ce.has(pe)&&de.set(pe,Ne);return de}const J=E.ambiguousCharacterData.getValue();let ne=R.filter(re=>!re.startsWith("_")&&re in J);ne.length===0&&(ne=["_default"]);let oe;for(const re of ne){const ce=I(J[re]);oe=z(oe,ce)}const _e=I(J._common),he=V(_e,oe);return new fe(he)}),fe._locales=new e.Lazy(()=>Object.keys(fe.ambiguousCharacterData.getValue()).filter(R=>!R.startsWith("_")));class we{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(we.getRawData())),this._data}static isInvisibleCharacter(I){return we.getData().has(I)}static get codePoints(){return we.getData()}}r.InvisibleCharacters=we,we._data=void 0}),Y(X[29],Z([0,1,4]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.StringSHA1=r.toHexString=r.stringHash=r.numberHash=r.doHash=r.hash=void 0;function e(w){return E(w,0)}r.hash=e;function E(w,L){switch(typeof w){case"object":return w===null?f(349,L):Array.isArray(w)?l(w,L):d(w,L);case"string":return C(w,L);case"boolean":return p(w,L);case"number":return f(w,L);case"undefined":return f(937,L);default:return f(617,L)}}r.doHash=E;function f(w,L){return(L<<5)-L+w|0}r.numberHash=f;function p(w,L){return f(w?433:863,L)}function C(w,L){L=f(149417,L);for(let S=0,b=w.length;S<b;S++)L=f(w.charCodeAt(S),L);return L}r.stringHash=C;function l(w,L){return L=f(104579,L),w.reduce((S,b)=>E(b,S),L)}function d(w,L){return L=f(181387,L),Object.keys(w).sort().reduce((S,b)=>(S=C(b,S),E(w[b],S)),L)}function y(w,L,S=32){const b=S-L,s=~((1<<b)-1);return(w<<L|(s&w)>>>b)>>>0}function t(w,L=0,S=w.byteLength,b=0){for(let s=0;s<S;s++)w[L+s]=b}function v(w,L,S="0"){for(;w.length<L;)w=S+w;return w}function u(w,L=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(S=>S.toString(16).padStart(2,"0")).join(""):v((w>>>0).toString(16),L/4)}r.toHexString=u;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(L){const S=L.length;if(S===0)return;const b=this._buff;let s=this._buffLen,i=this._leftoverHighSurrogate,o,_;for(i!==0?(o=i,_=-1,i=0):(o=L.charCodeAt(0),_=0);;){let c=o;if(N.isHighSurrogate(o))if(_+1<S){const a=L.charCodeAt(_+1);N.isLowSurrogate(a)?(_++,c=N.computeCodePoint(o,a)):c=65533}else{i=o;break}else N.isLowSurrogate(o)&&(c=65533);if(s=this._push(b,s,c),_++,_<S)o=L.charCodeAt(_);else break}this._buffLen=s,this._leftoverHighSurrogate=i}_push(L,S,b){return b<128?L[S++]=b:b<2048?(L[S++]=192|(b&1984)>>>6,L[S++]=128|(b&63)>>>0):b<65536?(L[S++]=224|(b&61440)>>>12,L[S++]=128|(b&4032)>>>6,L[S++]=128|(b&63)>>>0):(L[S++]=240|(b&1835008)>>>18,L[S++]=128|(b&258048)>>>12,L[S++]=128|(b&4032)>>>6,L[S++]=128|(b&63)>>>0),S>=64&&(this._step(),S-=64,this._totalLen+=64,L[0]=L[64+0],L[1]=L[64+1],L[2]=L[64+2]),S}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,t(this._buff,this._buffLen),this._buffLen>56&&(this._step(),t(this._buff));const L=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(L/4294967296),!1),this._buffDV.setUint32(60,L%4294967296,!1),this._step()}_step(){const L=m._bigBlock32,S=this._buffDV;for(let g=0;g<64;g+=4)L.setUint32(g,S.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)L.setUint32(g,y(L.getUint32(g-12,!1)^L.getUint32(g-32,!1)^L.getUint32(g-56,!1)^L.getUint32(g-64,!1),1),!1);let b=this._h0,s=this._h1,i=this._h2,o=this._h3,_=this._h4,c,a,h;for(let g=0;g<80;g++)g<20?(c=s&i|~s&o,a=1518500249):g<40?(c=s^i^o,a=1859775393):g<60?(c=s&i|s&o|i&o,a=2400959708):(c=s^i^o,a=3395469782),h=y(b,5)+c+_+a+L.getUint32(g*4,!1)&4294967295,_=o,o=i,i=y(s,30),s=b,b=h;this._h0=this._h0+b&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+_&4294967295}}r.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(X[15],Z([0,1,25,29]),function(k,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LcsDiff=r.MyArray=r.Debug=r.stringDiff=r.StringDiffSequence=void 0;class E{constructor(t){this.source=t}getElements(){const t=this.source,v=new Int32Array(t.length);for(let u=0,m=t.length;u<m;u++)v[u]=t.charCodeAt(u);return v}}r.StringDiffSequence=E;function f(y,t,v){return new d(new E(y),new E(t)).ComputeDiff(v).changes}r.stringDiff=f;class p{static Assert(t,v){if(!t)throw new Error(v)}}r.Debug=p;class C{static Copy(t,v,u,m,w){for(let L=0;L<w;L++)u[m+L]=t[v+L]}static Copy2(t,v,u,m,w){for(let L=0;L<w;L++)u[m+L]=t[v+L]}}r.MyArray=C;class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new N.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(t,v){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,v),this.m_originalCount++}AddModifiedElement(t,v){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,v),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class d{constructor(t,v,u=null){this.ContinueProcessingPredicate=u,this._originalSequence=t,this._modifiedSequence=v;const[m,w,L]=d._getElements(t),[S,b,s]=d._getElements(v);this._hasStrings=L&&s,this._originalStringElements=m,this._originalElementsOrHash=w,this._modifiedStringElements=S,this._modifiedElementsOrHash=b,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(t){return t.length>0&&typeof t[0]=="string"}static _getElements(t){const v=t.getElements();if(d._isStringArray(v)){const u=new Int32Array(v.length);for(let m=0,w=v.length;m<w;m++)u[m]=(0,e.stringHash)(v[m],0);return[v,u,!0]}return v instanceof Int32Array?[[],v,!1]:[[],new Int32Array(v),!1]}ElementsAreEqual(t,v){return this._originalElementsOrHash[t]!==this._modifiedElementsOrHash[v]?!1:this._hasStrings?this._originalStringElements[t]===this._modifiedStringElements[v]:!0}ElementsAreStrictEqual(t,v){if(!this.ElementsAreEqual(t,v))return!1;const u=d._getStrictElement(this._originalSequence,t),m=d._getStrictElement(this._modifiedSequence,v);return u===m}static _getStrictElement(t,v){return typeof t.getStrictElement=="function"?t.getStrictElement(v):null}OriginalElementsAreEqual(t,v){return this._originalElementsOrHash[t]!==this._originalElementsOrHash[v]?!1:this._hasStrings?this._originalStringElements[t]===this._originalStringElements[v]:!0}ModifiedElementsAreEqual(t,v){return this._modifiedElementsOrHash[t]!==this._modifiedElementsOrHash[v]?!1:this._hasStrings?this._modifiedStringElements[t]===this._modifiedStringElements[v]:!0}ComputeDiff(t){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,t)}_ComputeDiff(t,v,u,m,w){const L=[!1];let S=this.ComputeDiffRecursive(t,v,u,m,L);return w&&(S=this.PrettifyChanges(S)),{quitEarly:L[0],changes:S}}ComputeDiffRecursive(t,v,u,m,w){for(w[0]=!1;t<=v&&u<=m&&this.ElementsAreEqual(t,u);)t++,u++;for(;v>=t&&m>=u&&this.ElementsAreEqual(v,m);)v--,m--;if(t>v||u>m){let o;return u<=m?(p.Assert(t===v+1,"originalStart should only be one more than originalEnd"),o=[new N.DiffChange(t,0,u,m-u+1)]):t<=v?(p.Assert(u===m+1,"modifiedStart should only be one more than modifiedEnd"),o=[new N.DiffChange(t,v-t+1,u,0)]):(p.Assert(t===v+1,"originalStart should only be one more than originalEnd"),p.Assert(u===m+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const L=[0],S=[0],b=this.ComputeRecursionPoint(t,v,u,m,L,S,w),s=L[0],i=S[0];if(b!==null)return b;if(!w[0]){const o=this.ComputeDiffRecursive(t,s,u,i,w);let _=[];return w[0]?_=[new N.DiffChange(s+1,v-(s+1)+1,i+1,m-(i+1)+1)]:_=this.ComputeDiffRecursive(s+1,v,i+1,m,w),this.ConcatenateChanges(o,_)}return[new N.DiffChange(t,v-t+1,u,m-u+1)]}WALKTRACE(t,v,u,m,w,L,S,b,s,i,o,_,c,a,h,g,A,M){let D=null,P=null,B=new l,q=v,H=u,W=c[0]-g[0]-m,F=-1073741824,U=this.m_forwardHistory.length-1;do{const T=W+t;T===q||T<H&&s[T-1]<s[T+1]?(o=s[T+1],a=o-W-m,o<F&&B.MarkNextChange(),F=o,B.AddModifiedElement(o+1,a),W=T+1-t):(o=s[T-1]+1,a=o-W-m,o<F&&B.MarkNextChange(),F=o-1,B.AddOriginalElement(o,a+1),W=T-1-t),U>=0&&(s=this.m_forwardHistory[U],t=s[0],q=1,H=s.length-1)}while(--U>=-1);if(D=B.getReverseChanges(),M[0]){let T=c[0]+1,O=g[0]+1;if(D!==null&&D.length>0){const j=D[D.length-1];T=Math.max(T,j.getOriginalEnd()),O=Math.max(O,j.getModifiedEnd())}P=[new N.DiffChange(T,_-T+1,O,h-O+1)]}else{B=new l,q=L,H=S,W=c[0]-g[0]-b,F=1073741824,U=A?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const T=W+w;T===q||T<H&&i[T-1]>=i[T+1]?(o=i[T+1]-1,a=o-W-b,o>F&&B.MarkNextChange(),F=o+1,B.AddOriginalElement(o+1,a+1),W=T+1-w):(o=i[T-1],a=o-W-b,o>F&&B.MarkNextChange(),F=o,B.AddModifiedElement(o+1,a+1),W=T-1-w),U>=0&&(i=this.m_reverseHistory[U],w=i[0],q=1,H=i.length-1)}while(--U>=-1);P=B.getChanges()}return this.ConcatenateChanges(D,P)}ComputeRecursionPoint(t,v,u,m,w,L,S){let b=0,s=0,i=0,o=0,_=0,c=0;t--,u--,w[0]=0,L[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const a=v-t+(m-u),h=a+1,g=new Int32Array(h),A=new Int32Array(h),M=m-u,D=v-t,P=t-u,B=v-m,H=(D-M)%2===0;g[M]=t,A[D]=v,S[0]=!1;for(let W=1;W<=a/2+1;W++){let F=0,U=0;i=this.ClipDiagonalBound(M-W,W,M,h),o=this.ClipDiagonalBound(M+W,W,M,h);for(let O=i;O<=o;O+=2){O===i||O<o&&g[O-1]<g[O+1]?b=g[O+1]:b=g[O-1]+1,s=b-(O-M)-P;const j=b;for(;b<v&&s<m&&this.ElementsAreEqual(b+1,s+1);)b++,s++;if(g[O]=b,b+s>F+U&&(F=b,U=s),!H&&Math.abs(O-D)<=W-1&&b>=A[O])return w[0]=b,L[0]=s,j<=A[O]&&1447>0&&W<=1447+1?this.WALKTRACE(M,i,o,P,D,_,c,B,g,A,b,v,w,s,m,L,H,S):null}const T=(F-t+(U-u)-W)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(F,T))return S[0]=!0,w[0]=F,L[0]=U,T>0&&1447>0&&W<=1447+1?this.WALKTRACE(M,i,o,P,D,_,c,B,g,A,b,v,w,s,m,L,H,S):(t++,u++,[new N.DiffChange(t,v-t+1,u,m-u+1)]);_=this.ClipDiagonalBound(D-W,W,D,h),c=this.ClipDiagonalBound(D+W,W,D,h);for(let O=_;O<=c;O+=2){O===_||O<c&&A[O-1]>=A[O+1]?b=A[O+1]-1:b=A[O-1],s=b-(O-D)-B;const j=b;for(;b>t&&s>u&&this.ElementsAreEqual(b,s);)b--,s--;if(A[O]=b,H&&Math.abs(O-M)<=W&&b<=g[O])return w[0]=b,L[0]=s,j>=g[O]&&1447>0&&W<=1447+1?this.WALKTRACE(M,i,o,P,D,_,c,B,g,A,b,v,w,s,m,L,H,S):null}if(W<=1447){let O=new Int32Array(o-i+2);O[0]=M-i+1,C.Copy2(g,i,O,1,o-i+1),this.m_forwardHistory.push(O),O=new Int32Array(c-_+2),O[0]=D-_+1,C.Copy2(A,_,O,1,c-_+1),this.m_reverseHistory.push(O)}}return this.WALKTRACE(M,i,o,P,D,_,c,B,g,A,b,v,w,s,m,L,H,S)}PrettifyChanges(t){for(let v=0;v<t.length;v++){const u=t[v],m=v<t.length-1?t[v+1].originalStart:this._originalElementsOrHash.length,w=v<t.length-1?t[v+1].modifiedStart:this._modifiedElementsOrHash.length,L=u.originalLength>0,S=u.modifiedLength>0;for(;u.originalStart+u.originalLength<m&&u.modifiedStart+u.modifiedLength<w&&(!L||this.OriginalElementsAreEqual(u.originalStart,u.originalStart+u.originalLength))&&(!S||this.ModifiedElementsAreEqual(u.modifiedStart,u.modifiedStart+u.modifiedLength));){const s=this.ElementsAreStrictEqual(u.originalStart,u.modifiedStart);if(this.ElementsAreStrictEqual(u.originalStart+u.originalLength,u.modifiedStart+u.modifiedLength)&&!s)break;u.originalStart++,u.modifiedStart++}const b=[null];if(v<t.length-1&&this.ChangesOverlap(t[v],t[v+1],b)){t[v]=b[0],t.splice(v+1,1),v--;continue}}for(let v=t.length-1;v>=0;v--){const u=t[v];let m=0,w=0;if(v>0){const o=t[v-1];m=o.originalStart+o.originalLength,w=o.modifiedStart+o.modifiedLength}const L=u.originalLength>0,S=u.modifiedLength>0;let b=0,s=this._boundaryScore(u.originalStart,u.originalLength,u.modifiedStart,u.modifiedLength);for(let o=1;;o++){const _=u.originalStart-o,c=u.modifiedStart-o;if(_<m||c<w||L&&!this.OriginalElementsAreEqual(_,_+u.originalLength)||S&&!this.ModifiedElementsAreEqual(c,c+u.modifiedLength))break;const h=(_===m&&c===w?5:0)+this._boundaryScore(_,u.originalLength,c,u.modifiedLength);h>s&&(s=h,b=o)}u.originalStart-=b,u.modifiedStart-=b;const i=[null];if(v>0&&this.ChangesOverlap(t[v-1],t[v],i)){t[v-1]=i[0],t.splice(v,1),v++;continue}}if(this._hasStrings)for(let v=1,u=t.length;v<u;v++){const m=t[v-1],w=t[v],L=w.originalStart-m.originalStart-m.originalLength,S=m.originalStart,b=w.originalStart+w.originalLength,s=b-S,i=m.modifiedStart,o=w.modifiedStart+w.modifiedLength,_=o-i;if(L<5&&s<20&&_<20){const c=this._findBetterContiguousSequence(S,s,i,_,L);if(c){const[a,h]=c;(a!==m.originalStart+m.originalLength||h!==m.modifiedStart+m.modifiedLength)&&(m.originalLength=a-m.originalStart,m.modifiedLength=h-m.modifiedStart,w.originalStart=a+L,w.modifiedStart=h+L,w.originalLength=b-w.originalStart,w.modifiedLength=o-w.modifiedStart)}}}return t}_findBetterContiguousSequence(t,v,u,m,w){if(v<w||m<w)return null;const L=t+v-w+1,S=u+m-w+1;let b=0,s=0,i=0;for(let o=t;o<L;o++)for(let _=u;_<S;_++){const c=this._contiguousSequenceScore(o,_,w);c>0&&c>b&&(b=c,s=o,i=_)}return b>0?[s,i]:null}_contiguousSequenceScore(t,v,u){let m=0;for(let w=0;w<u;w++){if(!this.ElementsAreEqual(t+w,v+w))return 0;m+=this._originalStringElements[t+w].length}return m}_OriginalIsBoundary(t){return t<=0||t>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[t])}_OriginalRegionIsBoundary(t,v){if(this._OriginalIsBoundary(t)||this._OriginalIsBoundary(t-1))return!0;if(v>0){const u=t+v;if(this._OriginalIsBoundary(u-1)||this._OriginalIsBoundary(u))return!0}return!1}_ModifiedIsBoundary(t){return t<=0||t>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[t])}_ModifiedRegionIsBoundary(t,v){if(this._ModifiedIsBoundary(t)||this._ModifiedIsBoundary(t-1))return!0;if(v>0){const u=t+v;if(this._ModifiedIsBoundary(u-1)||this._ModifiedIsBoundary(u))return!0}return!1}_boundaryScore(t,v,u,m){const w=this._OriginalRegionIsBoundary(t,v)?1:0,L=this._ModifiedRegionIsBoundary(u,m)?1:0;return w+L}ConcatenateChanges(t,v){const u=[];if(t.length===0||v.length===0)return v.length>0?v:t;if(this.ChangesOverlap(t[t.length-1],v[0],u)){const m=new Array(t.length+v.length-1);return C.Copy(t,0,m,0,t.length-1),m[t.length-1]=u[0],C.Copy(v,1,m,t.length,v.length-1),m}else{const m=new Array(t.length+v.length);return C.Copy(t,0,m,0,t.length),C.Copy(v,0,m,t.length,v.length),m}}ChangesOverlap(t,v,u){if(p.Assert(t.originalStart<=v.originalStart,"Left change is not less than or equal to right change"),p.Assert(t.modifiedStart<=v.modifiedStart,"Left change is not less than or equal to right change"),t.originalStart+t.originalLength>=v.originalStart||t.modifiedStart+t.modifiedLength>=v.modifiedStart){const m=t.originalStart;let w=t.originalLength;const L=t.modifiedStart;let S=t.modifiedLength;return t.originalStart+t.originalLength>=v.originalStart&&(w=v.originalStart+v.originalLength-t.originalStart),t.modifiedStart+t.modifiedLength>=v.modifiedStart&&(S=v.modifiedStart+v.modifiedLength-t.modifiedStart),u[0]=new N.DiffChange(m,w,L,S),!0}else return u[0]=null,!1}ClipDiagonalBound(t,v,u,m){if(t>=0&&t<m)return t;const w=u,L=m-u-1,S=v%2===0;if(t<0){const b=w%2===0;return S===b?0:1}else{const b=L%2===0;return S===b?m-1:m-2}}}r.LcsDiff=d}),Y(X[30],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.withNullAsUndefined=r.validateConstraint=r.validateConstraints=r.isFunction=r.assertIsDefined=r.assertType=r.isUndefinedOrNull=r.isDefined=r.isUndefined=r.isBoolean=r.isIterable=r.isNumber=r.isTypedArray=r.isObject=r.isString=void 0;function N(S){return typeof S=="string"}r.isString=N;function e(S){return typeof S=="object"&&S!==null&&!Array.isArray(S)&&!(S instanceof RegExp)&&!(S instanceof Date)}r.isObject=e;function E(S){const b=Object.getPrototypeOf(Uint8Array);return typeof S=="object"&&S instanceof b}r.isTypedArray=E;function f(S){return typeof S=="number"&&!isNaN(S)}r.isNumber=f;function p(S){return!!S&&typeof S[Symbol.iterator]=="function"}r.isIterable=p;function C(S){return S===!0||S===!1}r.isBoolean=C;function l(S){return typeof S>"u"}r.isUndefined=l;function d(S){return!y(S)}r.isDefined=d;function y(S){return l(S)||S===null}r.isUndefinedOrNull=y;function t(S,b){if(!S)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}r.assertType=t;function v(S){if(y(S))throw new Error("Assertion Failed: argument is undefined or null");return S}r.assertIsDefined=v;function u(S){return typeof S=="function"}r.isFunction=u;function m(S,b){const s=Math.min(S.length,b.length);for(let i=0;i<s;i++)w(S[i],b[i])}r.validateConstraints=m;function w(S,b){if(N(b)){if(typeof S!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(u(b)){try{if(S instanceof b)return}catch{}if(!y(S)&&S.constructor===b||b.length===1&&b.call(void 0,S)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}r.validateConstraint=w;function L(S){return S===null?void 0:S}r.withNullAsUndefined=L}),Y(X[10],Z([0,1,30]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.createProxyObject=r.getAllMethodNames=r.getAllPropertyNames=r.equals=r.mixin=r.cloneAndChange=r.deepFreeze=r.deepClone=void 0;function e(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.keys(u).forEach(w=>{u[w]&&typeof u[w]=="object"?m[w]=e(u[w]):m[w]=u[w]}),m}r.deepClone=e;function E(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const w=m.shift();Object.freeze(w);for(const L in w)if(f.call(w,L)){const S=w[L];typeof S=="object"&&!Object.isFrozen(S)&&!(0,N.isTypedArray)(S)&&m.push(S)}}return u}r.deepFreeze=E;const f=Object.prototype.hasOwnProperty;function p(u,m){return C(u,m,new Set)}r.cloneAndChange=p;function C(u,m,w){if((0,N.isUndefinedOrNull)(u))return u;const L=m(u);if(typeof L<"u")return L;if(Array.isArray(u)){const S=[];for(const b of u)S.push(C(b,m,w));return S}if((0,N.isObject)(u)){if(w.has(u))throw new Error("Cannot clone recursive data-structure");w.add(u);const S={};for(const b in u)f.call(u,b)&&(S[b]=C(u[b],m,w));return w.delete(u),S}return u}function l(u,m,w=!0){return(0,N.isObject)(u)?((0,N.isObject)(m)&&Object.keys(m).forEach(L=>{L in u?w&&((0,N.isObject)(u[L])&&(0,N.isObject)(m[L])?l(u[L],m[L],w):u[L]=m[L]):u[L]=m[L]}),u):m}r.mixin=l;function d(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let w,L;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(w=0;w<u.length;w++)if(!d(u[w],m[w]))return!1}else{const S=[];for(L in u)S.push(L);S.sort();const b=[];for(L in m)b.push(L);if(b.sort(),!d(S,b))return!1;for(w=0;w<S.length;w++)if(!d(u[S[w]],m[S[w]]))return!1}return!0}r.equals=d;function y(u){let m=[],w=Object.getPrototypeOf(u);for(;Object.prototype!==w;)m=m.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return m}r.getAllPropertyNames=y;function t(u){const m=[];for(const w of y(u))typeof u[w]=="function"&&m.push(w);return m}r.getAllMethodNames=t;function v(u,m){const w=S=>function(){const b=Array.prototype.slice.call(arguments,0);return m(S,b)},L={};for(const S of u)L[S]=w(S);return L}r.createProxyObject=v}),Y(X[16],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.toUint32=r.toUint8=void 0;function N(E){return E<0?0:E>255?255:E|0}r.toUint8=N;function e(E){return E<0?0:E>4294967295?4294967295:E|0}r.toUint32=e}),Y(X[17],Z([0,1,16]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CharacterSet=r.CharacterClassifier=void 0;class e{constructor(p){const C=(0,N.toUint8)(p);this._defaultValue=C,this._asciiMap=e._createAsciiMap(C),this._map=new Map}static _createAsciiMap(p){const C=new Uint8Array(256);for(let l=0;l<256;l++)C[l]=p;return C}set(p,C){const l=(0,N.toUint8)(C);p>=0&&p<256?this._asciiMap[p]=l:this._map.set(p,l)}get(p){return p>=0&&p<256?this._asciiMap[p]:this._map.get(p)||this._defaultValue}}r.CharacterClassifier=e;class E{constructor(){this._actual=new e(0)}add(p){this._actual.set(p,1)}has(p){return this._actual.get(p)===1}}r.CharacterSet=E}),Y(X[3],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Position=void 0;class N{constructor(E,f){this.lineNumber=E,this.column=f}with(E=this.lineNumber,f=this.column){return E===this.lineNumber&&f===this.column?this:new N(E,f)}delta(E=0,f=0){return this.with(this.lineNumber+E,this.column+f)}equals(E){return N.equals(this,E)}static equals(E,f){return!E&&!f?!0:!!E&&!!f&&E.lineNumber===f.lineNumber&&E.column===f.column}isBefore(E){return N.isBefore(this,E)}static isBefore(E,f){return E.lineNumber<f.lineNumber?!0:f.lineNumber<E.lineNumber?!1:E.column<f.column}isBeforeOrEqual(E){return N.isBeforeOrEqual(this,E)}static isBeforeOrEqual(E,f){return E.lineNumber<f.lineNumber?!0:f.lineNumber<E.lineNumber?!1:E.column<=f.column}static compare(E,f){const p=E.lineNumber|0,C=f.lineNumber|0;if(p===C){const l=E.column|0,d=f.column|0;return l-d}return p-C}clone(){return new N(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(E){return new N(E.lineNumber,E.column)}static isIPosition(E){return E&&typeof E.lineNumber=="number"&&typeof E.column=="number"}}r.Position=N}),Y(X[2],Z([0,1,3]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Range=void 0;class e{constructor(f,p,C,l){f>C||f===C&&p>l?(this.startLineNumber=C,this.startColumn=l,this.endLineNumber=f,this.endColumn=p):(this.startLineNumber=f,this.startColumn=p,this.endLineNumber=C,this.endColumn=l)}isEmpty(){return e.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return e.containsPosition(this,f)}static containsPosition(f,p){return!(p.lineNumber<f.startLineNumber||p.lineNumber>f.endLineNumber||p.lineNumber===f.startLineNumber&&p.column<f.startColumn||p.lineNumber===f.endLineNumber&&p.column>f.endColumn)}static strictContainsPosition(f,p){return!(p.lineNumber<f.startLineNumber||p.lineNumber>f.endLineNumber||p.lineNumber===f.startLineNumber&&p.column<=f.startColumn||p.lineNumber===f.endLineNumber&&p.column>=f.endColumn)}containsRange(f){return e.containsRange(this,f)}static containsRange(f,p){return!(p.startLineNumber<f.startLineNumber||p.endLineNumber<f.startLineNumber||p.startLineNumber>f.endLineNumber||p.endLineNumber>f.endLineNumber||p.startLineNumber===f.startLineNumber&&p.startColumn<f.startColumn||p.endLineNumber===f.endLineNumber&&p.endColumn>f.endColumn)}strictContainsRange(f){return e.strictContainsRange(this,f)}static strictContainsRange(f,p){return!(p.startLineNumber<f.startLineNumber||p.endLineNumber<f.startLineNumber||p.startLineNumber>f.endLineNumber||p.endLineNumber>f.endLineNumber||p.startLineNumber===f.startLineNumber&&p.startColumn<=f.startColumn||p.endLineNumber===f.endLineNumber&&p.endColumn>=f.endColumn)}plusRange(f){return e.plusRange(this,f)}static plusRange(f,p){let C,l,d,y;return p.startLineNumber<f.startLineNumber?(C=p.startLineNumber,l=p.startColumn):p.startLineNumber===f.startLineNumber?(C=p.startLineNumber,l=Math.min(p.startColumn,f.startColumn)):(C=f.startLineNumber,l=f.startColumn),p.endLineNumber>f.endLineNumber?(d=p.endLineNumber,y=p.endColumn):p.endLineNumber===f.endLineNumber?(d=p.endLineNumber,y=Math.max(p.endColumn,f.endColumn)):(d=f.endLineNumber,y=f.endColumn),new e(C,l,d,y)}intersectRanges(f){return e.intersectRanges(this,f)}static intersectRanges(f,p){let C=f.startLineNumber,l=f.startColumn,d=f.endLineNumber,y=f.endColumn;const t=p.startLineNumber,v=p.startColumn,u=p.endLineNumber,m=p.endColumn;return C<t?(C=t,l=v):C===t&&(l=Math.max(l,v)),d>u?(d=u,y=m):d===u&&(y=Math.min(y,m)),C>d||C===d&&l>y?null:new e(C,l,d,y)}equalsRange(f){return e.equalsRange(this,f)}static equalsRange(f,p){return!!f&&!!p&&f.startLineNumber===p.startLineNumber&&f.startColumn===p.startColumn&&f.endLineNumber===p.endLineNumber&&f.endColumn===p.endColumn}getEndPosition(){return e.getEndPosition(this)}static getEndPosition(f){return new N.Position(f.endLineNumber,f.endColumn)}getStartPosition(){return e.getStartPosition(this)}static getStartPosition(f){return new N.Position(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,p){return new e(this.startLineNumber,this.startColumn,f,p)}setStartPosition(f,p){return new e(f,p,this.endLineNumber,this.endColumn)}collapseToStart(){return e.collapseToStart(this)}delta(f){return new e(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static collapseToStart(f){return new e(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}static fromPositions(f,p=f){return new e(f.lineNumber,f.column,p.lineNumber,p.column)}static lift(f){return f?new e(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,p){return!(f.endLineNumber<p.startLineNumber||f.endLineNumber===p.startLineNumber&&f.endColumn<p.startColumn||p.endLineNumber<f.startLineNumber||p.endLineNumber===f.startLineNumber&&p.endColumn<f.startColumn)}static areIntersecting(f,p){return!(f.endLineNumber<p.startLineNumber||f.endLineNumber===p.startLineNumber&&f.endColumn<=p.startColumn||p.endLineNumber<f.startLineNumber||p.endLineNumber===f.startLineNumber&&p.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,p){if(f&&p){const d=f.startLineNumber|0,y=p.startLineNumber|0;if(d===y){const t=f.startColumn|0,v=p.startColumn|0;if(t===v){const u=f.endLineNumber|0,m=p.endLineNumber|0;if(u===m){const w=f.endColumn|0,L=p.endColumn|0;return w-L}return u-m}return t-v}return d-y}return(f?1:0)-(p?1:0)}static compareRangesUsingEnds(f,p){return f.endLineNumber===p.endLineNumber?f.endColumn===p.endColumn?f.startLineNumber===p.startLineNumber?f.startColumn-p.startColumn:f.startLineNumber-p.startLineNumber:f.endColumn-p.endColumn:f.endLineNumber-p.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}r.Range=e}),Y(X[31],Z([0,1,3,2]),function(k,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Selection=void 0;class E extends e.Range{constructor(p,C,l,d){super(p,C,l,d),this.selectionStartLineNumber=p,this.selectionStartColumn=C,this.positionLineNumber=l,this.positionColumn=d}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return E.selectionsEqual(this,p)}static selectionsEqual(p,C){return p.selectionStartLineNumber===C.selectionStartLineNumber&&p.selectionStartColumn===C.selectionStartColumn&&p.positionLineNumber===C.positionLineNumber&&p.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,C){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,p,C):new E(p,C,this.startLineNumber,this.startColumn)}getPosition(){return new N.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new N.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,C){return this.getDirection()===0?new E(p,C,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,p,C)}static fromPositions(p,C=p){return new E(p.lineNumber,p.column,C.lineNumber,C.column)}static fromRange(p,C){return C===0?new E(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new E(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new E(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,C){if(p&&!C||!p&&C)return!1;if(!p&&!C)return!0;if(p.length!==C.length)return!1;for(let l=0,d=p.length;l<d;l++)if(!this.selectionsEqual(p[l],C[l]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,C,l,d,y){return y===0?new E(p,C,l,d):new E(l,d,p,C)}}r.Selection=E}),Y(X[32],Z([0,1,17]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getMapForWordSeparators=r.WordCharacterClassifier=void 0;class e extends N.CharacterClassifier{constructor(p){super(0);for(let C=0,l=p.length;C<l;C++)this.set(p.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}r.WordCharacterClassifier=e;function E(f){const p={};return C=>(p.hasOwnProperty(C)||(p[C]=f(C)),p[C])}r.getMapForWordSeparators=E(f=>new e(f))}),Y(X[18],Z([0,1,13,14]),function(k,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getWordAtText=r.ensureValidWordDefinition=r.DEFAULT_WORD_REGEXP=r.USUAL_WORD_SEPARATORS=void 0,r.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(d=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const t of r.USUAL_WORD_SEPARATORS)d.indexOf(t)>=0||(y+="\\"+t);return y+="\\s]+)",new RegExp(y,"g")}r.DEFAULT_WORD_REGEXP=E();function f(d){let y=r.DEFAULT_WORD_REGEXP;if(d&&d instanceof RegExp)if(d.global)y=d;else{let t="g";d.ignoreCase&&(t+="i"),d.multiline&&(t+="m"),d.unicode&&(t+="u"),y=new RegExp(d.source,t)}return y.lastIndex=0,y}r.ensureValidWordDefinition=f;const p=new e.LinkedList;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function C(d,y,t,v,u){if(u||(u=N.Iterable.first(p)),t.length>u.maxLen){let b=d-u.maxLen/2;return b<0?b=0:v+=b,t=t.substring(b,d+u.maxLen/2),C(d,y,t,v,u)}const m=Date.now(),w=d-1-v;let L=-1,S=null;for(let b=1;!(Date.now()-m>=u.timeBudget);b++){const s=w-u.windowSize*b;y.lastIndex=Math.max(0,s);const i=l(y,t,w,L);if(!i&&S||(S=i,s<=0))break;L=s}if(S){const b={word:S[0],startColumn:v+1+S.index,endColumn:v+1+S.index+S[0].length};return y.lastIndex=0,b}return null}r.getWordAtText=C;function l(d,y,t,v){let u;for(;u=d.exec(y);){const m=u.index||0;if(m<=t&&d.lastIndex>=t)return u;if(v>0&&m>v)return null}return null}}),Y(X[11],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.SequenceFromIntArray=r.OffsetRange=r.SequenceDiff=void 0;class N{constructor(p,C){this.seq1Range=p,this.seq2Range=C}}r.SequenceDiff=N;class e{constructor(p,C){this.start=p,this.endExclusive=C}get length(){return this.endExclusive-this.start}}r.OffsetRange=e;class E{constructor(p){this.arr=p}getElement(p){return this.arr[p]}get length(){return this.arr.length}}r.SequenceFromIntArray=E}),Y(X[33],Z([0,1,11]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.MyersDiffAlgorithm=void 0;class e{compute(l,d){function y(s,i){for(;s<l.length&&i<d.length&&l.getElement(s)===d.getElement(i);)s++,i++;return s}let t=0;const v=new f;v.set(0,y(0,0));const u=new p;u.set(0,v.get(0)===0?null:new E(null,0,0,v.get(0)));let m=0;e:for(;;)for(t++,m=-t;m<=t;m+=2){const s=m===t?-1:v.get(m+1),i=m===-t?-1:v.get(m-1)+1,o=Math.min(Math.max(s,i),l.length),_=o-m,c=y(o,_);v.set(m,c);const a=o===s?u.get(m+1):u.get(m-1);if(u.set(m,c!==o?new E(a,o,_,c-o):a),v.get(m)===l.length&&v.get(m)-m===d.length)break e}let w=u.get(m);const L=[];let S=l.length,b=d.length;for(;;){const s=w?w.x+w.length:0,i=w?w.y+w.length:0;if((s!==S||i!==b)&&L.push(new N.SequenceDiff(new N.OffsetRange(s,S),new N.OffsetRange(i,b))),!w)break;S=w.x,b=w.y,w=w.prev}return L.reverse(),L}}r.MyersDiffAlgorithm=e;class E{constructor(l,d,y,t){this.prev=l,this.x=d,this.y=y,this.length=t}}class f{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,d){if(l<0){if(l=-l-1,l>=this.negativeArr.length){const y=this.negativeArr;this.negativeArr=new Int32Array(y.length*2),this.negativeArr.set(y)}this.negativeArr[l]=d}else{if(l>=this.positiveArr.length){const y=this.positiveArr;this.positiveArr=new Int32Array(y.length*2),this.positiveArr.set(y)}this.positiveArr[l]=d}}}class p{constructor(){this.positiveArr=[],this.negativeArr=[]}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,d){l<0?(l=-l-1,this.negativeArr[l]=d):this.positiveArr[l]=d}}}),Y(X[34],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Array2D=void 0;class N{constructor(E,f){this.width=E,this.height=f,this.array=[],this.array=new Array(E*f)}get(E,f){return this.array[E+f*this.width]}set(E,f,p){this.array[E+f*this.width]=p}}r.Array2D=N}),Y(X[35],Z([0,1,11,34]),function(k,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DynamicProgrammingDiffing=void 0;class E{compute(p,C,l){const d=new e.Array2D(p.length,C.length),y=new e.Array2D(p.length,C.length),t=new e.Array2D(p.length,C.length);for(let b=0;b<p.length;b++)for(let s=0;s<C.length;s++){const i=b===0?0:d.get(b-1,s),o=s===0?0:d.get(b,s-1);let _;p.getElement(b)===C.getElement(s)?(b===0||s===0?_=0:_=d.get(b-1,s-1),_+=l?l(b,s):1):_=-1;const c=Math.max(i,o,_);if(c===i)t.set(b,s,0),y.set(b,s,1);else if(c===o)t.set(b,s,0),y.set(b,s,2);else{const a=b>0&&s>0?t.get(b-1,s-1):0;t.set(b,s,a+1),y.set(b,s,3)}d.set(b,s,c)}const v=[];let u=p.length,m=C.length;function w(b,s){(b+1!==u||s+1!==m)&&v.push(new N.SequenceDiff(new N.OffsetRange(b+1,u),new N.OffsetRange(s+1,m))),u=b,m=s}let L=p.length-1,S=C.length-1;for(;L>=0&&S>=0;)y.get(L,S)===3?(w(L,S),L--,S--):y.get(L,S)===1?L--:S--;return w(-1,-1),v.reverse(),v}}r.DynamicProgrammingDiffing=E}),Y(X[19],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LineRange=r.RangeMapping=r.LineRangeMapping=void 0;class N{constructor(p,C,l){this.originalRange=p,this.modifiedRange=C,this.innerChanges=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}r.LineRangeMapping=N;class e{constructor(p,C){this.originalRange=p,this.modifiedRange=C}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}r.RangeMapping=e;class E{constructor(p,C){this.startLineNumber=p,this.endLineNumberExclusive=C}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}join(p){return new E(Math.min(this.startLineNumber,p.startLineNumber),Math.max(this.endLineNumberExclusive,p.endLineNumberExclusive))}}r.LineRange=E}),Y(X[36],Z([0,1,15,19,4,2,8]),function(k,r,N,e,E,f,p){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DiffComputer=r.SmartLinesDiffComputer=void 0;const C=3;class l{computeDiff(i,o,_){var c;const h=new w(i,o,{maxComputationTime:_.maxComputationTime,shouldIgnoreTrimWhitespace:_.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),g=[];let A=null;for(const M of h.changes){let D;M.originalEndLineNumber===0?D=new e.LineRange(M.originalStartLineNumber+1,M.originalStartLineNumber+1):D=new e.LineRange(M.originalStartLineNumber,M.originalEndLineNumber+1);let P;M.modifiedEndLineNumber===0?P=new e.LineRange(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):P=new e.LineRange(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let B=new e.LineRangeMapping(D,P,(c=M.charChanges)===null||c===void 0?void 0:c.map(q=>new e.RangeMapping(new f.Range(q.originalStartLineNumber,q.originalStartColumn,q.originalEndLineNumber,q.originalEndColumn),new f.Range(q.modifiedStartLineNumber,q.modifiedStartColumn,q.modifiedEndLineNumber,q.modifiedEndColumn))));A&&(A.modifiedRange.endLineNumberExclusive===B.modifiedRange.startLineNumber||A.originalRange.endLineNumberExclusive===B.originalRange.startLineNumber)&&(B=new e.LineRangeMapping(A.originalRange.join(B.originalRange),A.modifiedRange.join(B.modifiedRange),A.innerChanges&&B.innerChanges?A.innerChanges.concat(B.innerChanges):void 0),g.pop()),g.push(B),A=B}return(0,p.assertFn)(()=>(0,p.checkAdjacentItems)(g,(M,D)=>D.originalRange.startLineNumber-M.originalRange.endLineNumberExclusive===D.modifiedRange.startLineNumber-M.modifiedRange.endLineNumberExclusive&&M.originalRange.endLineNumberExclusive<D.originalRange.startLineNumber&&M.modifiedRange.endLineNumberExclusive<D.modifiedRange.startLineNumber)),{quitEarly:h.quitEarly,changes:g}}}r.SmartLinesDiffComputer=l;function d(s,i,o,_){return new N.LcsDiff(s,i,o).ComputeDiff(_)}class y{constructor(i){const o=[],_=[];for(let c=0,a=i.length;c<a;c++)o[c]=L(i[c],1),_[c]=S(i[c],1);this.lines=i,this._startColumns=o,this._endColumns=_}getElements(){const i=[];for(let o=0,_=this.lines.length;o<_;o++)i[o]=this.lines[o].substring(this._startColumns[o]-1,this._endColumns[o]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,o,_){const c=[],a=[],h=[];let g=0;for(let A=o;A<=_;A++){const M=this.lines[A],D=i?this._startColumns[A]:1,P=i?this._endColumns[A]:M.length+1;for(let B=D;B<P;B++)c[g]=M.charCodeAt(B-1),a[g]=A+1,h[g]=B,g++;!i&&A<_&&(c[g]=10,a[g]=A+1,h[g]=M.length+1,g++)}return new t(c,a,h)}}class t{constructor(i,o,_){this._charCodes=i,this._lineNumbers=o,this._columns=_}toString(){return"["+this._charCodes.map((i,o)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[o]},${this._columns[o]})`).join(", ")+"]"}_assertIndex(i,o){if(i<0||i>=o.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class v{constructor(i,o,_,c,a,h,g,A){this.originalStartLineNumber=i,this.originalStartColumn=o,this.originalEndLineNumber=_,this.originalEndColumn=c,this.modifiedStartLineNumber=a,this.modifiedStartColumn=h,this.modifiedEndLineNumber=g,this.modifiedEndColumn=A}static createFromDiffChange(i,o,_){const c=o.getStartLineNumber(i.originalStart),a=o.getStartColumn(i.originalStart),h=o.getEndLineNumber(i.originalStart+i.originalLength-1),g=o.getEndColumn(i.originalStart+i.originalLength-1),A=_.getStartLineNumber(i.modifiedStart),M=_.getStartColumn(i.modifiedStart),D=_.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),P=_.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new v(c,a,h,g,A,M,D,P)}}function u(s){if(s.length<=1)return s;const i=[s[0]];let o=i[0];for(let _=1,c=s.length;_<c;_++){const a=s[_],h=a.originalStart-(o.originalStart+o.originalLength),g=a.modifiedStart-(o.modifiedStart+o.modifiedLength);Math.min(h,g)<C?(o.originalLength=a.originalStart+a.originalLength-o.originalStart,o.modifiedLength=a.modifiedStart+a.modifiedLength-o.modifiedStart):(i.push(a),o=a)}return i}class m{constructor(i,o,_,c,a){this.originalStartLineNumber=i,this.originalEndLineNumber=o,this.modifiedStartLineNumber=_,this.modifiedEndLineNumber=c,this.charChanges=a}static createFromDiffResult(i,o,_,c,a,h,g){let A,M,D,P,B;if(o.originalLength===0?(A=_.getStartLineNumber(o.originalStart)-1,M=0):(A=_.getStartLineNumber(o.originalStart),M=_.getEndLineNumber(o.originalStart+o.originalLength-1)),o.modifiedLength===0?(D=c.getStartLineNumber(o.modifiedStart)-1,P=0):(D=c.getStartLineNumber(o.modifiedStart),P=c.getEndLineNumber(o.modifiedStart+o.modifiedLength-1)),h&&o.originalLength>0&&o.originalLength<20&&o.modifiedLength>0&&o.modifiedLength<20&&a()){const q=_.createCharSequence(i,o.originalStart,o.originalStart+o.originalLength-1),H=c.createCharSequence(i,o.modifiedStart,o.modifiedStart+o.modifiedLength-1);if(q.getElements().length>0&&H.getElements().length>0){let W=d(q,H,a,!0).changes;g&&(W=u(W)),B=[];for(let F=0,U=W.length;F<U;F++)B.push(v.createFromDiffChange(W[F],q,H))}}return new m(A,M,D,P,B)}}class w{constructor(i,o,_){this.shouldComputeCharChanges=_.shouldComputeCharChanges,this.shouldPostProcessCharChanges=_.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=_.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=_.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=o,this.original=new y(i),this.modified=new y(o),this.continueLineDiff=b(_.maxComputationTime),this.continueCharDiff=b(_.maxComputationTime===0?0:Math.min(_.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=d(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),o=i.changes,_=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const g=[];for(let A=0,M=o.length;A<M;A++)g.push(m.createFromDiffResult(this.shouldIgnoreTrimWhitespace,o[A],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:_,changes:g}}const c=[];let a=0,h=0;for(let g=-1,A=o.length;g<A;g++){const M=g+1<A?o[g+1]:null,D=M?M.originalStart:this.originalLines.length,P=M?M.modifiedStart:this.modifiedLines.length;for(;a<D&&h<P;){const B=this.originalLines[a],q=this.modifiedLines[h];if(B!==q){{let H=L(B,1),W=L(q,1);for(;H>1&&W>1;){const F=B.charCodeAt(H-2),U=q.charCodeAt(W-2);if(F!==U)break;H--,W--}(H>1||W>1)&&this._pushTrimWhitespaceCharChange(c,a+1,1,H,h+1,1,W)}{let H=S(B,1),W=S(q,1);const F=B.length+1,U=q.length+1;for(;H<F&&W<U;){const T=B.charCodeAt(H-1),O=B.charCodeAt(W-1);if(T!==O)break;H++,W++}(H<F||W<U)&&this._pushTrimWhitespaceCharChange(c,a+1,H,F,h+1,W,U)}}a++,h++}M&&(c.push(m.createFromDiffResult(this.shouldIgnoreTrimWhitespace,M,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),a+=M.originalLength,h+=M.modifiedLength)}return{quitEarly:_,changes:c}}_pushTrimWhitespaceCharChange(i,o,_,c,a,h,g){if(this._mergeTrimWhitespaceCharChange(i,o,_,c,a,h,g))return;let A;this.shouldComputeCharChanges&&(A=[new v(o,_,o,c,a,h,a,g)]),i.push(new m(o,o,a,a,A))}_mergeTrimWhitespaceCharChange(i,o,_,c,a,h,g){const A=i.length;if(A===0)return!1;const M=i[A-1];return M.originalEndLineNumber===0||M.modifiedEndLineNumber===0?!1:M.originalEndLineNumber+1===o&&M.modifiedEndLineNumber+1===a?(M.originalEndLineNumber=o,M.modifiedEndLineNumber=a,this.shouldComputeCharChanges&&M.charChanges&&M.charChanges.push(new v(o,_,o,c,a,h,a,g)),!0):!1}}r.DiffComputer=w;function L(s,i){const o=E.firstNonWhitespaceIndex(s);return o===-1?i:o+1}function S(s,i){const o=E.lastNonWhitespaceIndex(s);return o===-1?i:o+2}function b(s){if(s===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<s}}),Y(X[37],Z([0,1,8,3,2,11,35,33,19]),function(k,r,N,e,E,f,p,C,l){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.lineRangeMappingFromRangeMappings=r.StandardLinesDiffComputer=void 0;class d{constructor(){this.dynamicProgrammingDiffing=new p.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new C.MyersDiffAlgorithm}computeDiff(m,w,L){const S=new Map;function b(g){let A=S.get(g);return A===void 0&&(A=S.size,S.set(g,A)),A}const s=m.map(g=>b(g.trim())),i=w.map(g=>b(g.trim())),o=new f.SequenceFromIntArray(s),_=new f.SequenceFromIntArray(i),c=(()=>o.length+_.length<1500?this.dynamicProgrammingDiffing.compute(o,_,(g,A)=>m[g]===w[A]?w[A].length===0?.1:1+Math.log(1+w[A].length):.99):this.myersDiffingAlgorithm.compute(o,_))(),a=[];for(const g of c){const A=this.refineDiff(m,w,g);for(const M of A)a.push(M)}const h=y(a);return{quitEarly:!1,changes:h}}refineDiff(m,w,L){const S=new v(m,L.seq1Range),b=new v(w,L.seq2Range);return this.myersDiffingAlgorithm.compute(S,b).map(o=>new l.RangeMapping(S.translateRange(o.seq1Range).delta(L.seq1Range.start),b.translateRange(o.seq2Range).delta(L.seq2Range.start)))}}r.StandardLinesDiffComputer=d;function y(u){const m=[];for(const w of t(u,(L,S)=>S.originalRange.startLineNumber-(L.originalRange.endLineNumber-(L.originalRange.endColumn>1?0:1))<=1||S.modifiedRange.startLineNumber-(L.modifiedRange.endLineNumber-(L.modifiedRange.endColumn>1?0:1))<=1)){const L=w[0],S=w[w.length-1];m.push(new l.LineRangeMapping(new l.LineRange(L.originalRange.startLineNumber,S.originalRange.endLineNumber+(S.originalRange.endColumn>1||S.modifiedRange.endColumn>1?1:0)),new l.LineRange(L.modifiedRange.startLineNumber,S.modifiedRange.endLineNumber+(S.originalRange.endColumn>1||S.modifiedRange.endColumn>1?1:0)),w))}return(0,N.assertFn)(()=>(0,N.checkAdjacentItems)(m,(w,L)=>L.originalRange.startLineNumber-w.originalRange.endLineNumberExclusive===L.modifiedRange.startLineNumber-w.modifiedRange.endLineNumberExclusive&&w.originalRange.endLineNumberExclusive<L.originalRange.startLineNumber&&w.modifiedRange.endLineNumberExclusive<L.modifiedRange.startLineNumber)),m}r.lineRangeMappingFromRangeMappings=y;function*t(u,m){let w,L;for(const S of u)L!==void 0&&m(L,S)?w.push(S):(w&&(yield w),w=[S]),L=S;w&&(yield w)}class v{constructor(m,w){this.lines=m,this.lineRange=w;let L=0;this.firstCharOnLineOffsets=new Int32Array(w.length);for(let b=w.start;b<w.endExclusive;b++)L+=m[b].length,this.firstCharOnLineOffsets[b-w.start]=L+1,L++;this.elements=new Int32Array(L);let S=0;for(let b=w.start;b<w.endExclusive;b++){const s=m[b];for(let i=0;i<s.length;i++)this.elements[S+i]=s.charCodeAt(i);S+=s.length,b<m.length-1&&(this.elements[S]=`
`.charCodeAt(0),S+=1)}}getElement(m){return this.elements[m]}get length(){return this.elements.length}translateOffset(m){let w=0,L=this.firstCharOnLineOffsets.length;for(;w<L;){const b=Math.floor((w+L)/2);this.firstCharOnLineOffsets[b]>m?L=b:w=b+1}const S=w===0?0:this.firstCharOnLineOffsets[w-1];return new e.Position(w+1,m-S+1)}translateRange(m){return E.Range.fromPositions(this.translateOffset(m.start),this.translateOffset(m.endExclusive))}}}),Y(X[38],Z([0,1,36,37]),function(k,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.linesDiffComputers=void 0,r.linesDiffComputers={smart:new N.SmartLinesDiffComputer,experimental:new e.StandardLinesDiffComputer}}),Y(X[39],Z([0,1,17]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.computeLinks=r.LinkComputer=r.StateMachine=r.Uint8Matrix=void 0;class e{constructor(v,u,m){const w=new Uint8Array(v*u);for(let L=0,S=v*u;L<S;L++)w[L]=m;this._data=w,this.rows=v,this.cols=u}get(v,u){return this._data[v*this.cols+u]}set(v,u,m){this._data[v*this.cols+u]=m}}r.Uint8Matrix=e;class E{constructor(v){let u=0,m=0;for(let L=0,S=v.length;L<S;L++){const[b,s,i]=v[L];s>u&&(u=s),b>m&&(m=b),i>m&&(m=i)}u++,m++;const w=new e(m,u,0);for(let L=0,S=v.length;L<S;L++){const[b,s,i]=v[L];w.set(b,s,i)}this._states=w,this._maxCharCode=u}nextState(v,u){return u<0||u>=this._maxCharCode?0:this._states.get(v,u)}}r.StateMachine=E;let f=null;function p(){return f===null&&(f=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),f}let C=null;function l(){if(C===null){C=new N.CharacterClassifier(0);const t=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<t.length;u++)C.set(t.charCodeAt(u),1);const v=".,;:";for(let u=0;u<v.length;u++)C.set(v.charCodeAt(u),2)}return C}class d{static _createLink(v,u,m,w,L){let S=L-1;do{const b=u.charCodeAt(S);if(v.get(b)!==2)break;S--}while(S>w);if(w>0){const b=u.charCodeAt(w-1),s=u.charCodeAt(S);(b===40&&s===41||b===91&&s===93||b===123&&s===125)&&S--}return{range:{startLineNumber:m,startColumn:w+1,endLineNumber:m,endColumn:S+2},url:u.substring(w,S+1)}}static computeLinks(v,u=p()){const m=l(),w=[];for(let L=1,S=v.getLineCount();L<=S;L++){const b=v.getLineContent(L),s=b.length;let i=0,o=0,_=0,c=1,a=!1,h=!1,g=!1,A=!1;for(;i<s;){let M=!1;const D=b.charCodeAt(i);if(c===13){let P;switch(D){case 40:a=!0,P=0;break;case 41:P=a?0:1;break;case 91:g=!0,h=!0,P=0;break;case 93:g=!1,P=h?0:1;break;case 123:A=!0,P=0;break;case 125:P=A?0:1;break;case 39:P=_===39?1:0;break;case 34:P=_===34?1:0;break;case 96:P=_===96?1:0;break;case 42:P=_===42?1:0;break;case 124:P=_===124?1:0;break;case 32:P=g?0:1;break;default:P=m.get(D)}P===1&&(w.push(d._createLink(m,b,L,o,i)),M=!0)}else if(c===12){let P;D===91?(h=!0,P=0):P=m.get(D),P===1?M=!0:c=13}else c=u.nextState(c,D),c===0&&(M=!0);M&&(c=1,a=!1,h=!1,A=!1,o=i+1,_=D),i++}c===13&&w.push(d._createLink(m,b,L,o,s))}return w}}r.LinkComputer=d;function y(t){return!t||typeof t.getLineCount!="function"||typeof t.getLineContent!="function"?[]:d.computeLinks(t)}r.computeLinks=y}),Y(X[40],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.BasicInplaceReplace=void 0;class N{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(E,f,p,C,l){if(E&&f){const d=this.doNavigateValueSet(f,l);if(d)return{range:E,value:d}}if(p&&C){const d=this.doNavigateValueSet(C,l);if(d)return{range:p,value:d}}return null}doNavigateValueSet(E,f){const p=this.numberReplace(E,f);return p!==null?p:this.textReplace(E,f)}numberReplace(E,f){const p=Math.pow(10,E.length-(E.lastIndexOf(".")+1));let C=Number(E);const l=parseFloat(E);return!isNaN(C)&&!isNaN(l)&&C===l?C===0&&!f?null:(C=Math.floor(C*p),C+=f?p:-p,String(C/p)):null}textReplace(E,f){return this.valueSetsReplace(this._defaultValueSet,E,f)}valueSetsReplace(E,f,p){let C=null;for(let l=0,d=E.length;C===null&&l<d;l++)C=this.valueSetReplace(E[l],f,p);return C}valueSetReplace(E,f,p){let C=E.indexOf(f);return C>=0?(C+=p?1:-1,C<0?C=E.length-1:C%=E.length,E[C]):null}}r.BasicInplaceReplace=N,N.INSTANCE=new N}),Y(X[41],Z([0,1,10]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.shouldSynchronizeModel=r.ApplyEditsResult=r.SearchData=r.ValidAnnotatedEditOperation=r.isITextSnapshot=r.FindMatch=r.TextModelResolvedOptions=r.InjectedTextCursorStops=r.MinimapPosition=r.OverviewRulerLane=void 0;var e;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(e=r.OverviewRulerLane||(r.OverviewRulerLane={}));var E;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(E=r.MinimapPosition||(r.MinimapPosition={}));var f;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(f=r.InjectedTextCursorStops||(r.InjectedTextCursorStops={}));class p{constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),this.indentSize=m.tabSize|0,this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace),this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,N.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}r.TextModelResolvedOptions=p;class C{constructor(m,w){this._findMatchBrand=void 0,this.range=m,this.matches=w}}r.FindMatch=C;function l(u){return u&&typeof u.read=="function"}r.isITextSnapshot=l;class d{constructor(m,w,L,S,b,s){this.identifier=m,this.range=w,this.text=L,this.forceMoveMarkers=S,this.isAutoWhitespaceEdit=b,this._isTracked=s}}r.ValidAnnotatedEditOperation=d;class y{constructor(m,w,L){this.regex=m,this.wordSeparators=w,this.simpleSearch=L}}r.SearchData=y;class t{constructor(m,w,L){this.reverseEdits=m,this.changes=w,this.trimAutoWhitespaceLineNumbers=L}}r.ApplyEditsResult=t;function v(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}r.shouldSynchronizeModel=v}),Y(X[42],Z([0,1,22,16]),function(k,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.PrefixSumIndexOfResult=r.ConstantTimePrefixSumComputer=r.PrefixSumComputer=void 0;class E{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(l,d){l=(0,e.toUint32)(l);const y=this.values,t=this.prefixSum,v=d.length;return v===0?!1:(this.values=new Uint32Array(y.length+v),this.values.set(y.subarray(0,l),0),this.values.set(y.subarray(l),l+v),this.values.set(d,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(t.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,d){return l=(0,e.toUint32)(l),d=(0,e.toUint32)(d),this.values[l]===d?!1:(this.values[l]=d,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,d){l=(0,e.toUint32)(l),d=(0,e.toUint32)(d);const y=this.values,t=this.prefixSum;if(l>=y.length)return!1;const v=y.length-l;return d>=v&&(d=v),d===0?!1:(this.values=new Uint32Array(y.length-d),this.values.set(y.subarray(0,l),0),this.values.set(y.subarray(l+d),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(t.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,e.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let d=this.prefixSumValidIndex[0]+1;d===0&&(this.prefixSum[0]=this.values[0],d++),l>=this.values.length&&(l=this.values.length-1);for(let y=d;y<=l;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let d=0,y=this.values.length-1,t=0,v=0,u=0;for(;d<=y;)if(t=d+(y-d)/2|0,v=this.prefixSum[t],u=v-this.values[t],l<u)y=t-1;else if(l>=v)d=t+1;else break;return new p(t,l-u)}}r.PrefixSumComputer=E;class f{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const d=this._indexBySum[l],y=d>0?this._prefixSum[d-1]:0;return new p(d,l-y)}removeValues(l,d){this._values.splice(l,d),this._invalidate(l)}insertValues(l,d){this._values=(0,N.arrayInsert)(this._values,l,d),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,d=this._values.length;l<d;l++){const y=this._values[l],t=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=t+y;for(let v=0;v<y;v++)this._indexBySum[t+v]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,d){this._values[l]!==d&&(this._values[l]=d,this._invalidate(l))}}r.ConstantTimePrefixSumComputer=f;class p{constructor(l,d){this.index=l,this.remainder=d,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=d}}r.PrefixSumIndexOfResult=p}),Y(X[43],Z([0,1,4,3,42]),function(k,r,N,e,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.MirrorTextModel=void 0;class f{constructor(C,l,d,y){this._uri=C,this._lines=l,this._eol=d,this._versionId=y,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const l=C.changes;for(const d of l)this._acceptDeleteRange(d.range),this._acceptInsertText(new e.Position(d.range.startLineNumber,d.range.startColumn),d.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,l=this._lines.length,d=new Uint32Array(l);for(let y=0;y<l;y++)d[y]=this._lines[y].length+C;this._lineStarts=new E.PrefixSumComputer(d)}}_setLineText(C,l){this._lines[C]=l,this._lineStarts&&this._lineStarts.setValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,l){if(l.length===0)return;const d=(0,N.splitLines)(l);if(d.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+d[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}d[d.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+d[0]);const y=new Uint32Array(d.length-1);for(let t=1;t<d.length;t++)this._lines.splice(C.lineNumber+t-1,0,d[t]),y[t-1]=d[t].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,y)}}r.MirrorTextModel=f}),Y(X[44],Z([0,1,4,32,3,2,41]),function(k,r,N,e,E,f,p){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Searcher=r.isValidMatch=r.TextModelSearch=r.createFindMatch=r.isMultilineRegexSource=r.SearchParams=void 0;const C=999;class l{constructor(b,s,i,o){this.searchString=b,this.isRegex=s,this.matchCase=i,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=d(this.searchString):b=this.searchString.indexOf(`
`)>=0;let s=null;try{s=N.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!s)return null;let i=!this.isRegex&&!b;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new p.SearchData(s,this.wordSeparators?(0,e.getMapForWordSeparators)(this.wordSeparators):null,i?this.searchString:null)}}r.SearchParams=l;function d(S){if(!S||S.length===0)return!1;for(let b=0,s=S.length;b<s;b++){const i=S.charCodeAt(b);if(i===10)return!0;if(i===92){if(b++,b>=s)break;const o=S.charCodeAt(b);if(o===110||o===114||o===87)return!0}}return!1}r.isMultilineRegexSource=d;function y(S,b,s){if(!s)return new p.FindMatch(S,null);const i=[];for(let o=0,_=b.length;o<_;o++)i[o]=b[o];return new p.FindMatch(S,i)}r.createFindMatch=y;class t{constructor(b){const s=[];let i=0;for(let o=0,_=b.length;o<_;o++)b.charCodeAt(o)===10&&(s[i++]=o);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(b){const s=this._lineFeedsOffsets;let i=0,o=s.length-1;if(o===-1||b<=s[0])return 0;for(;i<o;){const _=i+((o-i)/2>>0);s[_]>=b?o=_-1:s[_+1]>=b?(i=_,o=_):i=_+1}return i+1}}class v{static findMatches(b,s,i,o,_){const c=s.parseSearchRequest();return c?c.regex.multiline?this._doFindMatchesMultiline(b,i,new L(c.wordSeparators,c.regex),o,_):this._doFindMatchesLineByLine(b,i,c,o,_):[]}static _getMultilineMatchRange(b,s,i,o,_,c){let a,h=0;o?(h=o.findLineFeedCountBeforeOffset(_),a=s+_+h):a=s+_;let g;if(o){const P=o.findLineFeedCountBeforeOffset(_+c.length)-h;g=a+c.length+P}else g=a+c.length;const A=b.getPositionAt(a),M=b.getPositionAt(g);return new f.Range(A.lineNumber,A.column,M.lineNumber,M.column)}static _doFindMatchesMultiline(b,s,i,o,_){const c=b.getOffsetAt(s.getStartPosition()),a=b.getValueInRange(s,1),h=b.getEOL()===`\r
`?new t(a):null,g=[];let A=0,M;for(i.reset(0);M=i.next(a);)if(g[A++]=y(this._getMultilineMatchRange(b,c,a,h,M.index,M[0]),M,o),A>=_)return g;return g}static _doFindMatchesLineByLine(b,s,i,o,_){const c=[];let a=0;if(s.startLineNumber===s.endLineNumber){const g=b.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return a=this._findMatchesInLine(i,g,s.startLineNumber,s.startColumn-1,a,c,o,_),c}const h=b.getLineContent(s.startLineNumber).substring(s.startColumn-1);a=this._findMatchesInLine(i,h,s.startLineNumber,s.startColumn-1,a,c,o,_);for(let g=s.startLineNumber+1;g<s.endLineNumber&&a<_;g++)a=this._findMatchesInLine(i,b.getLineContent(g),g,0,a,c,o,_);if(a<_){const g=b.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);a=this._findMatchesInLine(i,g,s.endLineNumber,0,a,c,o,_)}return c}static _findMatchesInLine(b,s,i,o,_,c,a,h){const g=b.wordSeparators;if(!a&&b.simpleSearch){const D=b.simpleSearch,P=D.length,B=s.length;let q=-P;for(;(q=s.indexOf(D,q+P))!==-1;)if((!g||w(g,s,B,q,P))&&(c[_++]=new p.FindMatch(new f.Range(i,q+1+o,i,q+1+P+o),null),_>=h))return _;return _}const A=new L(b.wordSeparators,b.regex);let M;A.reset(0);do if(M=A.next(s),M&&(c[_++]=y(new f.Range(i,M.index+1+o,i,M.index+1+M[0].length+o),M,a),_>=h))return _;while(M);return _}static findNextMatch(b,s,i,o){const _=s.parseSearchRequest();if(!_)return null;const c=new L(_.wordSeparators,_.regex);return _.regex.multiline?this._doFindNextMatchMultiline(b,i,c,o):this._doFindNextMatchLineByLine(b,i,c,o)}static _doFindNextMatchMultiline(b,s,i,o){const _=new E.Position(s.lineNumber,1),c=b.getOffsetAt(_),a=b.getLineCount(),h=b.getValueInRange(new f.Range(_.lineNumber,_.column,a,b.getLineMaxColumn(a)),1),g=b.getEOL()===`\r
`?new t(h):null;i.reset(s.column-1);const A=i.next(h);return A?y(this._getMultilineMatchRange(b,c,h,g,A.index,A[0]),A,o):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(b,new E.Position(1,1),i,o):null}static _doFindNextMatchLineByLine(b,s,i,o){const _=b.getLineCount(),c=s.lineNumber,a=b.getLineContent(c),h=this._findFirstMatchInLine(i,a,c,s.column,o);if(h)return h;for(let g=1;g<=_;g++){const A=(c+g-1)%_,M=b.getLineContent(A+1),D=this._findFirstMatchInLine(i,M,A+1,1,o);if(D)return D}return null}static _findFirstMatchInLine(b,s,i,o,_){b.reset(o-1);const c=b.next(s);return c?y(new f.Range(i,c.index+1,i,c.index+1+c[0].length),c,_):null}static findPreviousMatch(b,s,i,o){const _=s.parseSearchRequest();if(!_)return null;const c=new L(_.wordSeparators,_.regex);return _.regex.multiline?this._doFindPreviousMatchMultiline(b,i,c,o):this._doFindPreviousMatchLineByLine(b,i,c,o)}static _doFindPreviousMatchMultiline(b,s,i,o){const _=this._doFindMatchesMultiline(b,new f.Range(1,1,s.lineNumber,s.column),i,o,10*C);if(_.length>0)return _[_.length-1];const c=b.getLineCount();return s.lineNumber!==c||s.column!==b.getLineMaxColumn(c)?this._doFindPreviousMatchMultiline(b,new E.Position(c,b.getLineMaxColumn(c)),i,o):null}static _doFindPreviousMatchLineByLine(b,s,i,o){const _=b.getLineCount(),c=s.lineNumber,a=b.getLineContent(c).substring(0,s.column-1),h=this._findLastMatchInLine(i,a,c,o);if(h)return h;for(let g=1;g<=_;g++){const A=(_+c-g-1)%_,M=b.getLineContent(A+1),D=this._findLastMatchInLine(i,M,A+1,o);if(D)return D}return null}static _findLastMatchInLine(b,s,i,o){let _=null,c;for(b.reset(0);c=b.next(s);)_=y(new f.Range(i,c.index+1,i,c.index+1+c[0].length),c,o);return _}}r.TextModelSearch=v;function u(S,b,s,i,o){if(i===0)return!0;const _=b.charCodeAt(i-1);if(S.get(_)!==0||_===13||_===10)return!0;if(o>0){const c=b.charCodeAt(i);if(S.get(c)!==0)return!0}return!1}function m(S,b,s,i,o){if(i+o===s)return!0;const _=b.charCodeAt(i+o);if(S.get(_)!==0||_===13||_===10)return!0;if(o>0){const c=b.charCodeAt(i+o-1);if(S.get(c)!==0)return!0}return!1}function w(S,b,s,i,o){return u(S,b,s,i,o)&&m(S,b,s,i,o)}r.isValidMatch=w;class L{constructor(b,s){this._wordSeparators=b,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const s=b.length;let i;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(i=this._searchRegex.exec(b),!i))return null;const o=i.index,_=i[0].length;if(o===this._prevMatchStartIndex&&_===this._prevMatchLength){if(_===0){N.getNextCodePoint(b,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=_,!this._wordSeparators||w(this._wordSeparators,b,s,o,_))return i}while(i);return null}}r.Searcher=L}),Y(X[45],Z([0,1,2,44,4,8,18]),function(k,r,N,e,E,f,p){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.UnicodeTextModelHighlighter=void 0;class C{static computeUnicodeHighlights(v,u,m){const w=m?m.startLineNumber:1,L=m?m.endLineNumber:v.getLineCount(),S=new d(u),b=S.getCandidateCodePoints();let s;b==="allNonBasicAscii"?s=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):s=new RegExp(`${l(Array.from(b))}`,"g");const i=new e.Searcher(null,s),o=[];let _=!1,c,a=0,h=0,g=0;e:for(let A=w,M=L;A<=M;A++){const D=v.getLineContent(A),P=D.length;i.reset(0);do if(c=i.next(D),c){let B=c.index,q=c.index+c[0].length;if(B>0){const U=D.charCodeAt(B-1);E.isHighSurrogate(U)&&B--}if(q+1<P){const U=D.charCodeAt(q-1);E.isHighSurrogate(U)&&q++}const H=D.substring(B,q),W=(0,p.getWordAtText)(B+1,p.DEFAULT_WORD_REGEXP,D,0),F=S.shouldHighlightNonBasicASCII(H,W?W.word:null);if(F!==0){F===3?a++:F===2?h++:F===1?g++:(0,f.assertNever)(F);const U=1e3;if(o.length>=U){_=!0;break e}o.push(new N.Range(A,B+1,A,q+1))}}while(c)}return{ranges:o,hasMore:_,ambiguousCharacterCount:a,invisibleCharacterCount:h,nonBasicAsciiCharacterCount:g}}static computeUnicodeHighlightReason(v,u){const m=new d(u);switch(m.shouldHighlightNonBasicASCII(v,null)){case 0:return null;case 2:return{kind:1};case 3:{const L=v.codePointAt(0),S=m.ambiguousCharacters.getPrimaryConfusable(L),b=E.AmbiguousCharacters.getLocales().filter(s=>!E.AmbiguousCharacters.getInstance(new Set([...u.allowedLocales,s])).isAmbiguous(L));return{kind:0,confusableWith:String.fromCodePoint(S),notAmbiguousInLocales:b}}case 1:return{kind:2}}}}r.UnicodeTextModelHighlighter=C;function l(t,v){return`[${E.escapeRegExpCharacters(t.map(m=>String.fromCodePoint(m)).join(""))}]`}class d{constructor(v){this.options=v,this.allowedCodePoints=new Set(v.allowedCodePoints),this.ambiguousCharacters=E.AmbiguousCharacters.getInstance(new Set(v.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const v=new Set;if(this.options.invisibleCharacters)for(const u of E.InvisibleCharacters.codePoints)y(String.fromCodePoint(u))||v.add(u);if(this.options.ambiguousCharacters)for(const u of this.ambiguousCharacters.getConfusableCodePoints())v.add(u);for(const u of this.allowedCodePoints)v.delete(u);return v}shouldHighlightNonBasicASCII(v,u){const m=v.codePointAt(0);if(this.allowedCodePoints.has(m))return 0;if(this.options.nonBasicASCII)return 1;let w=!1,L=!1;if(u)for(const S of u){const b=S.codePointAt(0),s=E.isBasicASCII(S);w=w||s,!s&&!this.ambiguousCharacters.isAmbiguous(b)&&!E.InvisibleCharacters.isInvisibleCharacter(b)&&(L=!0)}return!w&&L?0:this.options.invisibleCharacters&&!y(v)&&E.InvisibleCharacters.isInvisibleCharacter(m)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(m)?3:0}}function y(t){return t===" "||t===`
`||t==="	"}}),Y(X[46],Z([0,1]),function(k,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.WrappingIndent=r.TrackedRangeStickiness=r.TextEditorCursorStyle=r.TextEditorCursorBlinkingStyle=r.SymbolTag=r.SymbolKind=r.SignatureHelpTriggerKind=r.SelectionDirection=r.ScrollbarVisibility=r.ScrollType=r.RenderMinimap=r.RenderLineNumbersType=r.PositionAffinity=r.OverviewRulerLane=r.OverlayWidgetPositionPreference=r.MouseTargetType=r.MinimapPosition=r.MarkerTag=r.MarkerSeverity=r.KeyCode=r.InlineCompletionTriggerKind=r.InlayHintKind=r.InjectedTextCursorStops=r.IndentAction=r.EndOfLineSequence=r.EndOfLinePreference=r.EditorOption=r.EditorAutoIndentStrategy=r.DocumentHighlightKind=r.DefaultEndOfLine=r.CursorChangeReason=r.ContentWidgetPositionPreference=r.CompletionTriggerKind=r.CompletionItemTag=r.CompletionItemKind=r.CompletionItemInsertTextRule=r.CodeActionTriggerType=r.AccessibilitySupport=void 0;var N;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(N=r.AccessibilitySupport||(r.AccessibilitySupport={}));var e;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(e=r.CodeActionTriggerType||(r.CodeActionTriggerType={}));var E;(function(n){n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(E=r.CompletionItemInsertTextRule||(r.CompletionItemInsertTextRule={}));var f;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(f=r.CompletionItemKind||(r.CompletionItemKind={}));var p;(function(n){n[n.Deprecated=1]="Deprecated"})(p=r.CompletionItemTag||(r.CompletionItemTag={}));var C;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=r.CompletionTriggerKind||(r.CompletionTriggerKind={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l=r.ContentWidgetPositionPreference||(r.ContentWidgetPositionPreference={}));var d;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(d=r.CursorChangeReason||(r.CursorChangeReason={}));var y;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(y=r.DefaultEndOfLine||(r.DefaultEndOfLine={}));var t;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(t=r.DocumentHighlightKind||(r.DocumentHighlightKind={}));var v;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(v=r.EditorAutoIndentStrategy||(r.EditorAutoIndentStrategy={}));var u;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.columnSelection=18]="columnSelection",n[n.comments=19]="comments",n[n.contextmenu=20]="contextmenu",n[n.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",n[n.cursorBlinking=22]="cursorBlinking",n[n.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",n[n.cursorStyle=24]="cursorStyle",n[n.cursorSurroundingLines=25]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",n[n.cursorWidth=27]="cursorWidth",n[n.disableLayerHinting=28]="disableLayerHinting",n[n.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",n[n.domReadOnly=30]="domReadOnly",n[n.dragAndDrop=31]="dragAndDrop",n[n.dropIntoEditor=32]="dropIntoEditor",n[n.emptySelectionClipboard=33]="emptySelectionClipboard",n[n.extraEditorClassName=34]="extraEditorClassName",n[n.fastScrollSensitivity=35]="fastScrollSensitivity",n[n.find=36]="find",n[n.fixedOverflowWidgets=37]="fixedOverflowWidgets",n[n.folding=38]="folding",n[n.foldingStrategy=39]="foldingStrategy",n[n.foldingHighlight=40]="foldingHighlight",n[n.foldingImportsByDefault=41]="foldingImportsByDefault",n[n.foldingMaximumRegions=42]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=44]="fontFamily",n[n.fontInfo=45]="fontInfo",n[n.fontLigatures=46]="fontLigatures",n[n.fontSize=47]="fontSize",n[n.fontWeight=48]="fontWeight",n[n.formatOnPaste=49]="formatOnPaste",n[n.formatOnType=50]="formatOnType",n[n.glyphMargin=51]="glyphMargin",n[n.gotoLocation=52]="gotoLocation",n[n.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",n[n.hover=54]="hover",n[n.inDiffEditor=55]="inDiffEditor",n[n.inlineSuggest=56]="inlineSuggest",n[n.letterSpacing=57]="letterSpacing",n[n.lightbulb=58]="lightbulb",n[n.lineDecorationsWidth=59]="lineDecorationsWidth",n[n.lineHeight=60]="lineHeight",n[n.lineNumbers=61]="lineNumbers",n[n.lineNumbersMinChars=62]="lineNumbersMinChars",n[n.linkedEditing=63]="linkedEditing",n[n.links=64]="links",n[n.matchBrackets=65]="matchBrackets",n[n.minimap=66]="minimap",n[n.mouseStyle=67]="mouseStyle",n[n.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=69]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",n[n.multiCursorModifier=71]="multiCursorModifier",n[n.multiCursorPaste=72]="multiCursorPaste",n[n.occurrencesHighlight=73]="occurrencesHighlight",n[n.overviewRulerBorder=74]="overviewRulerBorder",n[n.overviewRulerLanes=75]="overviewRulerLanes",n[n.padding=76]="padding",n[n.parameterHints=77]="parameterHints",n[n.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",n[n.quickSuggestions=80]="quickSuggestions",n[n.quickSuggestionsDelay=81]="quickSuggestionsDelay",n[n.readOnly=82]="readOnly",n[n.renameOnType=83]="renameOnType",n[n.renderControlCharacters=84]="renderControlCharacters",n[n.renderFinalNewline=85]="renderFinalNewline",n[n.renderLineHighlight=86]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=88]="renderValidationDecorations",n[n.renderWhitespace=89]="renderWhitespace",n[n.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",n[n.roundedSelection=91]="roundedSelection",n[n.rulers=92]="rulers",n[n.scrollbar=93]="scrollbar",n[n.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=95]="scrollBeyondLastLine",n[n.scrollPredominantAxis=96]="scrollPredominantAxis",n[n.selectionClipboard=97]="selectionClipboard",n[n.selectionHighlight=98]="selectionHighlight",n[n.selectOnLineNumbers=99]="selectOnLineNumbers",n[n.showFoldingControls=100]="showFoldingControls",n[n.showUnused=101]="showUnused",n[n.snippetSuggestions=102]="snippetSuggestions",n[n.smartSelect=103]="smartSelect",n[n.smoothScrolling=104]="smoothScrolling",n[n.stickyScroll=105]="stickyScroll",n[n.stickyTabStops=106]="stickyTabStops",n[n.stopRenderingLineAfter=107]="stopRenderingLineAfter",n[n.suggest=108]="suggest",n[n.suggestFontSize=109]="suggestFontSize",n[n.suggestLineHeight=110]="suggestLineHeight",n[n.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",n[n.suggestSelection=112]="suggestSelection",n[n.tabCompletion=113]="tabCompletion",n[n.tabIndex=114]="tabIndex",n[n.unicodeHighlighting=115]="unicodeHighlighting",n[n.unusualLineTerminators=116]="unusualLineTerminators",n[n.useShadowDOM=117]="useShadowDOM",n[n.useTabStops=118]="useTabStops",n[n.wordSeparators=119]="wordSeparators",n[n.wordWrap=120]="wordWrap",n[n.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=123]="wordWrapColumn",n[n.wordWrapOverride1=124]="wordWrapOverride1",n[n.wordWrapOverride2=125]="wordWrapOverride2",n[n.wrappingIndent=126]="wrappingIndent",n[n.wrappingStrategy=127]="wrappingStrategy",n[n.showDeprecated=128]="showDeprecated",n[n.inlayHints=129]="inlayHints",n[n.editorClassName=130]="editorClassName",n[n.pixelRatio=131]="pixelRatio",n[n.tabFocusMode=132]="tabFocusMode",n[n.layoutInfo=133]="layoutInfo",n[n.wrappingInfo=134]="wrappingInfo"})(u=r.EditorOption||(r.EditorOption={}));var m;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(m=r.EndOfLinePreference||(r.EndOfLinePreference={}));var w;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(w=r.EndOfLineSequence||(r.EndOfLineSequence={}));var L;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(L=r.IndentAction||(r.IndentAction={}));var S;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(S=r.InjectedTextCursorStops||(r.InjectedTextCursorStops={}));var b;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(b=r.InlayHintKind||(r.InlayHintKind={}));var s;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(s=r.InlineCompletionTriggerKind||(r.InlineCompletionTriggerKind={}));var i;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(i=r.KeyCode||(r.KeyCode={}));var o;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(o=r.MarkerSeverity||(r.MarkerSeverity={}));var _;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(_=r.MarkerTag||(r.MarkerTag={}));var c;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(c=r.MinimapPosition||(r.MinimapPosition={}));var a;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(a=r.MouseTargetType||(r.MouseTargetType={}));var h;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(h=r.OverlayWidgetPositionPreference||(r.OverlayWidgetPositionPreference={}));var g;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(g=r.OverviewRulerLane||(r.OverviewRulerLane={}));var A;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(A=r.PositionAffinity||(r.PositionAffinity={}));var M;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(M=r.RenderLineNumbersType||(r.RenderLineNumbersType={}));var D;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(D=r.RenderMinimap||(r.RenderMinimap={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P=r.ScrollType||(r.ScrollType={}));var B;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(B=r.ScrollbarVisibility||(r.ScrollbarVisibility={}));var q;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(q=r.SelectionDirection||(r.SelectionDirection={}));var H;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(H=r.SignatureHelpTriggerKind||(r.SignatureHelpTriggerKind={}));var W;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(W=r.SymbolKind||(r.SymbolKind={}));var F;(function(n){n[n.Deprecated=1]="Deprecated"})(F=r.SymbolTag||(r.SymbolTag={}));var U;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(U=r.TextEditorCursorBlinkingStyle||(r.TextEditorCursorBlinkingStyle={}));var T;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(T=r.TextEditorCursorStyle||(r.TextEditorCursorStyle={}));var O;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(O=r.TrackedRangeStickiness||(r.TrackedRangeStickiness={}));var j;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(j=r.WrappingIndent||(r.WrappingIndent={}))}),Y(X[47],Z([21,54]),function(k,r){return k.create("vs/base/common/platform",r)}),Y(X[5],Z([0,1,47]),function(k,r,N){"use strict";var e;Object.defineProperty(r,"__esModule",{value:!0}),r.isAndroid=r.isEdge=r.isSafari=r.isFirefox=r.isChrome=r.isLittleEndian=r.OS=r.setTimeout0=r.setTimeout0IsFaster=r.language=r.userAgent=r.isMobile=r.isIOS=r.isWebWorker=r.isWeb=r.isNative=r.isLinux=r.isMacintosh=r.isWindows=r.globals=r.LANGUAGE_DEFAULT=void 0,r.LANGUAGE_DEFAULT="en";let E=!1,f=!1,p=!1,C=!1,l=!1,d=!1,y=!1,t=!1,v=!1,u=!1,m,w=r.LANGUAGE_DEFAULT,L,S;r.globals=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof r.globals.vscode<"u"&&typeof r.globals.vscode.process<"u"?b=r.globals.vscode.process:typeof process<"u"&&(b=process);const s=typeof((e=b?.versions)===null||e===void 0?void 0:e.electron)=="string",i=s&&b?.type==="renderer";if(typeof navigator=="object"&&!i)S=navigator.userAgent,E=S.indexOf("Windows")>=0,f=S.indexOf("Macintosh")>=0,t=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,p=S.indexOf("Linux")>=0,u=S?.indexOf("Mobi")>=0,d=!0,m=N.getConfiguredDefaultLocale(N.localize(0,null))||r.LANGUAGE_DEFAULT,w=m;else if(typeof b=="object"){E=b.platform==="win32",f=b.platform==="darwin",p=b.platform==="linux",C=p&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,y=s,v=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=r.LANGUAGE_DEFAULT,w=r.LANGUAGE_DEFAULT;const h=b.env.VSCODE_NLS_CONFIG;if(h)try{const g=JSON.parse(h),A=g.availableLanguages["*"];m=g.locale,w=A||r.LANGUAGE_DEFAULT,L=g._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");let o=0;f?o=1:E?o=3:p&&(o=2),r.isWindows=E,r.isMacintosh=f,r.isLinux=p,r.isNative=l,r.isWeb=d,r.isWebWorker=d&&typeof r.globals.importScripts=="function",r.isIOS=t,r.isMobile=u,r.userAgent=S,r.language=w,r.setTimeout0IsFaster=typeof r.globals.postMessage=="function"&&!r.globals.importScripts,r.setTimeout0=(()=>{if(r.setTimeout0IsFaster){const h=[];r.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let M=0,D=h.length;M<D;M++){const P=h[M];if(P.id===A.data.vscodeScheduleAsyncWork){h.splice(M,1),P.callback();return}}});let g=0;return A=>{const M=++g;h.push({id:M,callback:A}),r.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return h=>setTimeout(h)})(),r.OS=f||t?2:E?1:3;let _=!0,c=!1;function a(){if(!c){c=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,_=new Uint16Array(h.buffer)[0]===(2<<8)+1}return _}r.isLittleEndian=a,r.isChrome=!!(r.userAgent&&r.userAgent.indexOf("Chrome")>=0),r.isFirefox=!!(r.userAgent&&r.userAgent.indexOf("Firefox")>=0),r.isSafari=!!(!r.isChrome&&r.userAgent&&r.userAgent.indexOf("Safari")>=0),r.isEdge=!!(r.userAgent&&r.userAgent.indexOf("Edg/")>=0),r.isAndroid=!!(r.userAgent&&r.userAgent.indexOf("Android")>=0)}),Y(X[48],Z([0,1,5]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.platform=r.env=r.cwd=void 0;let e;if(typeof N.globals.vscode<"u"&&typeof N.globals.vscode.process<"u"){const E=N.globals.vscode.process;e={get platform(){return E.platform},get arch(){return E.arch},get env(){return E.env},cwd(){return E.cwd()}}}else typeof process<"u"?e={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:e={get platform(){return N.isWindows?"win32":N.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};r.cwd=e.cwd,r.env=e.env,r.platform=e.platform}),Y(X[49],Z([0,1,48]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.sep=r.extname=r.basename=r.dirname=r.relative=r.resolve=r.normalize=r.posix=r.win32=void 0;const e=65,E=97,f=90,p=122,C=46,l=47,d=92,y=58,t=63;class v extends Error{constructor(i,o,_){let c;typeof o=="string"&&o.indexOf("not ")===0?(c="must not be",o=o.replace(/^not /,"")):c="must be";const a=i.indexOf(".")!==-1?"property":"argument";let h=`The "${i}" ${a} ${c} of type ${o}`;h+=`. Received type ${typeof _}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function u(s,i){if(typeof s!="string")throw new v(i,"string",s)}function m(s){return s===l||s===d}function w(s){return s===l}function L(s){return s>=e&&s<=f||s>=E&&s<=p}function S(s,i,o,_){let c="",a=0,h=-1,g=0,A=0;for(let M=0;M<=s.length;++M){if(M<s.length)A=s.charCodeAt(M);else{if(_(A))break;A=l}if(_(A)){if(!(h===M-1||g===1))if(g===2){if(c.length<2||a!==2||c.charCodeAt(c.length-1)!==C||c.charCodeAt(c.length-2)!==C){if(c.length>2){const D=c.lastIndexOf(o);D===-1?(c="",a=0):(c=c.slice(0,D),a=c.length-1-c.lastIndexOf(o)),h=M,g=0;continue}else if(c.length!==0){c="",a=0,h=M,g=0;continue}}i&&(c+=c.length>0?`${o}..`:"..",a=2)}else c.length>0?c+=`${o}${s.slice(h+1,M)}`:c=s.slice(h+1,M),a=M-h-1;h=M,g=0}else A===C&&g!==-1?++g:g=-1}return c}function b(s,i){if(i===null||typeof i!="object")throw new v("pathObject","Object",i);const o=i.dir||i.root,_=i.base||`${i.name||""}${i.ext||""}`;return o?o===i.root?`${o}${_}`:`${o}${s}${_}`:_}r.win32={resolve(...s){let i="",o="",_=!1;for(let c=s.length-1;c>=-1;c--){let a;if(c>=0){if(a=s[c],u(a,"path"),a.length===0)continue}else i.length===0?a=N.cwd():(a=N.env[`=${i}`]||N.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==i.toLowerCase()&&a.charCodeAt(2)===d)&&(a=`${i}\\`));const h=a.length;let g=0,A="",M=!1;const D=a.charCodeAt(0);if(h===1)m(D)&&(g=1,M=!0);else if(m(D))if(M=!0,m(a.charCodeAt(1))){let P=2,B=P;for(;P<h&&!m(a.charCodeAt(P));)P++;if(P<h&&P!==B){const q=a.slice(B,P);for(B=P;P<h&&m(a.charCodeAt(P));)P++;if(P<h&&P!==B){for(B=P;P<h&&!m(a.charCodeAt(P));)P++;(P===h||P!==B)&&(A=`\\\\${q}\\${a.slice(B,P)}`,g=P)}}}else g=1;else L(D)&&a.charCodeAt(1)===y&&(A=a.slice(0,2),g=2,h>2&&m(a.charCodeAt(2))&&(M=!0,g=3));if(A.length>0)if(i.length>0){if(A.toLowerCase()!==i.toLowerCase())continue}else i=A;if(_){if(i.length>0)break}else if(o=`${a.slice(g)}\\${o}`,_=M,M&&i.length>0)break}return o=S(o,!_,"\\",m),_?`${i}\\${o}`:`${i}${o}`||"."},normalize(s){u(s,"path");const i=s.length;if(i===0)return".";let o=0,_,c=!1;const a=s.charCodeAt(0);if(i===1)return w(a)?"\\":s;if(m(a))if(c=!0,m(s.charCodeAt(1))){let g=2,A=g;for(;g<i&&!m(s.charCodeAt(g));)g++;if(g<i&&g!==A){const M=s.slice(A,g);for(A=g;g<i&&m(s.charCodeAt(g));)g++;if(g<i&&g!==A){for(A=g;g<i&&!m(s.charCodeAt(g));)g++;if(g===i)return`\\\\${M}\\${s.slice(A)}\\`;g!==A&&(_=`\\\\${M}\\${s.slice(A,g)}`,o=g)}}}else o=1;else L(a)&&s.charCodeAt(1)===y&&(_=s.slice(0,2),o=2,i>2&&m(s.charCodeAt(2))&&(c=!0,o=3));let h=o<i?S(s.slice(o),!c,"\\",m):"";return h.length===0&&!c&&(h="."),h.length>0&&m(s.charCodeAt(i-1))&&(h+="\\"),_===void 0?c?`\\${h}`:h:c?`${_}\\${h}`:`${_}${h}`},isAbsolute(s){u(s,"path");const i=s.length;if(i===0)return!1;const o=s.charCodeAt(0);return m(o)||i>2&&L(o)&&s.charCodeAt(1)===y&&m(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let i,o;for(let a=0;a<s.length;++a){const h=s[a];u(h,"path"),h.length>0&&(i===void 0?i=o=h:i+=`\\${h}`)}if(i===void 0)return".";let _=!0,c=0;if(typeof o=="string"&&m(o.charCodeAt(0))){++c;const a=o.length;a>1&&m(o.charCodeAt(1))&&(++c,a>2&&(m(o.charCodeAt(2))?++c:_=!1))}if(_){for(;c<i.length&&m(i.charCodeAt(c));)c++;c>=2&&(i=`\\${i.slice(c)}`)}return r.win32.normalize(i)},relative(s,i){if(u(s,"from"),u(i,"to"),s===i)return"";const o=r.win32.resolve(s),_=r.win32.resolve(i);if(o===_||(s=o.toLowerCase(),i=_.toLowerCase(),s===i))return"";let c=0;for(;c<s.length&&s.charCodeAt(c)===d;)c++;let a=s.length;for(;a-1>c&&s.charCodeAt(a-1)===d;)a--;const h=a-c;let g=0;for(;g<i.length&&i.charCodeAt(g)===d;)g++;let A=i.length;for(;A-1>g&&i.charCodeAt(A-1)===d;)A--;const M=A-g,D=h<M?h:M;let P=-1,B=0;for(;B<D;B++){const H=s.charCodeAt(c+B);if(H!==i.charCodeAt(g+B))break;H===d&&(P=B)}if(B!==D){if(P===-1)return _}else{if(M>D){if(i.charCodeAt(g+B)===d)return _.slice(g+B+1);if(B===2)return _.slice(g+B)}h>D&&(s.charCodeAt(c+B)===d?P=B:B===2&&(P=3)),P===-1&&(P=0)}let q="";for(B=c+P+1;B<=a;++B)(B===a||s.charCodeAt(B)===d)&&(q+=q.length===0?"..":"\\..");return g+=P,q.length>0?`${q}${_.slice(g,A)}`:(_.charCodeAt(g)===d&&++g,_.slice(g,A))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const i=r.win32.resolve(s);if(i.length<=2)return s;if(i.charCodeAt(0)===d){if(i.charCodeAt(1)===d){const o=i.charCodeAt(2);if(o!==t&&o!==C)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(L(i.charCodeAt(0))&&i.charCodeAt(1)===y&&i.charCodeAt(2)===d)return`\\\\?\\${i}`;return s},dirname(s){u(s,"path");const i=s.length;if(i===0)return".";let o=-1,_=0;const c=s.charCodeAt(0);if(i===1)return m(c)?s:".";if(m(c)){if(o=_=1,m(s.charCodeAt(1))){let g=2,A=g;for(;g<i&&!m(s.charCodeAt(g));)g++;if(g<i&&g!==A){for(A=g;g<i&&m(s.charCodeAt(g));)g++;if(g<i&&g!==A){for(A=g;g<i&&!m(s.charCodeAt(g));)g++;if(g===i)return s;g!==A&&(o=_=g+1)}}}}else L(c)&&s.charCodeAt(1)===y&&(o=i>2&&m(s.charCodeAt(2))?3:2,_=o);let a=-1,h=!0;for(let g=i-1;g>=_;--g)if(m(s.charCodeAt(g))){if(!h){a=g;break}}else h=!1;if(a===-1){if(o===-1)return".";a=o}return s.slice(0,a)},basename(s,i){i!==void 0&&u(i,"ext"),u(s,"path");let o=0,_=-1,c=!0,a;if(s.length>=2&&L(s.charCodeAt(0))&&s.charCodeAt(1)===y&&(o=2),i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let h=i.length-1,g=-1;for(a=s.length-1;a>=o;--a){const A=s.charCodeAt(a);if(m(A)){if(!c){o=a+1;break}}else g===-1&&(c=!1,g=a+1),h>=0&&(A===i.charCodeAt(h)?--h===-1&&(_=a):(h=-1,_=g))}return o===_?_=g:_===-1&&(_=s.length),s.slice(o,_)}for(a=s.length-1;a>=o;--a)if(m(s.charCodeAt(a))){if(!c){o=a+1;break}}else _===-1&&(c=!1,_=a+1);return _===-1?"":s.slice(o,_)},extname(s){u(s,"path");let i=0,o=-1,_=0,c=-1,a=!0,h=0;s.length>=2&&s.charCodeAt(1)===y&&L(s.charCodeAt(0))&&(i=_=2);for(let g=s.length-1;g>=i;--g){const A=s.charCodeAt(g);if(m(A)){if(!a){_=g+1;break}continue}c===-1&&(a=!1,c=g+1),A===C?o===-1?o=g:h!==1&&(h=1):o!==-1&&(h=-1)}return o===-1||c===-1||h===0||h===1&&o===c-1&&o===_+1?"":s.slice(o,c)},format:b.bind(null,"\\"),parse(s){u(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const o=s.length;let _=0,c=s.charCodeAt(0);if(o===1)return m(c)?(i.root=i.dir=s,i):(i.base=i.name=s,i);if(m(c)){if(_=1,m(s.charCodeAt(1))){let P=2,B=P;for(;P<o&&!m(s.charCodeAt(P));)P++;if(P<o&&P!==B){for(B=P;P<o&&m(s.charCodeAt(P));)P++;if(P<o&&P!==B){for(B=P;P<o&&!m(s.charCodeAt(P));)P++;P===o?_=P:P!==B&&(_=P+1)}}}}else if(L(c)&&s.charCodeAt(1)===y){if(o<=2)return i.root=i.dir=s,i;if(_=2,m(s.charCodeAt(2))){if(o===3)return i.root=i.dir=s,i;_=3}}_>0&&(i.root=s.slice(0,_));let a=-1,h=_,g=-1,A=!0,M=s.length-1,D=0;for(;M>=_;--M){if(c=s.charCodeAt(M),m(c)){if(!A){h=M+1;break}continue}g===-1&&(A=!1,g=M+1),c===C?a===-1?a=M:D!==1&&(D=1):a!==-1&&(D=-1)}return g!==-1&&(a===-1||D===0||D===1&&a===g-1&&a===h+1?i.base=i.name=s.slice(h,g):(i.name=s.slice(h,a),i.base=s.slice(h,g),i.ext=s.slice(a,g))),h>0&&h!==_?i.dir=s.slice(0,h-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},r.posix={resolve(...s){let i="",o=!1;for(let _=s.length-1;_>=-1&&!o;_--){const c=_>=0?s[_]:N.cwd();u(c,"path"),c.length!==0&&(i=`${c}/${i}`,o=c.charCodeAt(0)===l)}return i=S(i,!o,"/",w),o?`/${i}`:i.length>0?i:"."},normalize(s){if(u(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===l,o=s.charCodeAt(s.length-1)===l;return s=S(s,!i,"/",w),s.length===0?i?"/":o?"./":".":(o&&(s+="/"),i?`/${s}`:s)},isAbsolute(s){return u(s,"path"),s.length>0&&s.charCodeAt(0)===l},join(...s){if(s.length===0)return".";let i;for(let o=0;o<s.length;++o){const _=s[o];u(_,"path"),_.length>0&&(i===void 0?i=_:i+=`/${_}`)}return i===void 0?".":r.posix.normalize(i)},relative(s,i){if(u(s,"from"),u(i,"to"),s===i||(s=r.posix.resolve(s),i=r.posix.resolve(i),s===i))return"";const o=1,_=s.length,c=_-o,a=1,h=i.length-a,g=c<h?c:h;let A=-1,M=0;for(;M<g;M++){const P=s.charCodeAt(o+M);if(P!==i.charCodeAt(a+M))break;P===l&&(A=M)}if(M===g)if(h>g){if(i.charCodeAt(a+M)===l)return i.slice(a+M+1);if(M===0)return i.slice(a+M)}else c>g&&(s.charCodeAt(o+M)===l?A=M:M===0&&(A=0));let D="";for(M=o+A+1;M<=_;++M)(M===_||s.charCodeAt(M)===l)&&(D+=D.length===0?"..":"/..");return`${D}${i.slice(a+A)}`},toNamespacedPath(s){return s},dirname(s){if(u(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===l;let o=-1,_=!0;for(let c=s.length-1;c>=1;--c)if(s.charCodeAt(c)===l){if(!_){o=c;break}}else _=!1;return o===-1?i?"/":".":i&&o===1?"//":s.slice(0,o)},basename(s,i){i!==void 0&&u(i,"ext"),u(s,"path");let o=0,_=-1,c=!0,a;if(i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let h=i.length-1,g=-1;for(a=s.length-1;a>=0;--a){const A=s.charCodeAt(a);if(A===l){if(!c){o=a+1;break}}else g===-1&&(c=!1,g=a+1),h>=0&&(A===i.charCodeAt(h)?--h===-1&&(_=a):(h=-1,_=g))}return o===_?_=g:_===-1&&(_=s.length),s.slice(o,_)}for(a=s.length-1;a>=0;--a)if(s.charCodeAt(a)===l){if(!c){o=a+1;break}}else _===-1&&(c=!1,_=a+1);return _===-1?"":s.slice(o,_)},extname(s){u(s,"path");let i=-1,o=0,_=-1,c=!0,a=0;for(let h=s.length-1;h>=0;--h){const g=s.charCodeAt(h);if(g===l){if(!c){o=h+1;break}continue}_===-1&&(c=!1,_=h+1),g===C?i===-1?i=h:a!==1&&(a=1):i!==-1&&(a=-1)}return i===-1||_===-1||a===0||a===1&&i===_-1&&i===o+1?"":s.slice(i,_)},format:b.bind(null,"/"),parse(s){u(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const o=s.charCodeAt(0)===l;let _;o?(i.root="/",_=1):_=0;let c=-1,a=0,h=-1,g=!0,A=s.length-1,M=0;for(;A>=_;--A){const D=s.charCodeAt(A);if(D===l){if(!g){a=A+1;break}continue}h===-1&&(g=!1,h=A+1),D===C?c===-1?c=A:M!==1&&(M=1):c!==-1&&(M=-1)}if(h!==-1){const D=a===0&&o?1:a;c===-1||M===0||M===1&&c===h-1&&c===a+1?i.base=i.name=s.slice(D,h):(i.name=s.slice(D,c),i.base=s.slice(D,h),i.ext=s.slice(c,h))}return a>0?i.dir=s.slice(0,a-1):o&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},r.posix.win32=r.win32.win32=r.win32,r.posix.posix=r.win32.posix=r.posix,r.normalize=N.platform==="win32"?r.win32.normalize:r.posix.normalize,r.resolve=N.platform==="win32"?r.win32.resolve:r.posix.resolve,r.relative=N.platform==="win32"?r.win32.relative:r.posix.relative,r.dirname=N.platform==="win32"?r.win32.dirname:r.posix.dirname,r.basename=N.platform==="win32"?r.win32.basename:r.posix.basename,r.extname=N.platform==="win32"?r.win32.extname:r.posix.extname,r.sep=N.platform==="win32"?r.win32.sep:r.posix.sep}),Y(X[20],Z([0,1,5]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.StopWatch=void 0;const e=N.globals.performance&&typeof N.globals.performance.now=="function";class E{static create(p=!0){return new E(p)}constructor(p){this._highResolution=e&&p,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?N.globals.performance.now():Date.now()}}r.StopWatch=E}),Y(X[6],Z([0,1,7,9,14,20]),function(k,r,N,e,E,f){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Relay=r.EventBufferer=r.MicrotaskEmitter=r.DebounceEmitter=r.PauseableEmitter=r.EventDeliveryQueue=r.Emitter=r.EventProfiling=r.Event=void 0;const p=!1,C=!1;var l;(function(c){c.None=()=>e.Disposable.None;function a(K){if(C){const{onListenerDidAdd:$}=K,G=v.create();let Q=0;K.onListenerDidAdd=()=>{++Q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),$?.()}}}function h(K){return($,G=null,Q)=>{let x=!1,ee;return ee=K(te=>{if(!x)return ee?ee.dispose():x=!0,$.call(G,te)},null,Q),x&&ee.dispose(),ee}}c.once=h;function g(K,$,G){return q((Q,x=null,ee)=>K(te=>Q.call(x,$(te)),null,ee),G)}c.map=g;function A(K,$,G){return q((Q,x=null,ee)=>K(te=>{$(te),Q.call(x,te)},null,ee),G)}c.forEach=A;function M(K,$,G){return q((Q,x=null,ee)=>K(te=>$(te)&&Q.call(x,te),null,ee),G)}c.filter=M;function D(K){return K}c.signal=D;function P(...K){return($,G=null,Q)=>(0,e.combinedDisposable)(...K.map(x=>x(ee=>$.call(G,ee),null,Q)))}c.any=P;function B(K,$,G,Q){let x=G;return g(K,ee=>(x=$(x,ee),x),Q)}c.reduce=B;function q(K,$){let G;const Q={onFirstListenerAdd(){G=K(x.fire,x)},onLastListenerRemove(){G?.dispose()}};$||a(Q);const x=new m(Q);return $?.add(x),x.event}function H(K,$,G=100,Q=!1,x,ee){let te,ae,be,ue=0;const ve={leakWarningThreshold:x,onFirstListenerAdd(){te=K(Se=>{ue++,ae=$(ae,Se),Q&&!be&&(Ce.fire(ae),ae=void 0),clearTimeout(be),be=setTimeout(()=>{const Ae=ae;ae=void 0,be=void 0,(!Q||ue>1)&&Ce.fire(Ae),ue=0},G)})},onLastListenerRemove(){te.dispose()}};ee||a(ve);const Ce=new m(ve);return ee?.add(Ce),Ce.event}c.debounce=H;function W(K,$=(Q,x)=>Q===x,G){let Q=!0,x;return M(K,ee=>{const te=Q||!$(ee,x);return Q=!1,x=ee,te},G)}c.latch=W;function F(K,$,G){return[c.filter(K,$,G),c.filter(K,Q=>!$(Q),G)]}c.split=F;function U(K,$=!1,G=[]){let Q=G.slice(),x=K(ae=>{Q?Q.push(ae):te.fire(ae)});const ee=()=>{Q?.forEach(ae=>te.fire(ae)),Q=null},te=new m({onFirstListenerAdd(){x||(x=K(ae=>te.fire(ae)))},onFirstListenerDidAdd(){Q&&($?setTimeout(ee):ee())},onLastListenerRemove(){x&&x.dispose(),x=null}});return te.event}c.buffer=U;class T{constructor($){this.event=$,this.disposables=new e.DisposableStore}map($){return new T(g(this.event,$,this.disposables))}forEach($){return new T(A(this.event,$,this.disposables))}filter($){return new T(M(this.event,$,this.disposables))}reduce($,G){return new T(B(this.event,$,G,this.disposables))}latch(){return new T(W(this.event,void 0,this.disposables))}debounce($,G=100,Q=!1,x){return new T(H(this.event,$,G,Q,x,this.disposables))}on($,G,Q){return this.event($,G,Q)}once($,G,Q){return h(this.event)($,G,Q)}dispose(){this.disposables.dispose()}}function O(K){return new T(K)}c.chain=O;function j(K,$,G=Q=>Q){const Q=(...ae)=>te.fire(G(...ae)),x=()=>K.on($,Q),ee=()=>K.removeListener($,Q),te=new m({onFirstListenerAdd:x,onLastListenerRemove:ee});return te.event}c.fromNodeEventEmitter=j;function n(K,$,G=Q=>Q){const Q=(...ae)=>te.fire(G(...ae)),x=()=>K.addEventListener($,Q),ee=()=>K.removeEventListener($,Q),te=new m({onFirstListenerAdd:x,onLastListenerRemove:ee});return te.event}c.fromDOMEventEmitter=n;function se(K){return new Promise($=>h(K)($))}c.toPromise=se;function ge(K,$){return $(void 0),K(G=>$(G))}c.runAndSubscribe=ge;function me(K,$){let G=null;function Q(ee){G?.dispose(),G=new e.DisposableStore,$(ee,G)}Q(void 0);const x=K(ee=>Q(ee));return(0,e.toDisposable)(()=>{x.dispose(),G?.dispose()})}c.runAndSubscribeWithStore=me;class Le{constructor($,G){this.obs=$,this._counter=0,this._hasChanged=!1;const Q={onFirstListenerAdd:()=>{$.addObserver(this)},onLastListenerRemove:()=>{$.removeObserver(this)}};G||a(Q),this.emitter=new m(Q),G&&G.add(this.emitter)}beginUpdate($){this._counter++}handleChange($,G){this._hasChanged=!0}endUpdate($){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function ye(K,$){return new Le(K,$).emitter.event}c.fromObservable=ye})(l=r.Event||(r.Event={}));class d{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${d._idPool++}`,d.all.add(this)}start(a){this._stopWatch=new f.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}r.EventProfiling=d,d.all=new Set,d._idPool=0;let y=-1;class t{constructor(a,h=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,h){let g=y;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),g<=0||h<g)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let M,D=0;for(const[P,B]of this._stacks)(!M||D<B)&&(M=P,D=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${D}):`),console.warn(M)}return()=>{const M=this._stacks.get(a.value)||0;this._stacks.set(a.value,M-1)}}}class v{static create(){var a;return new v((a=new Error().stack)!==null&&a!==void 0?a:"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u{constructor(a,h,g){this.callback=a,this.callbackThis=h,this.stack=g,this.subscription=new e.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class m{constructor(a){var h,g;this._disposed=!1,this._options=a,this._leakageMon=y>0?new t(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=!((h=this._options)===null||h===void 0)&&h._profName?new d(this._options._profName):void 0,this._deliveryQueue=(g=this._options)===null||g===void 0?void 0:g.deliveryQueue}dispose(){var a,h,g,A;if(!this._disposed){if(this._disposed=!0,this._listeners){if(p){const M=Array.from(this._listeners);queueMicrotask(()=>{var D;for(const P of M)P.subscription.isset()&&(P.subscription.unset(),(D=P.stack)===null||D===void 0||D.print())})}this._listeners.clear()}(a=this._deliveryQueue)===null||a===void 0||a.clear(this),(g=(h=this._options)===null||h===void 0?void 0:h.onLastListenerRemove)===null||g===void 0||g.call(h),(A=this._leakageMon)===null||A===void 0||A.dispose()}}get event(){return this._event||(this._event=(a,h,g)=>{var A,M,D;this._listeners||(this._listeners=new E.LinkedList);const P=this._listeners.isEmpty();P&&((A=this._options)===null||A===void 0?void 0:A.onFirstListenerAdd)&&this._options.onFirstListenerAdd(this);let B,q;this._leakageMon&&this._listeners.size>=30&&(q=v.create(),B=this._leakageMon.check(q,this._listeners.size+1)),p&&(q=q??v.create());const H=new u(a,h,q),W=this._listeners.push(H);P&&((M=this._options)===null||M===void 0?void 0:M.onFirstListenerDidAdd)&&this._options.onFirstListenerDidAdd(this),!((D=this._options)===null||D===void 0)&&D.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,h);const F=H.subscription.set(()=>{B?.(),this._disposed||(W(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return g instanceof e.DisposableStore?g.add(F):Array.isArray(g)&&g.push(F),F}),this._event}fire(a){var h,g;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L);for(const A of this._listeners)this._deliveryQueue.push(this,A,a);(h=this._perfMon)===null||h===void 0||h.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),(g=this._perfMon)===null||g===void 0||g.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}r.Emitter=m;class w{constructor(){this._queue=new E.LinkedList}get size(){return this._queue.size}push(a,h,g){this._queue.push(new S(a,h,g))}clear(a){const h=new E.LinkedList;for(const g of this._queue)g.emitter!==a&&h.push(g);this._queue=h}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(h){(0,N.onUnexpectedError)(h)}}}}r.EventDeliveryQueue=w;class L extends w{clear(a){this._queue.clear()}}class S{constructor(a,h,g){this.emitter=a,this.listener=h,this.event=g}}class b extends m{constructor(a){super(a),this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}r.PauseableEmitter=b;class s extends b{constructor(a){var h;super(a),this._delay=(h=a.delay)!==null&&h!==void 0?h:100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}r.DebounceEmitter=s;class i extends m{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(h=>super.fire(h)),this._queuedEvents=[]}))}}r.MicrotaskEmitter=i;class o{constructor(){this.buffers=[]}wrapEvent(a){return(h,g,A)=>a(M=>{const D=this.buffers[this.buffers.length-1];D?D.push(()=>h.call(g,M)):h.call(g,M)},void 0,A)}bufferEvents(a){const h=[];this.buffers.push(h);const g=a();return this.buffers.pop(),h.forEach(A=>A()),g}}r.EventBufferer=o;class _{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=e.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}r.Relay=_}),Y(X[50],Z([0,1,6]),function(k,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CancellationTokenSource=r.CancellationToken=void 0;const e=Object.freeze(function(C,l){const d=setTimeout(C.bind(l),0);return{dispose(){clearTimeout(d)}}});var E;(function(C){function l(d){return d===C.None||d===C.Cancelled||d instanceof f?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}C.isCancellationToken=l,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:N.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(E=r.CancellationToken||(r.CancellationToken={}));class f{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?e:(this._emitter||(this._emitter=new N.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class p{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new f),this._token}cancel(){this._token?this._token instanceof f&&this._token.cancel():this._token=E.Cancelled}dispose(l=!1){var d;l&&this.cancel(),(d=this._parentListener)===null||d===void 0||d.dispose(),this._token?this._token instanceof f&&this._token.dispose():this._token=E.None}}r.CancellationTokenSource=p}),Y(X[12],Z([0,1,49,5]),function(k,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.uriToFsPath=r.URI=void 0;const E=/^\w[\w\d+.-]*$/,f=/^\//,p=/^\/\//;function C(a,h){if(!a.scheme&&h)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!E.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!f.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(a,h){return!a&&!h?"file":a}function d(a,h){switch(a){case"https":case"http":case"file":h?h[0]!==t&&(h=t+h):h=t;break}return h}const y="",t="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(h){return h instanceof u?!0:h?typeof h.authority=="string"&&typeof h.fragment=="string"&&typeof h.path=="string"&&typeof h.query=="string"&&typeof h.scheme=="string"&&typeof h.fsPath=="string"&&typeof h.with=="function"&&typeof h.toString=="function":!1}constructor(h,g,A,M,D,P=!1){typeof h=="object"?(this.scheme=h.scheme||y,this.authority=h.authority||y,this.path=h.path||y,this.query=h.query||y,this.fragment=h.fragment||y):(this.scheme=l(h,P),this.authority=g||y,this.path=d(this.scheme,A||y),this.query=M||y,this.fragment=D||y,C(this,P))}get fsPath(){return s(this,!1)}with(h){if(!h)return this;let{scheme:g,authority:A,path:M,query:D,fragment:P}=h;return g===void 0?g=this.scheme:g===null&&(g=y),A===void 0?A=this.authority:A===null&&(A=y),M===void 0?M=this.path:M===null&&(M=y),D===void 0?D=this.query:D===null&&(D=y),P===void 0?P=this.fragment:P===null&&(P=y),g===this.scheme&&A===this.authority&&M===this.path&&D===this.query&&P===this.fragment?this:new w(g,A,M,D,P)}static parse(h,g=!1){const A=v.exec(h);return A?new w(A[2]||y,c(A[4]||y),c(A[5]||y),c(A[7]||y),c(A[9]||y),g):new w(y,y,y,y,y)}static file(h){let g=y;if(e.isWindows&&(h=h.replace(/\\/g,t)),h[0]===t&&h[1]===t){const A=h.indexOf(t,2);A===-1?(g=h.substring(2),h=t):(g=h.substring(2,A),h=h.substring(A)||t)}return new w("file",g,h,y,y)}static from(h){const g=new w(h.scheme,h.authority,h.path,h.query,h.fragment);return C(g,!0),g}static joinPath(h,...g){if(!h.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return e.isWindows&&h.scheme==="file"?A=u.file(N.win32.join(s(h,!0),...g)).path:A=N.posix.join(h.path,...g),h.with({path:A})}toString(h=!1){return i(this,h)}toJSON(){return this}static revive(h){if(h){if(h instanceof u)return h;{const g=new w(h);return g._formatted=h.external,g._fsPath=h._sep===m?h.fsPath:null,g}}else return h}}r.URI=u;const m=e.isWindows?1:void 0;class w extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(h=!1){return h?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const h={$mid:1};return this._fsPath&&(h.fsPath=this._fsPath,h._sep=m),this._formatted&&(h.external=this._formatted),this.path&&(h.path=this.path),this.scheme&&(h.scheme=this.scheme),this.authority&&(h.authority=this.authority),this.query&&(h.query=this.query),this.fragment&&(h.fragment=this.fragment),h}}const L={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(a,h){let g,A=-1;for(let M=0;M<a.length;M++){const D=a.charCodeAt(M);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||h&&D===47)A!==-1&&(g+=encodeURIComponent(a.substring(A,M)),A=-1),g!==void 0&&(g+=a.charAt(M));else{g===void 0&&(g=a.substr(0,M));const P=L[D];P!==void 0?(A!==-1&&(g+=encodeURIComponent(a.substring(A,M)),A=-1),g+=P):A===-1&&(A=M)}}return A!==-1&&(g+=encodeURIComponent(a.substring(A))),g!==void 0?g:a}function b(a){let h;for(let g=0;g<a.length;g++){const A=a.charCodeAt(g);A===35||A===63?(h===void 0&&(h=a.substr(0,g)),h+=L[A]):h!==void 0&&(h+=a[g])}return h!==void 0?h:a}function s(a,h){let g;return a.authority&&a.path.length>1&&a.scheme==="file"?g=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?h?g=a.path.substr(1):g=a.path[1].toLowerCase()+a.path.substr(2):g=a.path,e.isWindows&&(g=g.replace(/\//g,"\\")),g}r.uriToFsPath=s;function i(a,h){const g=h?b:S;let A="",{scheme:M,authority:D,path:P,query:B,fragment:q}=a;if(M&&(A+=M,A+=":"),(D||M==="file")&&(A+=t,A+=t),D){let H=D.indexOf("@");if(H!==-1){const W=D.substr(0,H);D=D.substr(H+1),H=W.indexOf(":"),H===-1?A+=g(W,!1):(A+=g(W.substr(0,H),!1),A+=":",A+=g(W.substr(H+1),!1)),A+="@"}D=D.toLowerCase(),H=D.indexOf(":"),H===-1?A+=g(D,!1):(A+=g(D.substr(0,H),!1),A+=D.substr(H))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const H=P.charCodeAt(1);H>=65&&H<=90&&(P=`/${String.fromCharCode(H+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const H=P.charCodeAt(0);H>=65&&H<=90&&(P=`${String.fromCharCode(H+32)}:${P.substr(2)}`)}A+=g(P,!0)}return B&&(A+="?",A+=g(B,!1)),q&&(A+="#",A+=h?q:S(q,!1)),A}function o(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+o(a.substr(3)):a}}const _=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(a){return a.match(_)?a.replace(_,h=>o(h)):a}}),Y(X[55],Z([0,1,7,6,9,10,5,4]),function(k,r,N,e,E,f,p,C){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.SimpleWorkerServer=r.SimpleWorkerClient=r.logOnceWebWorkerWarning=void 0;const l="$initialize";let d=!1;function y(c){!p.isWeb||(d||(d=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(c.message))}r.logOnceWebWorkerWarning=y;class t{constructor(a,h,g,A){this.vsWorker=a,this.req=h,this.method=g,this.args=A,this.type=0}}class v{constructor(a,h,g,A){this.vsWorker=a,this.seq=h,this.res=g,this.err=A,this.type=1}}class u{constructor(a,h,g,A){this.vsWorker=a,this.req=h,this.eventName=g,this.arg=A,this.type=2}}class m{constructor(a,h,g){this.vsWorker=a,this.req=h,this.event=g,this.type=3}}class w{constructor(a,h){this.vsWorker=a,this.req=h,this.type=4}}class L{constructor(a){this._workerId=-1,this._handler=a,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(a){this._workerId=a}sendMessage(a,h){const g=String(++this._lastSentReq);return new Promise((A,M)=>{this._pendingReplies[g]={resolve:A,reject:M},this._send(new t(this._workerId,g,a,h))})}listen(a,h){let g=null;const A=new e.Emitter({onFirstListenerAdd:()=>{g=String(++this._lastSentReq),this._pendingEmitters.set(g,A),this._send(new u(this._workerId,g,a,h))},onLastListenerRemove:()=>{this._pendingEmitters.delete(g),this._send(new w(this._workerId,g)),g=null}});return A.event}handleMessage(a){!a||!a.vsWorker||this._workerId!==-1&&a.vsWorker!==this._workerId||this._handleMessage(a)}_handleMessage(a){switch(a.type){case 1:return this._handleReplyMessage(a);case 0:return this._handleRequestMessage(a);case 2:return this._handleSubscribeEventMessage(a);case 3:return this._handleEventMessage(a);case 4:return this._handleUnsubscribeEventMessage(a)}}_handleReplyMessage(a){if(!this._pendingReplies[a.seq]){console.warn("Got reply to unknown seq");return}const h=this._pendingReplies[a.seq];if(delete this._pendingReplies[a.seq],a.err){let g=a.err;a.err.$isError&&(g=new Error,g.name=a.err.name,g.message=a.err.message,g.stack=a.err.stack),h.reject(g);return}h.resolve(a.res)}_handleRequestMessage(a){const h=a.req;this._handler.handleMessage(a.method,a.args).then(A=>{this._send(new v(this._workerId,h,A,void 0))},A=>{A.detail instanceof Error&&(A.detail=(0,N.transformErrorForSerialization)(A.detail)),this._send(new v(this._workerId,h,void 0,(0,N.transformErrorForSerialization)(A)))})}_handleSubscribeEventMessage(a){const h=a.req,g=this._handler.handleEvent(a.eventName,a.arg)(A=>{this._send(new m(this._workerId,h,A))});this._pendingEvents.set(h,g)}_handleEventMessage(a){if(!this._pendingEmitters.has(a.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(a.req).fire(a.event)}_handleUnsubscribeEventMessage(a){if(!this._pendingEvents.has(a.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(a.req).dispose(),this._pendingEvents.delete(a.req)}_send(a){const h=[];if(a.type===0)for(let g=0;g<a.args.length;g++)a.args[g]instanceof ArrayBuffer&&h.push(a.args[g]);else a.type===1&&a.res instanceof ArrayBuffer&&h.push(a.res);this._handler.sendMessage(a,h)}}class S extends E.Disposable{constructor(a,h,g){super();let A=null;this._worker=this._register(a.create("vs/base/common/worker/simpleWorker",q=>{this._protocol.handleMessage(q)},q=>{A?.(q)})),this._protocol=new L({sendMessage:(q,H)=>{this._worker.postMessage(q,H)},handleMessage:(q,H)=>{if(typeof g[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(g[q].apply(g,H))}catch(W){return Promise.reject(W)}},handleEvent:(q,H)=>{if(s(q)){const W=g[q].call(g,H);if(typeof W!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return W}if(b(q)){const W=g[q];if(typeof W!="function")throw new Error(`Missing event ${q} on main thread host.`);return W}throw new Error(`Malformed event name ${q}`)}}),this._protocol.setWorkerId(this._worker.getId());let M=null;typeof p.globals.require<"u"&&typeof p.globals.require.getConfig=="function"?M=p.globals.require.getConfig():typeof p.globals.requirejs<"u"&&(M=p.globals.requirejs.s.contexts._.config);const D=(0,f.getAllMethodNames)(g);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(M)),h,D]);const P=(q,H)=>this._request(q,H),B=(q,H)=>this._protocol.listen(q,H);this._lazyProxy=new Promise((q,H)=>{A=H,this._onModuleLoaded.then(W=>{q(i(W,P,B))},W=>{H(W),this._onError("Worker failed to load "+h,W)})})}getProxyObject(){return this._lazyProxy}_request(a,h){return new Promise((g,A)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(a,h).then(g,A)},A)})}_onError(a,h){console.error(a),console.info(h)}}r.SimpleWorkerClient=S;function b(c){return c[0]==="o"&&c[1]==="n"&&C.isUpperAsciiLetter(c.charCodeAt(2))}function s(c){return/^onDynamic/.test(c)&&C.isUpperAsciiLetter(c.charCodeAt(9))}function i(c,a,h){const g=D=>function(){const P=Array.prototype.slice.call(arguments,0);return a(D,P)},A=D=>function(P){return h(D,P)},M={};for(const D of c){if(s(D)){M[D]=A(D);continue}if(b(D)){M[D]=h(D,void 0);continue}M[D]=g(D)}return M}class o{constructor(a,h){this._requestHandlerFactory=h,this._requestHandler=null,this._protocol=new L({sendMessage:(g,A)=>{a(g,A)},handleMessage:(g,A)=>this._handleMessage(g,A),handleEvent:(g,A)=>this._handleEvent(g,A)})}onmessage(a){this._protocol.handleMessage(a)}_handleMessage(a,h){if(a===l)return this.initialize(h[0],h[1],h[2],h[3]);if(!this._requestHandler||typeof this._requestHandler[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._requestHandler[a].apply(this._requestHandler,h))}catch(g){return Promise.reject(g)}}_handleEvent(a,h){if(!this._requestHandler)throw new Error("Missing requestHandler");if(s(a)){const g=this._requestHandler[a].call(this._requestHandler,h);if(typeof g!="function")throw new Error(`Missing dynamic event ${a} on request handler.`);return g}if(b(a)){const g=this._requestHandler[a];if(typeof g!="function")throw new Error(`Missing event ${a} on request handler.`);return g}throw new Error(`Malformed event name ${a}`)}initialize(a,h,g,A){this._protocol.setWorkerId(a);const P=i(A,(B,q)=>this._protocol.sendMessage(B,q),(B,q)=>this._protocol.listen(B,q));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(P),Promise.resolve((0,f.getAllMethodNames)(this._requestHandler))):(h&&(typeof h.baseUrl<"u"&&delete h.baseUrl,typeof h.paths<"u"&&typeof h.paths.vs<"u"&&delete h.paths.vs,typeof h.trustedTypesPolicy!==void 0&&delete h.trustedTypesPolicy,h.catchError=!0,p.globals.require.config(h)),new Promise((B,q)=>{(p.globals.require||k)([g],W=>{if(this._requestHandler=W.create(P),!this._requestHandler){q(new Error("No RequestHandler!"));return}B((0,f.getAllMethodNames)(this._requestHandler))},q)}))}}r.SimpleWorkerServer=o;function _(c){return new o(c,null)}r.create=_}),Y(X[51],Z([0,1,6,9]),function(k,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.TokenizationRegistry=void 0;class E{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new N.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,l){return this._map.set(C,l),this.fire([C]),(0,e.toDisposable)(()=>{this._map.get(C)===l&&(this._map.delete(C),this.fire([C]))})}registerFactory(C,l){var d;(d=this._factories.get(C))===null||d===void 0||d.dispose();const y=new f(this,C,l);return this._factories.set(C,y),(0,e.toDisposable)(()=>{const t=this._factories.get(C);!t||t!==y||(this._factories.delete(C),t.dispose())})}getOrCreate(C){return le(this,void 0,void 0,function*(){const l=this.get(C);if(l)return l;const d=this._factories.get(C);return!d||d.isResolved?null:(yield d.resolve(),this.get(C))})}get(C){return this._map.get(C)||null}isResolved(C){if(this.get(C))return!0;const d=this._factories.get(C);return!!(!d||d.isResolved)}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}r.TokenizationRegistry=E;class f extends e.Disposable{get isResolved(){return this._isResolved}constructor(C,l,d){super(),this._registry=C,this._languageId=l,this._factory=d,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return le(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return le(this,void 0,void 0,function*(){const C=yield Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,C&&!this._isDisposed&&this._register(this._registry.register(this._languageId,C))})}}}),Y(X[52],Z([0,1,24,12,2,51]),function(k,r,N,e,E,f){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.TokenizationRegistry=r.InlayHintKind=r.Command=r.FoldingRangeKind=r.SymbolKinds=r.isLocationLink=r.DocumentHighlightKind=r.SignatureHelpTriggerKind=r.InlineCompletionTriggerKind=r.CompletionItemKinds=r.EncodedTokenizationResult=r.TokenizationResult=r.Token=void 0;class p{constructor(s,i,o){this._tokenBrand=void 0,this.offset=s,this.type=i,this.language=o}toString(){return"("+this.offset+", "+this.type+")"}}r.Token=p;class C{constructor(s,i){this._tokenizationResultBrand=void 0,this.tokens=s,this.endState=i}}r.TokenizationResult=C;class l{constructor(s,i){this._encodedTokenizationResultBrand=void 0,this.tokens=s,this.endState=i}}r.EncodedTokenizationResult=l;var d;(function(b){const s=new Map;s.set(0,N.Codicon.symbolMethod),s.set(1,N.Codicon.symbolFunction),s.set(2,N.Codicon.symbolConstructor),s.set(3,N.Codicon.symbolField),s.set(4,N.Codicon.symbolVariable),s.set(5,N.Codicon.symbolClass),s.set(6,N.Codicon.symbolStruct),s.set(7,N.Codicon.symbolInterface),s.set(8,N.Codicon.symbolModule),s.set(9,N.Codicon.symbolProperty),s.set(10,N.Codicon.symbolEvent),s.set(11,N.Codicon.symbolOperator),s.set(12,N.Codicon.symbolUnit),s.set(13,N.Codicon.symbolValue),s.set(15,N.Codicon.symbolEnum),s.set(14,N.Codicon.symbolConstant),s.set(15,N.Codicon.symbolEnum),s.set(16,N.Codicon.symbolEnumMember),s.set(17,N.Codicon.symbolKeyword),s.set(27,N.Codicon.symbolSnippet),s.set(18,N.Codicon.symbolText),s.set(19,N.Codicon.symbolColor),s.set(20,N.Codicon.symbolFile),s.set(21,N.Codicon.symbolReference),s.set(22,N.Codicon.symbolCustomColor),s.set(23,N.Codicon.symbolFolder),s.set(24,N.Codicon.symbolTypeParameter),s.set(25,N.Codicon.account),s.set(26,N.Codicon.issues);function i(c){let a=s.get(c);return a||(console.info("No codicon found for CompletionItemKind "+c),a=N.Codicon.symbolProperty),a}b.toIcon=i;const o=new Map;o.set("method",0),o.set("function",1),o.set("constructor",2),o.set("field",3),o.set("variable",4),o.set("class",5),o.set("struct",6),o.set("interface",7),o.set("module",8),o.set("property",9),o.set("event",10),o.set("operator",11),o.set("unit",12),o.set("value",13),o.set("constant",14),o.set("enum",15),o.set("enum-member",16),o.set("enumMember",16),o.set("keyword",17),o.set("snippet",27),o.set("text",18),o.set("color",19),o.set("file",20),o.set("reference",21),o.set("customcolor",22),o.set("folder",23),o.set("type-parameter",24),o.set("typeParameter",24),o.set("account",25),o.set("issue",26);function _(c,a){let h=o.get(c);return typeof h>"u"&&!a&&(h=9),h}b.fromString=_})(d=r.CompletionItemKinds||(r.CompletionItemKinds={}));var y;(function(b){b[b.Automatic=0]="Automatic",b[b.Explicit=1]="Explicit"})(y=r.InlineCompletionTriggerKind||(r.InlineCompletionTriggerKind={}));var t;(function(b){b[b.Invoke=1]="Invoke",b[b.TriggerCharacter=2]="TriggerCharacter",b[b.ContentChange=3]="ContentChange"})(t=r.SignatureHelpTriggerKind||(r.SignatureHelpTriggerKind={}));var v;(function(b){b[b.Text=0]="Text",b[b.Read=1]="Read",b[b.Write=2]="Write"})(v=r.DocumentHighlightKind||(r.DocumentHighlightKind={}));function u(b){return b&&e.URI.isUri(b.uri)&&E.Range.isIRange(b.range)&&(E.Range.isIRange(b.originSelectionRange)||E.Range.isIRange(b.targetSelectionRange))}r.isLocationLink=u;var m;(function(b){const s=new Map;s.set(0,N.Codicon.symbolFile),s.set(1,N.Codicon.symbolModule),s.set(2,N.Codicon.symbolNamespace),s.set(3,N.Codicon.symbolPackage),s.set(4,N.Codicon.symbolClass),s.set(5,N.Codicon.symbolMethod),s.set(6,N.Codicon.symbolProperty),s.set(7,N.Codicon.symbolField),s.set(8,N.Codicon.symbolConstructor),s.set(9,N.Codicon.symbolEnum),s.set(10,N.Codicon.symbolInterface),s.set(11,N.Codicon.symbolFunction),s.set(12,N.Codicon.symbolVariable),s.set(13,N.Codicon.symbolConstant),s.set(14,N.Codicon.symbolString),s.set(15,N.Codicon.symbolNumber),s.set(16,N.Codicon.symbolBoolean),s.set(17,N.Codicon.symbolArray),s.set(18,N.Codicon.symbolObject),s.set(19,N.Codicon.symbolKey),s.set(20,N.Codicon.symbolNull),s.set(21,N.Codicon.symbolEnumMember),s.set(22,N.Codicon.symbolStruct),s.set(23,N.Codicon.symbolEvent),s.set(24,N.Codicon.symbolOperator),s.set(25,N.Codicon.symbolTypeParameter);function i(o){let _=s.get(o);return _||(console.info("No codicon found for SymbolKind "+o),_=N.Codicon.symbolProperty),_}b.toIcon=i})(m=r.SymbolKinds||(r.SymbolKinds={}));class w{constructor(s){this.value=s}}r.FoldingRangeKind=w,w.Comment=new w("comment"),w.Imports=new w("imports"),w.Region=new w("region");var L;(function(b){function s(i){return!i||typeof i!="object"?!1:typeof i.id=="string"&&typeof i.title=="string"}b.is=s})(L=r.Command||(r.Command={}));var S;(function(b){b[b.Type=1]="Type",b[b.Parameter=2]="Parameter"})(S=r.InlayHintKind||(r.InlayHintKind={})),r.TokenizationRegistry=new f.TokenizationRegistry}),Y(X[53],Z([0,1,50,6,27,12,3,2,31,52,46]),function(k,r,N,e,E,f,p,C,l,d,y){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.createMonacoBaseAPI=r.KeyMod=void 0;class t{static chord(m,w){return(0,E.KeyChord)(m,w)}}r.KeyMod=t,t.CtrlCmd=2048,t.Shift=1024,t.Alt=512,t.WinCtrl=256;function v(){return{editor:void 0,languages:void 0,CancellationTokenSource:N.CancellationTokenSource,Emitter:e.Emitter,KeyCode:y.KeyCode,KeyMod:t,Position:p.Position,Range:C.Range,Selection:l.Selection,SelectionDirection:y.SelectionDirection,MarkerSeverity:y.MarkerSeverity,MarkerTag:y.MarkerTag,Uri:f.URI,Token:d.Token}}r.createMonacoBaseAPI=v}),Y(X[56],Z([0,1,15,5,12,3,2,43,18,39,40,53,20,45,38,10]),function(k,r,N,e,E,f,p,C,l,d,y,t,v,u,m,w){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.EditorSimpleWorker=r.MirrorModel=void 0;class L extends C.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,o){const _=(0,l.getWordAtText)(i.column,(0,l.ensureValidWordDefinition)(o),this._lines[i.lineNumber-1],0);return _?new p.Range(i.lineNumber,_.startColumn,i.lineNumber,_.endColumn):null}words(i){const o=this._lines,_=this._wordenize.bind(this);let c=0,a="",h=0,g=[];return{*[Symbol.iterator](){for(;;)if(h<g.length){const A=a.substring(g[h].start,g[h].end);h+=1,yield A}else if(c<o.length)a=o[c],g=_(a,i),h=0,c+=1;else break}}}getLineWords(i,o){const _=this._lines[i-1],c=this._wordenize(_,o),a=[];for(const h of c)a.push({word:_.substring(h.start,h.end),startColumn:h.start+1,endColumn:h.end+1});return a}_wordenize(i,o){const _=[];let c;for(o.lastIndex=0;(c=o.exec(i))&&c[0].length!==0;)_.push({start:c.index,end:c.index+c[0].length});return _}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const o=this._eol,_=i.startLineNumber-1,c=i.endLineNumber-1,a=[];a.push(this._lines[_].substring(i.startColumn-1));for(let h=_+1;h<c;h++)a.push(this._lines[h]);return a.push(this._lines[c].substring(0,i.endColumn-1)),a.join(o)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(i),_=this._lines[o.index].length;return{lineNumber:1+o.index,column:1+Math.min(o.remainder,_)}}_validateRange(i){const o=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),_=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return o.lineNumber!==i.startLineNumber||o.column!==i.startColumn||_.lineNumber!==i.endLineNumber||_.column!==i.endColumn?{startLineNumber:o.lineNumber,startColumn:o.column,endLineNumber:_.lineNumber,endColumn:_.column}:i}_validatePosition(i){if(!f.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:o,column:_}=i,c=!1;if(o<1)o=1,_=1,c=!0;else if(o>this._lines.length)o=this._lines.length,_=this._lines[o-1].length+1,c=!0;else{const a=this._lines[o-1].length+1;_<1?(_=1,c=!0):_>a&&(_=a,c=!0)}return c?{lineNumber:o,column:_}:i}}r.MirrorModel=L;class S{constructor(i,o){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=o,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){const i=[];return Object.keys(this._models).forEach(o=>i.push(this._models[o])),i}acceptNewModel(i){this._models[i.url]=new L(E.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,o){if(!this._models[i])return;this._models[i].onEvents(o)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}computeUnicodeHighlights(i,o,_){return le(this,void 0,void 0,function*(){const c=this._getModel(i);return c?u.UnicodeTextModelHighlighter.computeUnicodeHighlights(c,o,_):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(i,o,_){return le(this,void 0,void 0,function*(){const c=this._getModel(i),a=this._getModel(o);return!c||!a?null:S.computeDiff(c,a,_)})}static computeDiff(i,o,_){const c=_.diffAlgorithm==="experimental"?m.linesDiffComputers.experimental:m.linesDiffComputers.smart,a=i.getLinesContent(),h=o.getLinesContent(),g=c.computeDiff(a,h,_);return{identical:g.changes.length>0?!1:this._modelsAreIdentical(i,o),quitEarly:g.quitEarly,changes:g.changes.map(M=>{var D;return[M.originalRange.startLineNumber,M.originalRange.endLineNumberExclusive,M.modifiedRange.startLineNumber,M.modifiedRange.endLineNumberExclusive,(D=M.innerChanges)===null||D===void 0?void 0:D.map(P=>[P.originalRange.startLineNumber,P.originalRange.startColumn,P.originalRange.endLineNumber,P.originalRange.endColumn,P.modifiedRange.startLineNumber,P.modifiedRange.startColumn,P.modifiedRange.endLineNumber,P.modifiedRange.endColumn])]})}}static _modelsAreIdentical(i,o){const _=i.getLineCount(),c=o.getLineCount();if(_!==c)return!1;for(let a=1;a<=_;a++){const h=i.getLineContent(a),g=o.getLineContent(a);if(h!==g)return!1}return!0}computeMoreMinimalEdits(i,o){return le(this,void 0,void 0,function*(){const _=this._getModel(i);if(!_)return o;const c=[];let a;o=o.slice(0).sort((h,g)=>{if(h.range&&g.range)return p.Range.compareRangesUsingStarts(h.range,g.range);const A=h.range?0:1,M=g.range?0:1;return A-M});for(let{range:h,text:g,eol:A}of o){if(typeof A=="number"&&(a=A),p.Range.isEmpty(h)&&!g)continue;const M=_.getValueInRange(h);if(g=g.replace(/\r\n|\n|\r/g,_.eol),M===g)continue;if(Math.max(g.length,M.length)>S._diffLimit){c.push({range:h,text:g});continue}const D=(0,N.stringDiff)(M,g,!1),P=_.offsetAt(p.Range.lift(h).getStartPosition());for(const B of D){const q=_.positionAt(P+B.originalStart),H=_.positionAt(P+B.originalStart+B.originalLength),W={text:g.substr(B.modifiedStart,B.modifiedLength),range:{startLineNumber:q.lineNumber,startColumn:q.column,endLineNumber:H.lineNumber,endColumn:H.column}};_.getValueInRange(W.range)!==W.text&&c.push(W)}}return typeof a=="number"&&c.push({eol:a,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),c})}computeLinks(i){return le(this,void 0,void 0,function*(){const o=this._getModel(i);return o?(0,d.computeLinks)(o):null})}textualSuggest(i,o,_,c){return le(this,void 0,void 0,function*(){const a=new v.StopWatch(!0),h=new RegExp(_,c),g=new Set;e:for(const A of i){const M=this._getModel(A);if(!!M){for(const D of M.words(h))if(!(D===o||!isNaN(Number(D)))&&(g.add(D),g.size>S._suggestionsLimit))break e}}return{words:Array.from(g),duration:a.elapsed()}})}computeWordRanges(i,o,_,c){return le(this,void 0,void 0,function*(){const a=this._getModel(i);if(!a)return Object.create(null);const h=new RegExp(_,c),g=Object.create(null);for(let A=o.startLineNumber;A<o.endLineNumber;A++){const M=a.getLineWords(A,h);for(const D of M){if(!isNaN(Number(D.word)))continue;let P=g[D.word];P||(P=[],g[D.word]=P),P.push({startLineNumber:A,startColumn:D.startColumn,endLineNumber:A,endColumn:D.endColumn})}}return g})}navigateValueSet(i,o,_,c,a){return le(this,void 0,void 0,function*(){const h=this._getModel(i);if(!h)return null;const g=new RegExp(c,a);o.startColumn===o.endColumn&&(o={startLineNumber:o.startLineNumber,startColumn:o.startColumn,endLineNumber:o.endLineNumber,endColumn:o.endColumn+1});const A=h.getValueInRange(o),M=h.getWordAtPosition({lineNumber:o.startLineNumber,column:o.startColumn},g);if(!M)return null;const D=h.getValueInRange(M);return y.BasicInplaceReplace.INSTANCE.navigateValueSet(o,A,M,D,_)})}loadForeignModule(i,o,_){const c=(g,A)=>this._host.fhr(g,A),h={host:(0,w.createProxyObject)(_,c),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(h,o),Promise.resolve((0,w.getAllMethodNames)(this._foreignModule))):new Promise((g,A)=>{k([i],M=>{this._foreignModule=M.create(h,o),g((0,w.getAllMethodNames)(this._foreignModule))},A)})}fmr(i,o){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,o))}catch(_){return Promise.reject(_)}}}r.EditorSimpleWorker=S,S._diffLimit=1e5,S._suggestionsLimit=1e4;function b(s){return new S(s,null)}r.create=b,typeof importScripts=="function"&&(e.globals.monaco=(0,t.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map